SystemOrganization addCategory: #'SqueakSource-Magritte'!
SystemOrganization addCategory: #'SqueakSource-Model'!
SystemOrganization addCategory: #'SqueakSource-View-Components'!
SystemOrganization addCategory: #'SqueakSource-View-Decorations'!
SystemOrganization addCategory: #'SqueakSource-View-Fake'!
SystemOrganization addCategory: #'SqueakSource-Server'!
SystemOrganization addCategory: #'SqueakSource-Tests'!

!Color class methodsFor: '*SqueakSource' stamp: 'lr 2/27/2004 19:46'!
activity: aFloat
	| index hue |
	index := aFloat min: 1.0 max: 0.0.
	hue := 240 - (240 * index).
	^self h: hue s: 1 v: 1! !

WAErrorHandler subclass: #SSEmailErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSEmailErrorHandler methodsFor: 'private' stamp: 'pmm 10/4/2007 20:28'!
causingContextOf: anException
	| context |
	context := anException signalerContext. 
	[ context receiver isKindOf: Exception ]
		whileTrue: [ context := context sender ].
	^context! !

!SSEmailErrorHandler methodsFor: 'accessing' stamp: 'pmm 10/4/2007 20:29'!
emailAddresses
	^ self repository superUserEmail findTokens: ','! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 10/4/2007 20:13'!
emailTextOf: anException
	^ String streamContents: [ :stream |
		| context |
		context := self causingContextOf: anException. 
		stream
			nextPutAll: 'Subject: ';
			nextPutAll: context printString;
			cr; cr.
		self printDescriptionOf: anException on: stream.
		self printWalkbackOf: context on: stream ]! !

!SSEmailErrorHandler methodsFor: 'actions' stamp: 'pmm 10/4/2007 20:33'!
handleError: anError
	| contents response |
	SeasidePlatformSupport
		deliverMailFrom: self senderAddress
		to: self emailAddresses
		text: (self emailTextOf: anError)
		usingServer: self smtpServer.
	contents := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root |
			root title: 'Internal Error' ];
		render: [ :html |
			html heading level1; with: 'Error'.
			html text: 'There has been an internal error. The system administrator has been notified.' ].
	response := WAResponse new
			internalError;
			nextPutAll: contents;
			yourself.
	WACurrentSession value returnResponse: response! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 10/4/2007 20:11'!
printDescriptionOf: anException on: aResponse
	aResponse nextPutAll: anException description; cr! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 10/4/2007 20:15'!
printExceptionDescriptionOn: aStream
	aStream nextPutAll: exception description; cr! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 8/26/2007 14:31'!
printFooterForStackFrame: aContext on: aStream
	aStream nextPutAll: '--------'! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 8/26/2007 14:31'!
printHeaderForStackFrame: aContext on: aStream
	aStream cr; nextPutAll: aContext fullPrintString	; cr
	! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 8/26/2007 14:31'!
printObject: anObject labelled: aString on: aStream
	aStream space; space; space; nextPutAll: aString.
	(20 - aString size) timesRepeat: [aStream space].
	aStream nextPutAll: (anObject printStringLimitedTo: 100).
	aStream cr.! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 10/4/2007 20:16'!
printStackFrame: aContext on: aStream
	self printHeaderForStackFrame: aContext on: aStream.
	self printObject: aContext receiver labelled: 'self' on: aStream.
		
	aContext tempNames withIndexDo: [ :name :index |
		self printObject: (aContext tempAt: index) labelled: name on: aStream].

	self printFooterForStackFrame: aContext on: aStream.! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 8/26/2007 14:31'!
printStackFrameListEndOn: aStream! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 8/26/2007 14:31'!
printStackFrameListStartOn: aStream! !

!SSEmailErrorHandler methodsFor: 'printing-email' stamp: 'pmm 10/4/2007 20:13'!
printWalkbackOf: aContext on: aStream
	| context |
	self printStackFrameListStartOn: aStream.

	context := aContext.
	[ context notNil ] whileTrue: [
		self printStackFrame: context on: aStream.
		context := context sender ].

	self printStackFrameListEndOn: aStream.! !

!SSEmailErrorHandler methodsFor: 'accessing' stamp: 'pmm 10/4/2007 20:29'!
repository
	^ SSRepository current! !

!SSEmailErrorHandler methodsFor: 'accessing' stamp: 'pmm 10/4/2007 20:29'!
senderAddress
	^ self repository title! !

!SSEmailErrorHandler methodsFor: 'accessing' stamp: 'pmm 10/4/2007 20:30'!
smtpServer
	^ self repository smtpServer! !

!MIMEDocument class methodsFor: '*SqueakSource' stamp: 'pmm 10/9/2006 00:15'!
contentTypeGZip
	^'application/x-gzip'! !

!MIMEDocument class methodsFor: '*SqueakSource' stamp: 'pmm 3/14/2006 17:45'!
contentTypeMonticello
	^'application/x-monticello'! !

!MIMEDocument class methodsFor: '*SqueakSource' stamp: 'pmm 10/19/2006 07:12'!
contentTypeRss
	"not official IANA but anybody uses it"
	^'application/rss+xml'! !

!MIMEDocument class methodsFor: '*SqueakSource' stamp: 'pmm 10/19/2006 07:14'!
contentTypeTextPlain
	^'text/plain'! !

!MIMEDocument class methodsFor: '*SqueakSource' stamp: 'pmm 10/11/2006 01:29'!
contentTypeZip
	"also found 'application/x-zip'"
	^'application/zip'! !

!TimeStamp methodsFor: '*SqueakSource' stamp: 'pmm 11/20/2006 12:36'!
printHttpFormat: aTimeZone on: aStream
	"see #printHttpFormatOn:"
	
	| d t |
	d := self date.
	t := self time.
	aStream nextPutAll: (d weekday copyFrom: 1 to: 3).
	aStream nextPutAll: ', '.
	d printOn: aStream format: #(1 2 3 $  2 1 2).
	aStream nextPut: $ .
	t print24: true on: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: aTimeZone! !

WADecoration subclass: #SSConfirmConfigurationDeleteDecoration
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Decorations'!

!SSConfirmConfigurationDeleteDecoration class methodsFor: 'instance creation' stamp: 'pmm 9/18/2007 21:47'!
configuration: aConfiguration
	^self new
		configuration: aConfiguration;
		yourself! !

!SSConfirmConfigurationDeleteDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:45'!
configuration
	^configuration! !

!SSConfirmConfigurationDeleteDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:45'!
configuration: aConfiguration
	configuration := aConfiguration! !

!SSConfirmConfigurationDeleteDecoration methodsFor: 'rendering' stamp: 'pmm 9/18/2007 21:47'!
renderContentOn: html
	html text: self configuration fileName.
	html heading level3 with: [
		html withLineBreaks: self configuration summary ].
	html text: 'Really delete ', self configuration fileName, '? There is no backup!!'.
	self renderOwnerOn: html! !

WADecoration subclass: #SSExplanationDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Decorations'!

!SSExplanationDecoration methodsFor: 'rendering' stamp: 'pmm 9/17/2007 20:51'!
renderContentOn: html
	html paragraph: 'SqueakSource allows a fine-grained control about the people being allowed to read, write and admin your project. The following settings are available:'.
	html unorderedList: [
		html listItem: 'Global specifies the default right for users not being marked as guest, developer or administrator of this project.'.
		html listItem: 'Administrators are allowed to edit the project settings, to update the rss-feed, to make releases and to open and save versions.'.
		html listItem: 'Developers are allowed to open and save versions.'.
		html listItem: 'Guests are allowed to open versions.' ].
	self renderOwnerOn: html! !

WADecoration subclass: #SSHeadingDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Decorations'!

!SSHeadingDecoration class methodsFor: 'instance creation' stamp: 'pmm 8/25/2007 14:41'!
message: aString
	^self new
		message: aString;
		yourself! !

!SSHeadingDecoration methodsFor: 'accessing' stamp: 'pmm 8/25/2007 14:40'!
message
	^message! !

!SSHeadingDecoration methodsFor: 'accessing' stamp: 'pmm 8/25/2007 14:40'!
message: aString
	message := aString! !

!SSHeadingDecoration methodsFor: 'rendering' stamp: 'pmm 8/25/2007 14:39'!
renderContentOn: html
	html heading: self message.
	self renderOwnerOn: html! !

WADecoration subclass: #SSIntroductionDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Decorations'!

!SSIntroductionDecoration methodsFor: 'rendering' stamp: 'pmm 9/17/2007 20:52'!
renderContentOn: html
	html paragraph: 'To register a new project please fill-in the following form. Note that the project name has to be unique within SqueakSource, it cannot be changed after registration and should not contain blanks or other special characters.'.
	self renderOwnerOn: html! !

WADecoration subclass: #SSVersionListingDecoration
	instanceVariableNames: 'version versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Decorations'!

!SSVersionListingDecoration class methodsFor: 'instance creation' stamp: 'pmm 9/18/2007 21:39'!
version: aVersion versions: aCollection
	^self new
		version: aVersion;
		versions: aCollection;
		yourself! !

!SSVersionListingDecoration methodsFor: 'rendering' stamp: 'pmm 9/18/2007 21:44'!
renderContentOn: html
	html text: 'Really delete all versions of package "', self version packageName, '"?'.
	html unorderedList: [
		self versions do: [ :each |
			html listItem: each fileName ] ].
	self renderOwnerOn: html! !

!SSVersionListingDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:38'!
version
	^version! !

!SSVersionListingDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:38'!
version: aVersion
	version := aVersion! !

!SSVersionListingDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:36'!
versions
	^versions! !

!SSVersionListingDecoration methodsFor: 'accessing' stamp: 'pmm 9/18/2007 21:36'!
versions: aCollection
	versions := aCollection! !

!SeasidePlatformSupport class methodsFor: '*SqueakSource' stamp: 'pmm 10/2/2007 21:46'!
deliverMailFrom: fromAddress to: recipientList text: messageText usingServer: serverName
	SMTPClient
		deliverMailFrom: fromAddress
		to: recipientList
		text: messageText
		usingServer: serverName! !

Announcement subclass: #SSCallAnnoucement
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSCallAnnoucement class methodsFor: 'instance creation' stamp: 'pmm 9/8/2007 20:06'!
component: aComponent
	^self new
		component: aComponent;
		yourself! !

!SSCallAnnoucement methodsFor: 'accessing' stamp: 'pmm 9/8/2007 20:06'!
component
	^component! !

!SSCallAnnoucement methodsFor: 'accessing' stamp: 'pmm 9/8/2007 20:06'!
component: aComponent
	component := aComponent! !

SSCallAnnoucement subclass: #SSProjectViewCallAnnoucement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

SSCallAnnoucement subclass: #SSVersionViewCallAnnoucement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

Announcement subclass: #SSSearchAnnoucement
	instanceVariableNames: 'searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSSearchAnnoucement class methodsFor: 'instance creation' stamp: 'pmm 9/8/2007 19:18'!
searchText: aString
	^self new
		searchText: aString;
		yourself! !

!SSSearchAnnoucement methodsFor: 'accessing' stamp: 'pmm 9/8/2007 19:18'!
searchText
	^searchText! !

!SSSearchAnnoucement methodsFor: 'accessing' stamp: 'pmm 9/8/2007 19:18'!
searchText: aString
	searchText := aString! !

TestCase subclass: #SSTestAccessRights
	instanceVariableNames: 'creator admin developer guest other project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Tests'!

!SSTestAccessRights methodsFor: 'setUp' stamp: 'lr 2/27/2004 19:14'!
setUp
	creator := SSMember initials: 'cr'.
	admin := SSMember initials: 'ad'.
	developer := SSMember initials: 'de'.
	guest := SSMember initials: 'gu'.
	other := SSMember initials: 'ot'.
	
	project := SSProject creator: creator.
	project accessPolicy addAdmin: admin.
	project accessPolicy addDeveloper: developer.
	project accessPolicy addGuest: guest.! !

!SSTestAccessRights methodsFor: 'running' stamp: 'al 7/29/2004 10:21'!
testAccess
	"Test default global read all access right"
	"self run: #testAccess"
	
	self assert: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy write).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy read).
	
	self assert: (project isMember: admin allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy write).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: developer allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy write).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: guest allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: guest allowedTo: SSAccessPolicy write).
	self assert: (project isMember: guest allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: other allowedTo: SSAccessPolicy write).
	self assert: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: nil allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: nil allowedTo: SSAccessPolicy write).
	self assert: (project isMember: nil allowedTo: SSAccessPolicy read).
	
	self 
		should: [ project isMember: admin allowedTo: #zork ] 
		raise: Error.
	
	project admins: (project admins copyWithout: creator).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy write).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy read).
! !

!SSTestAccessRights methodsFor: 'running' stamp: 'al 7/29/2004 10:19'!
testAccessNoAccess
	"self run: #testAccessNoAccess"
	
	project globalRight: SSAccessPolicy allowNothing.
	
	self assert: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy write).
	self assert: (project isMember: creator allowedTo: SSAccessPolicy read).
	
	self assert: (project isMember: admin allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy write).
	self assert: (project isMember: admin allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: developer allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy write).
	self assert: (project isMember: developer allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: guest allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: guest allowedTo: SSAccessPolicy write).
	self assert: (project isMember: guest allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: other allowedTo: SSAccessPolicy write).
	self deny: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: nil allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: nil allowedTo: SSAccessPolicy write).
	self deny: (project isMember: nil allowedTo: SSAccessPolicy read).
	
	self 
		should: [ project isMember: admin allowedTo: #zork ] 
		raise: Error.
	
	project admins: (project admins copyWithout: creator).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy write).
	self deny: (project isMember: creator allowedTo: SSAccessPolicy read).
! !

!SSTestAccessRights methodsFor: 'running' stamp: 'lr 2/27/2004 19:17'!
testGlobalAccess
	"self run: #testGlobalAccess"
	
	project globalRight: SSAccessPolicy allowAllRead.
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: other allowedTo: SSAccessPolicy write).
	self assert: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: nil allowedTo: SSAccessPolicy admin).
	self deny: (project isMember: nil allowedTo: SSAccessPolicy write).
	self assert: (project isMember: nil allowedTo: SSAccessPolicy read).
	
	project globalRight: SSAccessPolicy allowAllWrite.
	
	self deny: (project isMember: other allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: other allowedTo: SSAccessPolicy write).
	self assert: (project isMember: other allowedTo: SSAccessPolicy read).
	
	self deny: (project isMember: nil allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: nil allowedTo: SSAccessPolicy write).
	self assert: (project isMember: nil allowedTo: SSAccessPolicy read).
	! !

!SSTestAccessRights methodsFor: 'running' stamp: 'pmm 10/8/2007 20:27'!
testInitialization
	"self run: #testInitialization"
	
	self deny: project accessPolicy isNil.
	
	self assert: project creator = creator.
	
	self assert: (project admins includesAllOf: (Array with: creator with: admin)).
	self assert: project admins size = 2.
	
	self assert: (project developers includes: developer).
	self assert: project developers size = 1.
	
	self assert: (project guests includes: guest).
	self assert: project guests size = 1.
	
	self assert: project globalRight = SSAccessPolicy allowAllRead
	
	
	! !

!SSTestAccessRights methodsFor: 'running' stamp: 'lr 2/27/2004 19:19'!
testSuperuser
	"self run: #testSuperuser"
	
	| superuser |
	superuser := (SSMember initials: 'su') superuser: true.
	self assert: superuser isSuperUser.
	
	project globalRight: SSAccessPolicy allowAllRead.
	self assert: (project isMember: superuser allowedTo: SSAccessPolicy admin).
	self assert: (project isMember: superuser allowedTo: SSAccessPolicy read).
	self assert: (project isMember: superuser allowedTo: SSAccessPolicy write).
	
	! !

!ZipArchive methodsFor: '*squeaksource-override' stamp: 'bf 5/26/2005 17:31'!
writeEndOfCentralDirectoryTo: aStream

	aStream nextPutAll: EndOfCentralDirectorySignature asByteArray.
	aStream nextLittleEndianNumber: 2 put: 0. "diskNumber"
	aStream nextLittleEndianNumber: 2 put: 0. "diskNumberWithStartOfCentralDirectory"
	aStream nextLittleEndianNumber: 2 put: members size. "numberOfCentralDirectoriesOnThisDisk"
	aStream nextLittleEndianNumber: 2 put: members size. "numberOfCentralDirectories"
	aStream nextLittleEndianNumber: 4 put: writeEOCDOffset - writeCentralDirectoryOffset. "size of central dir"
	aStream nextLittleEndianNumber: 4 put: writeCentralDirectoryOffset. "offset of central dir"
	aStream nextLittleEndianNumber: 2 put: zipFileComment size. "zip file comment"
	zipFileComment isEmpty ifFalse: [ aStream nextPutAll: zipFileComment ].

! !

WAComponent subclass: #SSComponent
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

SSComponent subclass: #SSAddLinkComponent
	instanceVariableNames: 'tokens delimiter url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSAddLinkComponent class methodsFor: 'instance creation' stamp: 'pmm 9/17/2007 20:36'!
string: aString delimiter: aDelimiter url: aUrl
	| splitIndex tokens |
	splitIndex := aString findString: aDelimiter.
	tokens := Array
		with: (aString copyFrom: 1 to: splitIndex - 1)
		with: (aString copyFrom: splitIndex + aDelimiter size to: aString size).
	^self new
		tokens: tokens;
		delimiter: aDelimiter;
		url: aUrl;
		yourself! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:19'!
delimiter
	^delimiter! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:19'!
delimiter: aString
	delimiter := aString! !

!SSAddLinkComponent methodsFor: 'rendering' stamp: 'pmm 9/17/2007 20:19'!
renderContentOn: html
	self tokens
		do: [ :each | html text: each ]
		separatedBy: [
			html anchor
				url: self url;
				with: self delimiter ]! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:18'!
tokens
	^tokens! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:18'!
tokens: aString
	tokens := aString! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:19'!
url
	^url! !

!SSAddLinkComponent methodsFor: 'accessing' stamp: 'pmm 9/17/2007 20:19'!
url: aString
	url := aString! !

SSComponent subclass: #SSBrowser
	instanceVariableNames: 'heading'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSBrowser class methodsFor: 'instance creation' stamp: 'lr 2/8/2004 12:17'!
model: aModel heading: aString
	^(self model: aModel)
		heading: aString;
		yourself! !

!SSBrowser methodsFor: 'accessing' stamp: 'lr 2/8/2004 12:16'!
heading
	^heading! !

!SSBrowser methodsFor: 'accessing' stamp: 'pmm 8/25/2007 15:19'!
heading: aString
	heading := aString! !

!SSBrowser methodsFor: 'rendering' stamp: 'pmm 8/26/2007 14:50'!
renderButtonsOn: html
	html form: [
		html div: [
			html submitButton
				callback: [ self model switchBeInstance ];
				text: 'Instance'.
			html space.
			html submitButton
				callback: [ self model switchBeComment ];
				text: 'Comment'.
			html space.
			html submitButton
				callback: [ self model switchBeClass ];
				text: 'Class' ] ]
! !

!SSBrowser methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:31'!
renderColumn: aSelector on: html
	html form: [
		html div: [
			html select
				beSubmitOnChange;
				list: (self model perform: (aSelector , 'List') asSymbol);
				selected: (self model perform: (aSelector , 'Selection') asSymbol);
				callback: [ :item |
					self model
						perform: (aSelector , 'Selection:') asSymbol
						with: item ] ] ]! !

!SSBrowser methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:32'!
renderColumnsOn: html
	| columns |
	columns := #(category class protocol method).
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [
		html tableRow: [
			columns do: [ :each | 
				self renderColumn: each on: html ] ] ]! !

!SSBrowser methodsFor: 'rendering' stamp: 'lr 2/4/2004 19:11'!
renderContentOn: html
	self renderTitleOn: html.
	self renderColumnsOn: html.
	self renderButtonsOn: html.
	self renderTextOn: html.! !

!SSBrowser methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:19'!
renderTextOn: html
	html preformatted: [
		html code: [
			html text: self model text ] ]! !

!SSBrowser methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:19'!
renderTitleOn: html
	html heading: self heading! !

!SSComponent class methodsFor: 'instance creation' stamp: 'lr 1/26/2004 16:21'!
model: aModel
	^self new
		setModel: aModel;
		yourself! !

!SSComponent methodsFor: 'accessing' stamp: 'lr 1/26/2004 16:26'!
actions
	^Array new! !

!SSComponent methodsFor: 'actions' stamp: 'pmm 3/15/2006 21:56'!
displayProjectsWithTag: aTag
	self call: (SSProjectsWithTag model: aTag)! !

!SSComponent methodsFor: 'actions' stamp: 'pmm 9/9/2007 12:38'!
editMember
	self editMember: 'Edit Member'! !

!SSComponent methodsFor: 'actions' stamp: 'pmm 9/9/2007 12:38'!
editMember: aTitleString
	| editor |
	editor := self self session user asComponent
		addTitle: aTitleString;
		addValidatedForm;
		yourself.
	(self call: editor)
		ifNotNil: [ self session save ]! !

!SSComponent methodsFor: 'actions' stamp: 'pmm 9/17/2007 20:23'!
editSettings
	| editor |
	self session isValidUser ifFalse: [
		self call: (SSLogin model: self repository) ].
	self session isSuperUser ifFalse: [
			self informOnlyAdmin: 'Only the administrator is allowed to change repository settings!!'.
			^self answer ].
	editor := self repository asComponent
		addTitle: 'Repository Settings';
		addValidatedForm;
		yourself.
	(self call: editor)
		ifNotNil: [ self session save ]! !

!SSComponent methodsFor: 'convenience' stamp: 'pmm 9/17/2007 20:22'!
informOnlyAdmin: aString
	| message |
	message := SSAddLinkComponent
		string: aString
		delimiter: 'administrator'
		url: 'mailto:', self repository superUserEmail.
	self call: message! !

!SSComponent methodsFor: 'actions' stamp: 'lr 3/19/2004 13:31'!
loginMember
	self call: (SSLogin model: self model)! !

!SSComponent methodsFor: 'actions' stamp: 'lr 3/19/2004 13:30'!
logoutMember
	self session logout! !

!SSComponent methodsFor: 'accessing' stamp: 'lr 1/26/2004 16:20'!
model
	^model! !

!SSComponent methodsFor: 'actions' stamp: 'pmm 9/17/2007 20:23'!
registerGroup
	| editor |
	self session isValidUser ifFalse: [
		self call: (SSLogin model: self repository) ].
	self session isValidUser ifFalse: [ ^self ].
	
	self session isSuperUser ifFalse: [
		self informOnlyAdmin: 'Only the administrator can create groups!!'.
		^self ].

	editor := SSGroup new asRegisterComponent
		addTitle: 'Register Group'; 
		addValidatedForm;
		yourself.
		
	(self call: editor)
		ifNotNilDo: [ :group | 
			self model addGroup: group.
			self session save ].
! !

!SSComponent methodsFor: 'actions' stamp: 'pmm 9/9/2007 12:36'!
registerMember
	| editor |
	editor := SSMember new asRegisterComponent
		addTitle: 'Register Member'; 
		addValidatedForm;
		yourself.
	(self call: editor) ifNotNilDo: [ :member | 
		self model addMember: member.
		self session isValidUser ifFalse: [
			self session login: member ].
		self session save ].! !

!SSComponent methodsFor: 'actions' stamp: 'pmm 9/17/2007 20:52'!
registerProject
	| editor |
	self session isValidUser ifFalse: [
		self call: (SSLogin model: self repository) ].
	self session isValidUser ifTrue: [
		(self repository allowRegisterProject
			or: [self session user superuser]) ifFalse: [
				self informOnlyAdmin: 'On this server, only the administrator can create new projects!!'.
				^ self answer ].
		editor := (SSProject creator: self session user) asRegisterComponent
			addDecoration: SSExplanationDecoration new;
			addDecoration: SSIntroductionDecoration new;
			addTitle: 'Register Project';
			addValidatedForm;
			yourself.
		(self call: editor) ifNotNilDo: [ :project | 
			self model addProject: project.
			self session save.
			self call: project view ] ].! !

!SSComponent methodsFor: 'accessing' stamp: 'bf 12/15/2005 19:22'!
repository
	^self session repository! !

!SSComponent methodsFor: 'initialization' stamp: 'lr 2/4/2004 09:55'!
resetModel
	self setModel: self model.! !

!SSComponent methodsFor: 'initialization' stamp: 'lr 1/26/2004 16:21'!
setModel: aModel
	model := aModel! !

!SSComponent methodsFor: 'accessing' stamp: 'pmm 1/26/2006 12:58'!
user
	^self session user! !

SSComponent subclass: #SSFilenameRenderer
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSFilenameRenderer methodsFor: 'accessing' stamp: 'pmm 10/8/2007 07:04'!
announcer
	^announcer! !

!SSFilenameRenderer methodsFor: 'accessing' stamp: 'pmm 10/8/2007 07:04'!
announcer: anObject
	announcer := anObject! !

!SSFilenameRenderer methodsFor: 'actions' stamp: 'pmm 10/8/2007 07:02'!
callOnView: aComponent
	| announcement |
	announcement := SSVersionViewCallAnnoucement component: aComponent.
	self announcer announce: announcement! !

!SSFilenameRenderer methodsFor: 'accessing' stamp: 'pmm 10/8/2007 07:01'!
project
	self subclassResponsibility! !

!SSFilenameRenderer methodsFor: 'actions' stamp: 'pmm 10/8/2007 07:02'!
renderFilename: aString of: aVersion on: html
	aVersion isNil
		ifTrue: [ html text: aString ]
		ifFalse: [ 
			(self session isAllowed: SSAccessPolicy allowAllRead for: aVersion in: self project)
				ifFalse: [ html text: aString ]
				ifTrue: [
					html anchor
						callback: [ self callOnView: (SSVersionView project: self project version: aVersion) ];
						with: aString ] ]! !

SSFilenameRenderer subclass: #SSVersionView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

SSVersionView subclass: #SSVersionHistoryItems
	instanceVariableNames: 'infos project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSVersionHistoryItems methodsFor: 'accessing' stamp: 'pmm 10/8/2007 06:49'!
infos
	^infos! !

!SSVersionHistoryItems methodsFor: 'accessing' stamp: 'pmm 10/8/2007 06:49'!
infos: aCollectionOfVersionInfos 
	infos := aCollectionOfVersionInfos! !

!SSVersionHistoryItems methodsFor: 'accessing' stamp: 'pmm 10/8/2007 06:48'!
project
	^project! !

!SSVersionHistoryItems methodsFor: 'accessing' stamp: 'pmm 10/8/2007 06:48'!
project: aProject 
	project := aProject! !

!SSVersionHistoryItems methodsFor: 'rendering' stamp: 'pmm 10/8/2007 06:51'!
renderContentOn: html
	self infos do: [ :each |
		html paragraph: [
			html strong: [
				self renderFilename: each name
					of: (self project versionAt: each name, '.mcz')
					on: html].
			html text: ' (', each date displayString, ', ', each time displayString, ')'; break.
			each ancestors size > 1
				ifTrue: [ html strong: 'MERGED ', each ancestorString; break].
			each stepChildren isEmpty ifFalse: [
				html strong: 'BACKPORT '.
				html text: each stepChildrenString; break].
			html withLineBreaks: each message ] ]! !

!SSVersionView class methodsFor: 'instance creation' stamp: 'lr 2/4/2004 17:35'!
project: aProject version: aVersion
	^self model: (Array 
		with: aProject 
		with: aVersion)! !

!SSVersionView methodsFor: 'accessing' stamp: 'pmm 10/23/2006 12:37'!
actions
	^Array streamContents: [ :stream |
		(self project isMember: self session user allowedTo: SSAccessPolicy read for: self version) ifTrue: [ 
			stream nextPutAll: #( 'Download Package' download ).
			stream nextPutAll: #( 'Browse Code' browse ).
			stream nextPutAll: #( 'Show History' history ).
			stream nextPutAll: #( 'Copy Version' copy ) ].
		(self project isMember: self session user allowedTo: SSAccessPolicy write for: self version) ifTrue: [ 
			stream nextPutAll: #( 'Move Version' move ).
			stream nextPutAll: #( 'Delete Version' delete ).
			stream nextPutAll: #( 'Delete Package' deleteAll ) ]. ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 15:52'!
bless
	self project blessVersion: self version ifForbidden: [self blessingForbidden]! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 16:01'!
blessingForbidden
	self inform: 'You cannot bless ', self version fileName, ', because ', (self project blessedVersionForPackage: self version package) fileName , ' is not among its ancestors.  Please merge these two versions together first.'! !

!SSVersionView methodsFor: 'actions' stamp: 'lr 11/6/2006 15:05'!
browse
	| reader browser |
	[ reader := self version reader: self project.
	browser := MCSnapshotBrowser forSnapshot: reader snapshot.
	self call: (SSBrowser model: browser heading: 'Browse ' , self version fileName) ] 
		on: Error do: [ self session errorNotFound: self version fileName ]! !

!SSVersionView methodsFor: 'accessing' stamp: 'pmm 10/8/2007 07:03'!
callFromFilename: anAnnoucement
	self call: anAnnoucement component! !

!SSVersionView methodsFor: 'private' stamp: 'pmm 9/18/2007 21:43'!
confirmDelete: aCollection
	decoration := SSVersionListingDecoration
		version: self version
		versions: aCollection.
	^ self call: (WAYesOrNoDialog new
		addDecoration: decoration;
		yourself)! !

!SSVersionView methodsFor: 'actions' stamp: 'pmm 10/11/2006 01:16'!
copy
	| result |
	result := self call: (SSSimpleObjectChooser 
		model: self writableProjectsForUser
		heading: 'Select the project to copy "' , self version fileName , '" to:').
	result isNil ifTrue: [ ^ self ].
	result 
		addVersion: (SSRepository storage
			loadMonticello: self version
			from: self project)
		author: self version author.
	self session save.! !

!SSVersionView methodsFor: 'actions' stamp: 'pmm 9/17/2007 20:25'!
delete
	(self project isMember: self session user allowedTo: SSAccessPolicy admin for: self version)
		ifFalse: [^self inform: 'Only administrators can delete versions!!'].

	(self confirm: 'Really delete version "', self version fileName,'"?')
		ifTrue: [
			self project deleteVersion: self version.
			self session save.
			self answer ]! !

!SSVersionView methodsFor: 'actions' stamp: 'pmm 9/18/2007 21:42'!
deleteAll
	| all |
	(self project isMember: self session user allowedTo: SSAccessPolicy admin for: self version)
		ifFalse: [^self inform: 'Only administrators can delete versions!!'].
		
	all := self project versions select: [ :each |
		each packageName = self version packageName ].
	all := all asSortedCollection.

	(self confirmDelete: all) ifTrue: [
		all do: [:each | self project deleteVersion: each].
		self session save.
		self answer ]! !

!SSVersionView methodsFor: 'actions' stamp: 'lr 2/4/2004 18:35'!
download
	self session redirectTo: (self version url: self project).! !

!SSVersionView methodsFor: 'actions' stamp: 'pmm 10/8/2007 07:07'!
history
	self call: (SSWindow new
		title: 'Version History';
		content: (SSVersionHistoryItems new
			infos: (self version reader: self project) info withBreadthFirstAncestors;
			project: self project;
			announcer: self announcer;
			yourself))! !

!SSVersionView methodsFor: 'initialize-release' stamp: 'pmm 10/8/2007 07:04'!
initialize
	super initialize.
	announcer := Announcer new.
	announcer on: SSVersionViewCallAnnoucement send: #callFromFilename: to: self! !

!SSVersionView methodsFor: 'actions' stamp: 'pmm 9/17/2007 20:26'!
move
	| result |
	(self project isMember: self session user allowedTo: SSAccessPolicy admin for: self version)
		ifFalse: [^self inform: 'Only administrators can move versions!!'].

	result := self call: (SSSimpleObjectChooser 
		model: self writableProjectsForUser
		heading: 'Select the project to move "' , self version fileName , '" to:').
	result isNil ifTrue: [ ^ self ].
	result 
		addVersion: (SSRepository storage
			loadMonticello: self version
			from: self project)
		author: self version author.
	self project deleteVersion: self version.
	self session save.
	self answer.! !

!SSVersionView methodsFor: 'accessing' stamp: 'lr 2/4/2004 17:30'!
project
	^self model first! !

!SSVersionView methodsFor: 'actions' stamp: 'pmm 3/1/2006 21:59'!
releaseCreate
	self version beRelease.
	self session save.! !

!SSVersionView methodsFor: 'actions' stamp: 'pmm 8/26/2007 12:43'!
releaseCreateSM
	| result |
	result := self call: (SSRegisterSqueakMap model: self model).
	result isNil ifFalse: [
		result := self version registerSqueakMapCurl: self project.
		result isNil
			ifTrue: [ self version beRelease. self session save ]
			ifFalse: [
				self session returnResponse: (WAResponse
					document: result contents 
					mimeType: 'text/html') ] ]! !

!SSVersionView methodsFor: 'actions' stamp: 'pmm 3/1/2006 22:00'!
releaseRemove
	self version noRelease.
	self session save.! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 16:59'!
renderAuthorOn: html
	html tableRow: [
		html tableData
			class: 'label';
			with: 'Author:'.
		html tableData: [
			html anchor
				callback: [ self call: self version author view ];
				with: self version authorString ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:00'!
renderBlessingInfoOn: html
	| blessed |
	blessed := self project blessedVersionForPackage: self version package.
	blessed ifNotNil: [
		blessed = self version
			ifTrue: [ html strong: 'This is the currently blessed version for package ', blessed package printString ]
			ifFalse: [ html string: 'The currently blessed version of package ', blessed package printString, ' is ', blessed fileName ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 14:51'!
renderButtonsOn: html
	html break.
	html form: [
		html div: [
			(self project isMember: self session user allowedTo: SSAccessPolicy admin)
				ifTrue: [
					self version isRelease 
						ifFalse: [
							html submitButton
								callback: [ self releaseCreate ];
								text: 'Create Release' ]
						ifTrue: [
							html submitButton
								callback: [ self releaseRemove ];
								text: 'Remove Release' ].
					html space.
					html submitButton
						callback: [
							self session redirectTo: 'http://bugs.squeak.org/view.php?id=2753'.
							"self releaseCreateSM" ];
						text: 'SqueakMap Release' ].
			(self project isMember: self session user allowedTo: SSAccessPolicy bless)
				ifTrue: [
					html space.
					(self project isVersionBlessed: self version)
						ifFalse: [
							html submitButton
								callback: [ self bless ];
								text: 'Bless' ]
						ifTrue: [
							html submitButton
								callback: [ self unbless ];
								text: 'Remove Blessing' ] ] ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:01'!
renderContentOn: html
	html heading: self version fileName , (self version isRelease
		ifTrue: [ ' (Release)' ]
		ifFalse: [ String new ]).
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [
			self renderFilenameOn: html.
			self renderAuthorOn: html.
			self renderTimestampOn: html.
			self renderUUIDOn: html.	
			self
				renderPackageList: self version ancestors 
				label: 'Ancestors:' on: html.
			self
				renderPackageList: self version dependencies 
				label: 'Dependencies:' on: html.
			self renderReleaseOn: html.
			self renderMessageOn: html.
			self renderStatisticsOn: html ].
	self renderButtonsOn: html.
	self renderBlessingInfoOn: html.! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:02'!
renderFilenameOn: html
	html tableRow: [
		html tableData
			class: 'mediumLabel';
			with: 'Filename:'.
		html tableData: [
			html anchor
				url: (self version url: self project);
				with: self version fileName ] ]
! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:04'!
renderMessageOn: html
	html tableRow: [
		html tableData
			class: 'label';
			with: 'Message:'.
		html tableData: [
			html withLineBreaks: self version message ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:04'!
renderPackageList: aCollection label: aString on: html
	| filename version |
	aCollection isEmpty 
		ifTrue: [ ^self ].
	html tableRow: [
		html tableData
			class: 'label';
			with: aString.
		html tableData: [
			aCollection 
				do: [ :each |
					filename := each name , '.mcz'.
					version := self project versionAt: filename.
					self renderFilename: filename of: version on: html ]
				separatedBy: [ html text: ', ' ] ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:05'!
renderReleaseOn: html
	self version isRelease ifTrue: [
		html tableRow: [
			html tableData
				class: 'label';
				with: 'Release:'.
			html tableData: 'This is a release that can be read by anybody.' ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 9/11/2007 22:15'!
renderStatisticsOn: html
	html tableRow: [
		html tableData
			class: 'label';
			with:  'Downloads:'.
		html tableData: [
			self version downloadStatistics isEmpty
				ifTrue: [ html text: '0' ]
				ifFalse: [
					self version downloadStatistics associationsDo: [ :assoc |
						html text: assoc key displayString, ': '.
						html text: assoc value.
						html break ] ] ] ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:07'!
renderTimestampOn: html
	html tableRow: [
		html tableData
			class: 'label';
			with: 'Timestamp:'.
		html tableData: self version timestamp ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:07'!
renderUUIDOn: html
	html tableRow: [
		html tableData
			class: 'label';
			with: 'UUID:'.
		html tableData: self version id ]! !

!SSVersionView methodsFor: 'rendering' stamp: 'avi 9/23/2004 15:49'!
unbless
	self project unblessVersion: self version! !

!SSVersionView methodsFor: 'accessing' stamp: 'lr 2/4/2004 17:30'!
version
	^self model second! !

!SSVersionView methodsFor: 'accessing' stamp: 'pmm 10/11/2006 01:15'!
writableProjectsForUser
	| user |
	user := self session user.
	^(self repository visibleProjectsSelect: [ :each |
		self project ~= each
			and: [ each isMember: user allowedTo: SSAccessPolicy write ] ])
				asSortedCollection: [ :x :y | x name <= y name ]! !

SSComponent subclass: #SSFilteringComponent
	instanceVariableNames: 'report searchText announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSFilteringComponent class methodsFor: 'instance creation' stamp: 'pmm 9/8/2007 19:18'!
model: anObject announcer: anAnnouncer searchTerm: aString
	^(self model: anObject)
		setAnnouncer: anAnnouncer;
		searchText: aString;
		resetReport;
		yourself! !

!SSFilteringComponent methodsFor: 'private' stamp: 'pmm 9/8/2007 20:16'!
addColumnsToReport
	report addColumn: (MAColumn new
		selector: #fileName;
		title: 'Filename';
		format: [ :each :html | 
			html anchor
				callback: [ self callOnParent: (SSVersionView project: self model version: each) ];
				with: each fileName ];
		yourself).
	report addColumn: (MAColumn new
		selector: #author;
		title: 'Author';
		format: [ :each :html |
			| author |
			author := each author.
			author isNil
				ifTrue: [ html text: 'unknown' ]
				ifFalse: [ 
					html anchor
						callback: [ self callOnParent: author view ];
						with: author name ] ];
		yourself).
	report addColumn: (MAColumn new
		selector: #timestamp;
		title: 'Timestamp';
		format: [ :each :html |
			| timestamp |
			timestamp := each timestamp.
			html render: (timestamp date yyyymmdd , ' ' , timestamp time print24) ];
		sorter: [ :a :b | a timestamp > b timestamp ];
		yourself).
	report addColumn: (MAColumn new
		selector: #yourself ;
		title: 'Actions';
		format: [ :each :html | 
			html anchor
				callback: [ self callOnParent: (SSVersionView project: self model version: each) ];
				with: 'details'.
			html space.
			html anchor
				url: (each url: self model);
				with: 'download' ];
		sorter: nil;
		yourself)! !

!SSFilteringComponent methodsFor: 'accessing' stamp: 'pmm 9/8/2007 18:43'!
announcer
	^announcer! !

!SSFilteringComponent methodsFor: 'private' stamp: 'pmm 9/18/2007 19:55'!
buildReport
	report := MAReport new
		rowPeriod: 1;
		batchSize: self repository batchSize;
		yourself.
	self addColumnsToReport! !

!SSFilteringComponent methodsFor: 'actions' stamp: 'pmm 10/8/2007 06:58'!
callOnParent: aComponent
	| announcement |
	announcement := SSProjectViewCallAnnoucement component: aComponent.
	self announcer announce: announcement! !

!SSFilteringComponent methodsFor: 'accessing' stamp: 'pmm 9/8/2007 08:45'!
children
	^Array with: report! !

!SSFilteringComponent methodsFor: 'private' stamp: 'pmm 9/8/2007 08:42'!
filter: someVersions
	searchText isEmptyOrNil ifTrue: [
		^someVersions].
	^(searchText includes: $*)
		ifTrue: [
			someVersions select: [ :each |
				each stringsSatisfy: [ :str |
					str notNil and: [ searchText match: str ] ] ] ]
		ifFalse: [
			someVersions select: [ :each |
				each stringsSatisfy: [ :str |
					str notNil and: [ str includesSubstring: searchText
						caseSensitive: false ] ] ] ]
! !

!SSFilteringComponent methodsFor: 'initialize-release' stamp: 'pmm 9/8/2007 19:42'!
initialize
	super initialize.
	self buildReport! !

!SSFilteringComponent methodsFor: 'rendering' stamp: 'pmm 9/8/2007 08:51'!
renderSearchOn: html
	html form: [
		html div: [
			html textInput
				on: #searchText of: self.
			html space.
			html submitButton
				callback: [ self search ];
				text: 'Search' ] ]! !

!SSFilteringComponent methodsFor: 'private' stamp: 'pmm 9/8/2007 19:20'!
resetReport
	report rows: (self filter: self rows)! !

!SSFilteringComponent methodsFor: 'private' stamp: 'pmm 9/8/2007 08:44'!
rows
	self subclassResponsibility! !

!SSFilteringComponent methodsFor: 'actions' stamp: 'pmm 9/8/2007 18:45'!
search
	| announcement |
	announcement := SSSearchAnnoucement searchText: self searchText.
	self announcer announce: announcement! !

!SSFilteringComponent methodsFor: 'actions' stamp: 'pmm 9/8/2007 19:20'!
search: anAnnoucement
	searchText := anAnnoucement searchText.
	self resetReport! !

!SSFilteringComponent methodsFor: 'accessing' stamp: 'pmm 9/8/2007 08:51'!
searchText
	^searchText! !

!SSFilteringComponent methodsFor: 'accessing' stamp: 'pmm 9/8/2007 08:51'!
searchText: aString
	searchText := aString! !

!SSFilteringComponent methodsFor: 'initialize-release' stamp: 'pmm 9/8/2007 18:46'!
setAnnouncer: anAnnouncer
	announcer := anAnnouncer.
	announcer on: SSSearchAnnoucement send: #search: to: self! !

SSFilteringComponent subclass: #SSProjectBlessedVersions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSProjectBlessedVersions methodsFor: 'private' stamp: 'pmm 9/8/2007 20:13'!
addColumnsToReport
	report addColumn: (MAColumn new
		selector: #package;
		title: 'Package';
		yourself).
	super addColumnsToReport! !

!SSProjectBlessedVersions methodsFor: 'rendering' stamp: 'pmm 9/8/2007 08:55'!
renderContentOn: html
	html break.
	self renderSearchOn: html.
	html break.
	report rows isEmpty
		ifFalse: [ html render: report ]
		ifTrue: [ html emphasis: (String streamContents: [:stream |
			stream nextPutAll: 'No '.
			searchText isEmptyOrNil ifFalse: [
				stream nextPutAll: 'matching ' ].
			self session isValidUser ifFalse: [
				stream nextPutAll: 'public ' ].
			stream nextPutAll: 'blessed versions available'])]! !

!SSProjectBlessedVersions methodsFor: 'private' stamp: 'pmm 9/8/2007 18:56'!
rows
	^ self model allBlessedVersions
		select: [ :each |
			each notNil
				and: [
					self model 
						isMember: self session user 
						allowedTo: SSAccessPolicy read
						for: each ] ]! !

SSFilteringComponent subclass: #SSProjectLatestVersions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSProjectLatestVersions methodsFor: 'rendering' stamp: 'pmm 9/8/2007 18:27'!
renderContentOn: html
	html break.
	self renderSearchOn: html.
	html break.
	report rows isEmpty
		ifFalse: [ html render: report ]
		ifTrue: [
			html emphasis: (String streamContents: [:stream |
				stream nextPutAll: 'No '.
				searchText isEmptyOrNil ifFalse: [
					stream nextPutAll: 'matching ' ].
				self session isValidUser ifFalse: [
					stream nextPutAll: 'public ' ].
				stream nextPutAll: 'versions available'])]! !

!SSProjectLatestVersions methodsFor: 'private' stamp: 'pmm 9/8/2007 18:56'!
rows
	^self model latestVersions select: [ :each |
		self model 
			isMember: self session user 
			allowedTo: SSAccessPolicy read
			for: each ]! !

SSFilteringComponent subclass: #SSProjectReleases
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSProjectReleases methodsFor: 'rendering' stamp: 'pmm 9/8/2007 08:52'!
renderContentOn: html
	html break.
	self renderSearchOn: html.
	html break.
	report rows isEmpty
		ifFalse: [ html render: report ]
		ifTrue: [ html emphasis: 'No ',
			(searchText isEmptyOrNil
				ifTrue: [ '' ]
				ifFalse: [ 'matching ' ]),
			'releases available' ]! !

!SSProjectReleases methodsFor: 'private' stamp: 'pmm 9/8/2007 18:54'!
rows
	^self model releasesSorted! !

SSFilteringComponent subclass: #SSProjectVersions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSProjectVersions methodsFor: 'rendering' stamp: 'pmm 9/8/2007 18:25'!
renderContentOn: html
	html break.
	self renderSearchOn: html.
	html break.
	report rows isEmpty
		ifFalse: [ html render: report ]
		ifTrue: [
			html emphasis: (String streamContents: [ :stream |
				stream nextPutAll: 'No '.
				searchText isEmptyOrNil ifFalse: [
					stream nextPutAll: 'matching ' ].
				self session isValidUser ifFalse: [
					stream nextPutAll: 'public ' ].
				stream nextPutAll: 'versions available']) ]! !

!SSProjectVersions methodsFor: 'private' stamp: 'pmm 9/8/2007 18:54'!
rows
	^self model versionsSorted select: [ :each |
		each isRelease not and: [
			self model 
				isMember: self session user 
				allowedTo: SSAccessPolicy read
				for: each ] ]! !

SSComponent subclass: #SSGenericFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

SSGenericFrame subclass: #SSFrame
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSFrame class methodsFor: 'testing' stamp: 'pmm 8/29/2007 10:28'!
canBeRoot
	^true! !

!SSFrame methodsFor: 'accessing' stamp: 'pmm 8/29/2007 13:35'!
actions
	| controller |
	controller := self component activeComponent.
	^Array streamContents: [ :stream |
		self isHome ifTrue: [ 
			stream nextPutAll: #( 
				'RSS feed' '/feed.rss'
				'Register Member' #registerMember
				'Register Group' #registerGroup
				'Register Project' #registerProject ).
			self session isSuperUser ifTrue: [
				stream nextPutAll: #('Edit Settings' #editSettings)]].
		(controller respondsTo: #actions)
			ifTrue: [ stream nextPutAll: controller actions ] ]! !

!SSFrame methodsFor: 'actions' stamp: 'pmm 10/9/2007 07:04'!
back
	| parent |
	component delegations isEmpty ifTrue: [ ^self ].
	parent := component.
	[ parent := parent delegations first delegate ]
		doWhileFalse: [ parent delegations isEmpty ].
	parent answer! !

!SSFrame methodsFor: 'private' stamp: 'pmm 8/29/2007 14:03'!
call: aComponent
	^self component
		home;
		call: aComponent! !

!SSFrame methodsFor: 'accessing' stamp: 'pmm 8/30/2007 09:17'!
children
	^Array with: component! !

!SSFrame methodsFor: 'accessing' stamp: 'pmm 8/29/2007 13:36'!
component
	^component activeComponent! !

!SSFrame methodsFor: 'configuration' stamp: 'bf 5/24/2005 15:20'!
groupsClass
	^SSGroups! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:31'!
helpClass
	^SSHelp! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 1/26/2004 17:07'!
homeClass
	^SSHome! !

!SSFrame methodsFor: 'configuration' stamp: 'pmm 3/15/2006 21:58'!
homeClasses
	^Array streamContents: [ :stream |
		stream
			nextPut: self homeClass;
			nextPut: self projectsClass;
			nextPut: self tagsClass;
			nextPut: self membersClass;
			nextPut: self groupsClass;
			nextPut: self helpClass;
			nextPut: self loginClass ]
		! !

!SSFrame methodsFor: 'initialization' stamp: 'pmm 9/5/2007 22:34'!
initialRequest: aRequest
	| accessPath |
	super initialRequest: aRequest.
	accessPath := self session relativePathFor: aRequest.
	accessPath isEmpty ifFalse: [
		(self session projectNamed: (accessPath first copyUpToLast: $.))
			ifNotNilDo: [:project | self setComponent: project view ] ].! !

!SSFrame methodsFor: 'initialization' stamp: 'pmm 8/26/2007 11:08'!
initialize
	super initialize.
	component := self homeClass 
		model: self model! !

!SSFrame methodsFor: 'testing' stamp: 'lr 3/15/2004 18:34'!
isHome
	^self homeClasses includes: self component class ! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/25/2005 11:32'!
login
	self call: (self loginClass model: self model).
	self component resetModel.! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:09'!
loginClass
	^SSLogin! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/25/2005 11:32'!
logout
	self session logout.
	self component resetModel.! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:28'!
membersClass
	^SSMembers! !

!SSFrame methodsFor: 'accessing' stamp: 'pmm 8/26/2007 12:27'!
model
	^self repository! !

!SSFrame methodsFor: 'private' stamp: 'lr 3/15/2004 18:30'!
performAction: aSymbol
	self component 
		perform: aSymbol.! !

!SSFrame methodsFor: 'private' stamp: 'pmm 8/27/2007 11:01'!
projectNamed: aString

	^self projectNamed: aString ifNotAllowed: [ nil ]! !

!SSFrame methodsFor: 'private' stamp: 'pmm 8/27/2007 11:01'!
projectNamed: aString ifNotAllowed: aBlock
	| project |
	project := self repository projectAt: aString ifAbsent: [ ^nil ].
	^(self repository isVisible: project)
			ifTrue: [ project ]
			ifFalse: [ aBlock value: project ]! !

!SSFrame methodsFor: 'configuration' stamp: 'lr 3/15/2004 18:28'!
projectsClass
	^SSProjects! !

!SSFrame methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:26'!
renderActionsOn: html
	self renderMenu: 'Actions' do: [
		self actions pairsDo: [ :description :selector |
			self renderMenuItem: [
				selector isSymbol 
					ifTrue: [
						html anchor
							callback: [ self performAction: selector ];
							with: description ]
					ifFalse: [
						html anchor
							url: selector;
							with: description ] ] on: html ].
		self isHome ifFalse: [
			self renderMenuItem: [
				html anchor
					callback: [ self back ];
					with: 'Back' ] on: html ] ] on: html! !

!SSFrame methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:28'!
renderAuthenticationOn: html
	self session isValidUser 
		ifTrue: [
			self renderMenu: self session user do: [
				self
					renderMenuItem: [
						html anchor
							callback: [ self logout ];
							with: 'Logout' ]
					on: html.
				self 
					renderMenuItem: [
						html anchor
							callback: [ self editMember ];
							with: 'Edit Account' ] 
					on: html.
				html break.
				self session user projects asSortedCollection do: [ :each |
					self 
						renderMenuItem: [
							html anchor
								callback: [ self showProject: each ];
								with: each title ] 
						on: html ] ] on: html ]
		ifFalse: [
			self renderMenu: 'Authentication' do: [
				self 
					renderMenuItem: [
						html anchor
							callback: [ self login ];
							with: 'Login' ] 
					on: html ] on: html ]! !

!SSFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 23:00'!
renderContentsOn: html
	html render: component.! !

!SSFrame methodsFor: 'rendering' stamp: 'lr 1/28/2004 22:55'!
renderHeadingOn: html
	html title: self model title.
	html text: self model title.! !

!SSFrame methodsFor: 'rendering' stamp: 'lr 3/15/2004 18:47'!
renderNavigationOn: html
	self renderActionsOn: html.
	self renderAuthenticationOn: html.! !

!SSFrame methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:29'!
renderToolbarOn: html
	html anchor
		callback: [ self showHome ];
		with: 'Home'.
	html anchor
		callback: [ self showProjects ];
		with: 'Projects'.
	html anchor
		callback: [ self showTags ];
		with: 'Tags'.
	html anchor
		callback: [ self showMembers ];
		with: 'Members'.
	html anchor
		callback: [ self showGroups ];
		with: 'Groups'.
	html anchor
		callback: [ self showHelp ];
		with: 'Help'.! !

!SSFrame methodsFor: 'rendering' stamp: 'pmm 2/9/2006 20:28'!
renderTopOn: html
	html text: 'up to date'.
	html space.! !

!SSFrame methodsFor: 'initialization' stamp: 'pmm 8/26/2007 17:25'!
setComponent: aComponent
	component := aComponent! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/24/2005 15:19'!
showGroups
	self call: (self groupsClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:30'!
showHelp
	self call: (self helpClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:30'!
showHome
	self call: (self homeClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:29'!
showMembers
	self call: (self membersClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'bf 5/24/2005 18:12'!
showProject: aProject
	self call: aProject view! !

!SSFrame methodsFor: 'actions' stamp: 'lr 3/15/2004 18:29'!
showProjects
	self call: (self projectsClass model: self model)! !

!SSFrame methodsFor: 'actions' stamp: 'pmm 3/15/2006 21:59'!
showTags
	self call: (self tagsClass model: self model)! !

!SSFrame methodsFor: 'configuration' stamp: 'pmm 3/15/2006 22:00'!
tagsClass
	^SSTags! !

!SSFrame methodsFor: 'rendering' stamp: 'pmm 9/15/2007 09:30'!
updateRoot: html
	super updateRoot: html.
	"google sitemaps verification"
	html meta
		name: 'verify-v1';
		content: 'aYJ5chz2x0fRQuxMBS4pW+Ikb7hgtaBsysf18Fbt3q8='.
	html title: self model title
	! !

!SSGenericFrame methodsFor: 'accessing' stamp: 'pmm 1/23/2006 22:38'!
faviconUrl
	^self repository rootUrl , self repository faviconFilename! !

!SSGenericFrame methodsFor: 'accessing' stamp: 'pmm 9/5/2007 22:30'!
feedUrl
	^self session baseUrl
		addToPath: 'feed.rss';
		yourself! !

!SSGenericFrame methodsFor: 'accessing' stamp: 'pmm 8/30/2007 10:55'!
feedValidationUrl
	^WAUrl new
		hostname: 'validator.w3.org';
		addToPath: 'feed/check.cgi';
		addParameter: 'url' value: self feedUrl;
		yourself! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'pmm 8/26/2007 11:47'!
renderAnalyticsOn: html
	| account |
	account := self repository googleAnalyticsAccount.
	account isEmptyOrNil ifTrue: [ ^self ].
	
	html script url: 'http://www.google-analytics.com/urchin.js'.
	
	html script
		with: 
'_uacct = "', account, '";
urchinTracker();'! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'pmm 8/29/2007 13:38'!
renderBottomOn: html
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		style: 'width: 100%';
		with: [
			html tableRow: [
				html tableData
					align: 'left';
					with: [
						html anchor
							url: 'http://validator.w3.org/check/referer';
							with: 'XHTML'.
						html text: ' | '.
						html anchor
							url: 'http://jigsaw.w3.org/css-validator/check/referer';
							with: 'CSS'.
						html text: ' | '.
						html anchor
							url: self feedValidationUrl;
							with: 'RSS' ].
				html tableData
					align: 'right';
					with: Date today ] ]
! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'pmm 8/26/2007 11:48'!
renderContainerOn: html
	html div
		id: 'top';
		with: [ self renderTopOn: html ].
	html div
		id: 'sstoolbar';
		with: [ self renderToolbarOn: html ].
	html div
		id: 'page';
		with: [ self renderPageOn: html ].
	html div
		id: 'bottom';
		with: [ self renderBottomOn: html ]! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'pmm 8/26/2007 11:49'!
renderContentOn: html
	html div
		id: 'container';
		with: [ self renderContainerOn: html ].
	self renderAnalyticsOn: html! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 22:46'!
renderContentsOn: html! !

!SSGenericFrame methodsFor: 'rendering-tools' stamp: 'pmm 8/26/2007 11:50'!
renderMenu: aString do: aBlock on: html
	html div
		class: 'title';
		with: aString.
	html div
		class: 'list';
		with: aBlock! !

!SSGenericFrame methodsFor: 'rendering-tools' stamp: 'pmm 8/26/2007 11:50'!
renderMenuItem: aBlock on: html
	html div
		class: 'item';
		with: aBlock! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 22:46'!
renderNavigationOn: html! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'pmm 8/26/2007 11:49'!
renderPageOn: html
	html div
		id: 'navigation';
		with: [ self renderNavigationOn: html ].
	html div
		id: 'contents';
		with: [ self renderContentsOn: html ]! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/12/2004 22:45'!
renderToolbarOn: html! !

!SSGenericFrame methodsFor: 'rendering' stamp: 'lr 3/15/2004 15:02'!
renderTopOn: html! !

!SSGenericFrame methodsFor: 'accessing' stamp: 'pmm 1/20/2006 09:46'!
repository
	^SSRepository current! !

!SSGenericFrame methodsFor: 'updating' stamp: 'pmm 9/15/2007 09:30'!
updateRoot: html
	super updateRoot: html.
	html link beAlternate; beRss; title: self repository title; url: self feedUrl.
	html link beShortcutIcon; url: self faviconUrl! !

SSComponent subclass: #SSGroupView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSGroupView methodsFor: 'accessing' stamp: 'bf 5/24/2005 18:16'!
actions
	^#( 'Edit' edit ) ,
		super actions! !

!SSGroupView methodsFor: 'actions' stamp: 'pmm 9/17/2007 20:24'!
edit
	| component |
	self session isValidUser ifFalse: [
		self call: (SSLogin model: self repository) ].
	self session isValidUser ifFalse: [^self].
	
	self session isSuperUser ifFalse: [
		self informOnlyAdmin: 'Only the administrator can edit groups!!'.
		^self ].

	component := self model asComponent
		addTitle: 'Edit Group'; 
		addValidatedForm;
		yourself.
	(self call: component)
		ifNotNil: [ self session save ]
! !

!SSGroupView methodsFor: 'rendering' stamp: 'bf 5/24/2005 16:27'!
renderContentOn: html
	self renderTitleOn: html.
	self renderTableOn: html.! !

!SSGroupView methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:38'!
renderList: aCollection label: aString on: html
	aCollection isEmpty ifFalse: [
		html tableRow: [
			html tableData: aString.
			html tableData: [
				aCollection
					do: [ :each | 
						html anchor
							callback: [ self call: each view ];
							with: each fullname ]
					separatedBy: [ html text: ', ' ] ] ] ].! !

!SSGroupView methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:37'!
renderTableOn: html
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [
			self renderList: self model members label: 'Members:' on: html ]! !

!SSGroupView methodsFor: 'rendering' stamp: 'bf 5/24/2005 16:26'!
renderTitleOn: html
	html heading: self model fullname , ' (' , self model id , ')'! !

SSComponent subclass: #SSGroups
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSGroups methodsFor: 'accessing' stamp: 'pmm 8/25/2007 15:45'!
children
	^Array with: report! !

!SSGroups methodsFor: 'actions' stamp: 'bf 5/24/2005 15:21'!
registerGroup
	super registerGroup.
	self resetModel.

! !

!SSGroups methodsFor: 'rendering' stamp: 'pmm 7/10/2005 10:49'!
renderContentOn: html
	html heading: 'Groups'.
	self renderGroupsOn: html.! !

!SSGroups methodsFor: 'rendering' stamp: 'pmm 1/20/2006 15:28'!
renderGroupsOn: html
	html break.
	self report rows isEmpty
		ifFalse: [ html render: self report ]
		ifTrue: [
			html emphasis: 'No groups available' ]! !

!SSGroups methodsFor: 'accessing' stamp: 'bf 12/15/2005 23:53'!
report
	^report! !

!SSGroups methodsFor: 'accessing' stamp: 'pmm 9/18/2007 19:55'!
setModel: aModel
	| sort |
	super setModel: aModel.
	report := MAReport new
		rowPeriod: 1;
		batchSize: self repository batchSize;
		rows: aModel groups;
		addColumn: (sort := (MAColumn new
				selector: #fullname ;
				title: 'Name';
				format: [ :each :html | 
					html anchor
						callback: [ self call: each view ];
						with: each fullname ];
				sorter: [ :a :b |
					a fullname caseInsensitiveLessOrEqual: b fullname ];
				yourself));
		addColumn: (MAColumn new
				selector: #id;
				title: 'id';
				yourself);
		addColumn: (MAColumn new
				selector: #members;
				title: 'Members';
				format: [ :item :html | 
					item members
						do: [ :each | html anchor
							callback: [ self call: each view ];
							with: each initials ]
						separatedBy: [ html text: ', ' ] ];
				sorter: nil;
				yourself);
		sortColumn: sort;
		yourself.! !

SSComponent subclass: #SSHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSHelp methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:50'!
renderContentOn: html
	self renderHeadingOn: html.
	self renderWhatIsOn: html.
	self renderHowToSqueakOn: html.
	self renderHowToProjectOn: html.! !

!SSHelp methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:50'!
renderHeadingOn: html
	html heading: 'Help'! !

!SSHelp methodsFor: 'rendering' stamp: 'pmm 9/9/2007 12:00'!
renderHowToProjectOn: html
	html heading level2; with: 'How to create a project?'.
	self repository allowRegisterProject
		ifTrue: [
			html paragraph: [
				html text: 'To create a new project you need to have a SqueakSource account ('.
				html anchor
					callback: [ self registerMember ];
					with: 'Register member'.
				html text: ') and you need to be logged-in ('.
				html anchor
					callback: [ self loginMember ];
					with: 'Login'.
				html text: '). Then you are able to create any number of new projects ('.
				html anchor
					callback: [ self registerProject ];
					with: 'Register Project'.
				html text: '), by filling-in the project form. '.
				html text: 'You will find some additional information concerning this step at the top of the project-registration dialog.' ]]
		ifFalse: [
			html paragraph: [
				html text: 'On this server, only the  '.
				html anchor
					url: 'mailto:', self repository superUserEmail;
					with: 'administrator'.
				html text: ' can create new projects ('.
				html anchor
					callback: [ self registerProject ];
					with: 'Register Project'.
				html text: ').' ] ].
	html paragraph: [
		html text: 'The newly created project is now shown in the list with all the projects you are involved in below your name on the left. The following tabs are available in the project-view:' ].
	html unorderedList: [
		html listItem: 'Overview: Project''s description, members, registration template and some statistics. Use the registration template to create a new repository in your monticello client.'.
		html listItem: [ 
			html text: 'Wiki: Each project has its own wiki that can be modified by developers and admins. The syntax is similar to the one of SmallWiki:'.
			html unorderedList: [
				html listItem: 'Paragraph: A carriage return becomes a new paragraph.'.
				html listItem: 'Headers: A line starting with one or more <code>!!</code> becomes a header.'.
				html listItem: 'Horizontal Rule: A line starting with <code>_</code> becomes a horizotal rule.'.
				html listItem: 'Lists: A block of lines starting with <code>#</code> or <code>-</code> becomes a ordered-/unordered list.'.
				html listItem: 'Preformatted: A block of lines starting with <code>=</code> becomes preformatted.'.
				html listItem: 'Links: Text beteween stars becomes an internal (e.g. <code>*My Page*</code>) or an external reference (e.g <code>*http://www.google.com*</code>).'.
				html listItem: 'XHTML: Use any valid XHTML tags withing your code.' ] ].
		html listItem: 'RSS-Feed: Administrators are able to add custom messages to the project-feed by clicking on ''Add Message''. They will show up on this tab-panel and in the rss-feed of the project.'.
		html listItem: 'Releases: Releases are committed versions that have been released. They are public and readable by everybody. To remove a release select ''details->Remove Release''. Releases do show up automatically in the rss-feed of the project.'.
		html listItem: 'Versions: This list shows all commits that have not been tagged as releases. To create a release or create a SqueakMap release, click on ''details/release''. This view shows details about the versions and let you make a release or browse the code in your web-browser.' ]! !

!SSHelp methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:07'!
renderHowToSqueakOn: html.
	html heading level2; with: 'How to use SqueakSource?'.
	html paragraph: [
		html text: 'To use SqueakSource you have to create a project, what is described below, and to install the '.
		html anchor
			url: 'http://wiki.squeak.org/squeak/1287';
			with: 'Monticello'.
		html text: ' client into your Squeak image:' ].
	html orderedList: [
		html listItem: 'Open the ''Package Loader'' from the world-menu.'.
		html listItem: 'Load the most recent versions of ''MCInstaller'' and ''Monticello''.'.
		html listItem: 'Open the ''Monticello Browser'' from the world-menu.'.
		html listItem: 'Click ''+Repository'' and choose ''HTTP'' to add the SqueakSource repository to the ''Monticello Browser''.'.
		html listItem: 'Copy and paste the registration-string from the overview-tab of your project into the dialog and add your password manually.'.
		html listItem: 'Now you should be able to open and save versions of your project into that repository.' ]! !

!SSHelp methodsFor: 'rendering' stamp: 'pmm 8/25/2007 15:57'!
renderWhatIsOn: html.
	html heading level2; with: 'What is SqueakSource?'. 
	html paragraph: 'SqueakSource is a monticello code repository server which hosts your projects. You  connect to it with the monticello client to commit and load code. SqueakSource also implements a web-frontend (which you are looking at) which makes it easy to create and admin your projects or browse other public projects.'.
	html paragraph: 'The creator of a project assigns the global access-policy and which people are administrators, developers and guests. Further-on the committed versions of your code can be marked as releases to be public accessible. Other feature are to automatically register a release on SqueakMap or browse the code with your web-browser using a similar interface like the code-browser of squeak. RSS-Feeds of all SqueakSource projects and of single projects are available: They show all public versions and releases plus additional items created by the project admin.'.! !

SSComponent subclass: #SSHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSHome methodsFor: 'configuration' stamp: 'lr 2/19/2004 12:59'!
defaultLongSize
	^20! !

!SSHome methodsFor: 'configuration' stamp: 'pmm 10/26/2006 22:26'!
defaultShortSize
	^4! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:32'!
membersActive
	^self statistics membersActive! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:32'!
membersNew
	^self statistics membersNew! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:33'!
projectsActive
	^self statistics projectsActive! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:33'!
projectsDownloads
	^self statistics projectsDownloads! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:33'!
projectsNew
	^self statistics projectsNew! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:40'!
projectsRecent
	^self statistics projectsRecent! !

!SSHome methodsFor: 'rendering' stamp: 'pmm 10/26/2006 21:02'!
renderContentOn: html
	self renderTitleOn: html.
	self renderIntroductionOn: html.

	self renderStatisticsOn: html.

	self session user ifNotNil: [ self session isSuperUser
		ifTrue: [self renderLogOn: html]].
! !

!SSHome methodsFor: 'rendering' stamp: 'pmm 9/9/2007 12:00'!
renderIntroductionOn: html
	self repository introText withBlanksTrimmed isEmpty ifFalse: [
		^(self repository introText findTokens: String cr) do: [ :paragraph | 
			html paragraph: [
				html html: paragraph ] ] ].

	html paragraph: [
		html text: 'Welcome to SqueakSource, the smart Monticello code-repository for Squeak. To get started register your personal account and create any number of projects to host on our server. You''ll immediately get all the necessary permissions to create and manage your account, projects and versions. Detailed instructions can be found on the '.
		html anchor
			callback: [ self call: (SSHelp model: self model) ];
			with: 'Help'.
		html text: ' page.' ].
	
	html paragraph: 'This service is brought to you for free: it is hosted on a Mac OS X server that is backed up daily. Still, please make sure that you have proper backups and note that we cannot give any accessibility guarantees. However, if you wish you can set up your own SqueakSource server. It is self-hosted and can be downloaded from SqueakMap.'.

	html paragraph: [
		html text: 'Please report any problems or suggestions to the '.
		html anchor
			url: 'mailto:', 'squeak-dev@lists.squeakfoundation.org';
			with: 'Squeak Mailing-List'.
		html text: '. Enjoy!!' ]! !

!SSHome methodsFor: 'rendering' stamp: 'pmm 9/11/2007 22:18'!
renderLabel: aString list: aListSelector click: aClickSelector more: aMoreSelector on: html
	| fullCollection shortCollection |
	fullCollection := self perform: aListSelector.
	fullCollection := fullCollection first: (self defaultLongSize min: fullCollection size).
	fullCollection isEmpty ifFalse: [
		shortCollection := fullCollection first: (self defaultShortSize min: fullCollection size).
		html tableRow: [
			html tableData
				class: 'largeLabel';
				with: aString , ':'.
			html tableData: [
				shortCollection
					do: [ :each | 
						html anchor
							callback: [ self perform: aClickSelector with: each ];
							with: each ]
					separatedBy: [ html text: ', ' ].
				shortCollection size < fullCollection size ifTrue: [ 
					html text: ', '.
					html anchor
						callback: [ self perform: aMoreSelector with: fullCollection with: aString ];
						with: '...' ] ] ] ]! !

!SSHome methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:11'!
renderLogOn: html
	| log |
	log := self session storage getLogOfSize: 2000.
	log ifNil: [^self].

	html heading level2; with: 'Log'.
	html text: '(showing last 2 KB, up to 100 KB '.
	html anchor
		callback: [
			self session returnResponse: (WAResponse
				document: (self session storage getLogOfSize: 100000)
				mimeType: 'text/plain') ];
		with: 'here'.
	html text: ')'.
	html preformatted: log.
! !

!SSHome methodsFor: 'rendering' stamp: 'pmm 9/11/2007 22:20'!
renderStatisticsOn: html
	html heading level2; with: 'Statistics'.
	html heading level3; with: 'Members (' , self model membersCount displayString , ')'.
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [
			self renderLabel: 'Recently Joined' list: #membersNew click: #showMember: more: #showMoreMembers:titled: on: html.
			self renderLabel: 'Most Active' list: #membersActive click: #showMember: more: #showMoreMembers:titled: on: html ].
		html heading level3; with: 'Projects (' , self model projectsCount displayString , ')' .
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [
			self renderLabel: 'Recently Created' list: #projectsNew click: #showProject: more: #showMoreProjects:titled: on: html.
			self renderLabel: 'Recently Used' list: #projectsRecent click: #showProject: more: #showMoreProjects:titled: on: html.
			self renderLabel: 'Most Active' list: #projectsActive click: #showProject: more: #showMoreProjects:titled: on: html.
			self renderLabel: 'Most Downloads' list: #projectsDownloads click: #showProject: more: #showMoreProjects:titled: on: html ].! !

!SSHome methodsFor: 'rendering' stamp: 'lr 3/15/2004 19:28'!
renderTitleOn: html
	html heading: 'Home'.! !

!SSHome methodsFor: 'actions' stamp: 'bf 5/24/2005 18:09'!
showMember: aMember
	self call: aMember view! !

!SSHome methodsFor: 'actions' stamp: 'pmm 8/25/2007 16:13'!
showMoreMembers: aCollection titled: aString
	self call: ((SSListPrinter model: aCollection)
		title: aString;
		renderBlock: [ :html :value | 
			html anchor
				callback: [ self showMember: value ];
				with: value ];
		yourself)! !

!SSHome methodsFor: 'actions' stamp: 'pmm 8/25/2007 16:14'!
showMoreProjects: aCollection titled: aString
	self call: ((SSListPrinter model: aCollection)
		title: aString;
		renderBlock: [ :html :value | 
			html anchor
				callback: [ self showProject: value ];
				with: value ];
		yourself)! !

!SSHome methodsFor: 'actions' stamp: 'bf 5/24/2005 18:13'!
showProject: aProject
	self call: aProject view! !

!SSHome methodsFor: 'statistics' stamp: 'al 7/26/2004 14:32'!
statistics
	^self model statistics! !

SSComponent subclass: #SSListPrinter
	instanceVariableNames: 'renderBlock title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSListPrinter methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:23'!
renderBlock
	^renderBlock! !

!SSListPrinter methodsFor: 'accessing' stamp: 'pmm 8/25/2007 16:18'!
renderBlock: aBlock
	renderBlock := aBlock! !

!SSListPrinter methodsFor: 'rendering' stamp: 'pmm 8/26/2007 14:50'!
renderContentOn: html
	html heading: self title.
	html orderedList: [
		self model do: [ :each |
			html listItem: [
				self renderBlock value: html value: each ] ] ].
	html form: [ 
		html div: [
			html submitButton
				callback: [ self answer ];
				text: 'Close' ] ]! !

!SSListPrinter methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:55'!
title
	^title! !

!SSListPrinter methodsFor: 'accessing' stamp: 'pmm 9/11/2007 22:04'!
title: aString
	title := aString! !

SSComponent subclass: #SSLogin
	instanceVariableNames: 'username password loginFailed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSLogin methodsFor: 'actions' stamp: 'lr 3/15/2004 18:04'!
cancel
	self answer! !

!SSLogin methodsFor: 'initialize-release' stamp: 'pmm 3/1/2006 23:16'!
initialize
	super initialize.
	loginFailed := false.! !

!SSLogin methodsFor: 'actions' stamp: 'pmm 9/1/2007 15:05'!
login
	self session login: (self model
		authenticateUser: self username
		password: self password).
	self session isValidUser
		ifTrue: [ self answer ]
		ifFalse: [ loginFailed := true ]! !

!SSLogin methodsFor: 'accessing' stamp: 'pmm 3/1/2006 23:09'!
loginFailed
	^loginFailed! !

!SSLogin methodsFor: 'accessing' stamp: 'lr 3/15/2004 17:57'!
password
	^password! !

!SSLogin methodsFor: 'accessing' stamp: 'pmm 8/25/2007 16:18'!
password: aString
	password := aString! !

!SSLogin methodsFor: 'rendering' stamp: 'al 3/29/2004 22:10'!
renderContentOn: html
	self renderTitleOn: html.
	self renderFormOn: html.
	self renderForgottonpasswordOn: html! !

!SSLogin methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:20'!
renderForgottonpasswordLinkOn: html
	html anchor
		callback: [ self sendPassword ];
		with: 'I forgot my password'! !

!SSLogin methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:21'!
renderForgottonpasswordOn: html
	html break.
	self loginFailed
		ifTrue: [ html strong: [
			self renderForgottonpasswordLinkOn: html ] ]
		ifFalse: [ self renderForgottonpasswordLinkOn: html ]! !

!SSLogin methodsFor: 'rendering' stamp: 'pmm 8/30/2007 17:40'!
renderFormOn: html
	html form: [
		html div: [
			html table
				border: 0;
				cellspacing: 0;
				cellpadding: 0;
				with: [
					html tableRow: [
						html tableData
							class: 'smallLabel';
							with: 'Initials:'.
						html tableData: [
							html textInput
								on: #username of: self ] ].
					html tableRow: [
						html tableData: 'Password:'.
						html tableData: [
							html passwordInput
								on: #password of: self ] ] ].
			html break.
			html submitButton
				callback: [ self login ];
				text: 'Login'.
			html space.
			html submitButton
				callback: [ self cancel ];
				text: 'Cancel' ] ]! !

!SSLogin methodsFor: 'rendering' stamp: 'lr 3/15/2004 17:59'!
renderTitleOn: html
	html heading: 'Login'.! !

!SSLogin methodsFor: 'actions' stamp: 'al 3/29/2004 22:07'!
sendPassword
	self call: (SSSendPassword model: self model)! !

!SSLogin methodsFor: 'accessing' stamp: 'lr 3/15/2004 17:57'!
username
	^username! !

!SSLogin methodsFor: 'accessing' stamp: 'pmm 8/25/2007 16:34'!
username: aString
	username := aString! !

SSComponent subclass: #SSMemberView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSMemberView methodsFor: 'accessing' stamp: 'lr 2/6/2004 18:44'!
actions
	^(self session user = self model or: [ self session isSuperUser ])
		ifTrue: [ #( 'Edit' edit ) ]
		ifFalse: [ super actions ]! !

!SSMemberView methodsFor: 'actions' stamp: 'pmm 9/1/2007 16:44'!
edit
	| component |
	component := self model asComponent
		addTitle: 'Edit Member'; 
		addValidatedForm;
		yourself.
	(self call: component)
		ifNotNil: [self session save]! !

!SSMemberView methodsFor: 'rendering' stamp: 'lr 3/15/2004 20:03'!
renderContentOn: html
	self renderTitleOn: html.
	self renderDescriptionOn: html.
	self renderTableOn: html.! !

!SSMemberView methodsFor: 'rendering' stamp: 'pmm 10/9/2007 07:09'!
renderDescriptionOn: html
	self model description isNil ifFalse: [
		self
			withLineBreaks: self model information
			on: html ]! !

!SSMemberView methodsFor: 'rendering' stamp: 'pmm 9/5/2007 19:46'!
renderEmailOn: html
	self model email isEmptyOrNil ifFalse: [
		html tableRow: [
			html tableData
				class: 'mediumLabel';
				with: 'E-Mail:'.
		 	html tableData: [ 
				html anchor
					url: 'mailto:', self model email;
					with: self model email ] ] ]! !

!SSMemberView methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:38'!
renderList: aCollection label: aString on: html
	aCollection isEmpty ifFalse: [
		html tableRow: [
			html tableData
				class: 'mediumLabel';
				with: aString.
			html tableData: [
				aCollection
					do: [ :each | 
						html anchor
							callback: [ self call: each view ];
							with: each title ]
					separatedBy: [ html text: ', ' ] ] ] ].! !

!SSMemberView methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:38'!
renderTableOn: html
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [
			self renderEmailOn: html.
			self renderList: self model adminInProjects label: 'Admin:' on: html.
			self renderList: self model developerInProjects label: 'Developer:' on: html.
			self renderList: self model guestInProjects label: 'Guest:' on: html.
			self renderList: self model groups label: 'Groups:' on: html ]! !

!SSMemberView methodsFor: 'rendering' stamp: 'lr 3/15/2004 20:04'!
renderTitleOn: html
	html heading: self model fullname , ' (' , self model initials , ')'! !

!SSMemberView methodsFor: 'rendering' stamp: 'pmm 10/9/2007 07:08'!
withLineBreaks: aString on: html
	| stream |
	stream := aString readStream.
	[ stream atEnd ] whileFalse: [
		html html: stream nextLine.
		stream atEnd ifFalse: [ html break ] ]! !

SSComponent subclass: #SSOverview
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSOverview methodsFor: 'accessing' stamp: 'pmm 10/9/2007 06:42'!
announcer
	^announcer! !

!SSOverview methodsFor: 'accessing' stamp: 'pmm 10/9/2007 06:42'!
announcer: anObject
	announcer := anObject! !

!SSOverview methodsFor: 'actions' stamp: 'pmm 10/9/2007 06:42'!
callOnParent: aComponent
	| announcement |
	announcement := SSProjectViewCallAnnoucement component: aComponent.
	self announcer announce: announcement! !

!SSOverview methodsFor: 'actions' stamp: 'pmm 10/9/2007 07:11'!
displayProjectsWithTag: aTag
	self callOnParent: (SSProjectsWithTag model: aTag)! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 9/8/2007 09:05'!
renderAccessOn: html
	html break ; break.
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [
			html tableRow: [
				html tableData
					class: 'largeLabel';
					with: 'Global:'.
				html tableData: self model accessPolicy globalRight asCapitalizedPhrase ] ]! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 9/8/2007 09:00'!
renderContentOn: html
	self renderDescriptionOn: html.
	self renderMembersOn: html.
	self renderTagsOn: html.
	self renderLicencseOn: html.
	self renderRegistrationOn: html.
	self renderLinksOn: html.
	self renderAccessOn: html.
	self renderStatisticsOn: html! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 9/8/2007 09:00'!
renderDescriptionOn: html
	html heading level2; with: 'Project Description'.
	html paragraph: self model information! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 9/8/2007 09:03'!
renderLicencseOn: html
	| license |
	license := self model license.
	license isNil ifTrue: [ ^self ].
	license first isNil ifTrue: [ ^self ].
	
	html heading level2; with: 'License'.
	html text: 'Code commited to this repository will be automatically under '.
	html anchor
		url: license second;
		with: license first.
	html text: ' license.'! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 9/9/2007 12:48'!
renderLinksOn: html
	html heading level2; with: 'Links'.
	html anchor
		title: 'static project url';
		url: self model fullHomepageUrl;
		with: self model fullHomepageUrl.
	html break.
	html anchor
		title: 'static listing url';
		url: self model fullDirectoryUrl;
		with: self model fullDirectoryUrl! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 10/9/2007 06:42'!
renderList: aCollection label: aString on: html
	aCollection isEmpty ifFalse: [
		html tableRow: [
			html tableData
				class: 'largeLabel';
				with: aString.
			html tableData: [
				aCollection
					do: [ :each |
						html anchor
							callback: [ self callOnParent: each view ];
							with: each fullname ]
					separatedBy: [ html text: ', ' ] ] ] ]! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 9/8/2007 09:01'!
renderMembersOn: html
	html heading level2; with: 'Members'.
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [
			self renderList: self model creators label: 'Creator:' on: html.
			self renderList: self model admins label: 'Admin:' on: html.
			self renderList: self model developers label: 'Developer:' on: html.
			self renderList: self model guests label: 'Guests:' on: html ]! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 9/9/2007 12:45'!
renderRegistrationOn: html
	html heading level2; with: 'Registration'.
	html preformatted: [
		html text: 'MCHttpRepository'; break.
		html text: '    location: '; text: self model fullDirectoryUrl printString; break.
		html text: '    user: '; text: (self session isValidUser
			ifTrue: [ self session user initials ]
			ifFalse: [ String new ]) printString; break.
		html text: '    password: '; text: String new printString; break ].! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 9/8/2007 09:05'!
renderStatisticsOn: html
	html heading level2; with: 'Statistics'.
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [
			html tableRow: [
				html tableData
					class: 'largeLabel';
					with: 'Registered:'.
				html tableData: self model timestamp ].
			
			html tableRow: [
				html tableData
					class: 'largeLabel';
					with: 'Total Releases:'.
				html tableData: self model cachedNumberOfReleases ].
			html tableRow: [
				html tableData
					class: 'largeLabel';
					with: 'Total Versions:'.
				html tableData: self model cachedNumberOfNormalVersions ].
			html tableRow: [
				html tableData
					class: 'largeLabel';
					with: 'Total Downloads:'.
				html tableData: self model cachedDownloads ] ]! !

!SSOverview methodsFor: 'rendering' stamp: 'pmm 9/8/2007 18:29'!
renderTagsOn: html
	html heading level2; with: 'Tags'.
	self model hasTags
		ifFalse: [ html text: 'This project doesn''t yet have tags.' ]
		ifTrue: [ 
			self model tags
				do: [ :each |
					html anchor
						callback: [ self displayProjectsWithTag: each ];
						with: [ html text: each name ] ]
				separatedBy: [ html text: ', ' ] ]! !

SSComponent subclass: #SSProjectRSS
	instanceVariableNames: 'batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSProjectRSS methodsFor: 'accessing' stamp: 'pmm 8/25/2007 16:48'!
children
	^Array with: batchedList! !

!SSProjectRSS methodsFor: 'rendering' stamp: 'pmm 9/8/2007 08:59'!
renderContentOn: html
	html break.
	batchedList batch isEmpty
		ifTrue: [ html emphasis: 'No feed available' ]
		ifFalse: [ self renderFeedListingOn: html ]! !

!SSProjectRSS methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:54'!
renderFeedListingOn: html
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [ 
			batchedList batch do: [ :each |
				html tableRow
					class: 'TabUnselected';
					with: [
						html tableData
							class: 'left';
							with: [
								html strong: each title ].
						html tableData
							align: 'right';
							with: [
								html render: each author.
								html text: ', '.
								html render: each timestamp ] ].
				html tableRow: [
					html tableData
						colSpan: 3;
						with: [ html withLineBreaks: each message ] ].
				html tableRow: [
					html tableData
						colSpan: 3;
						with: [ html space ] ] ] ].
	batchedList maxPages > 1 ifTrue: [ 
		html render: batchedList ]! !

!SSProjectRSS methodsFor: 'initialization' stamp: 'pmm 8/25/2007 16:47'!
setModel: aModel
	super setModel: aModel.
	batchedList := SSBatchedList new
		batchSize: 10;
		items: self sortedItems;
		yourself! !

!SSProjectRSS methodsFor: 'accessing' stamp: 'bf 12/19/2005 12:37'!
sortedItems
	^(SortedCollection sortBlock: [:a :b | a timestamp > b timestamp])
		addAll: model feeds;
		addAll: model versions;
		yourself! !

SSComponent subclass: #SSProjectView
	instanceVariableNames: 'tabPanel searchText announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 9/9/2007 12:47'!
actions
	^Array streamContents: [ :stream |
		stream nextPut: 'RSS feed'; nextPut: self model fullDirectoryUrl, '/feed.rss'.
		(self model isMember: self session user allowedTo: SSAccessPolicy admin) ifTrue: [
			stream nextPutAll: #( 'Add Message' rss ).
			stream nextPutAll: #( 'Edit Project' edit ).
			stream nextPutAll: #( 'Delete Project' delete ).
			self model hasConfigs ifTrue: [
				stream nextPutAll: #( 'Edit Configs' editConfigs ).]].
		(self model isMember: self session user allowedTo: SSAccessPolicy write)
			ifTrue: [ stream nextPutAll: #( 'Import Versions' import ) ].
		"(self model isMember: self session user allowedTo: SSAccessPolicy read)
			ifTrue: [
				SSGraphBuilder formats , #(pdf) do: [ :each |
					stream nextPutAll: (Array
						with: 'Ancestory ', each asUppercase
						with: '/', self project id,'/'  ,SSGraphBuilder filename, '.', each) ] ]" ]! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 9/8/2007 19:01'!
announcer
	^announcer! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 4/23/2007 00:45'!
blessedVersions
	^ self model allBlessedVersions
		select: [ :each |
			each notNil
				and: [
					self model 
						isMember: self session user 
						allowedTo: SSAccessPolicy read
						for: each ] ]! !

!SSProjectView methodsFor: 'actions' stamp: 'pmm 9/8/2007 20:09'!
callFromTabContent: anAnnoucement
	self call: anAnnoucement component! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 9/8/2007 08:53'!
children
	^Array with: tabPanel! !

!SSProjectView methodsFor: 'actions' stamp: 'pmm 9/18/2007 21:49'!
confirmDelete: aConfiguration
	^ self call: (WAYesOrNoDialog new
		addDecoration: (SSConfirmConfigurationDeleteDecoration configuration: aConfiguration);
		yourself)
	! !

!SSProjectView methodsFor: 'actions' stamp: 'bf 12/15/2005 19:24'!
delete
	(self confirm: 'You are about to delete the project ''', self model title, '''. All data and version information will be lost!! Are you sure you really want to delete this project?') ifTrue: [
		self repository removeProject: self model.
		self session save.
		self session expire ]! !

!SSProjectView methodsFor: 'actions' stamp: 'pmm 9/17/2007 20:50'!
edit
	| component |
	component := self model asComponent
		addDecoration: SSExplanationDecoration new;
		addTitle: 'Edit Project'; 
		addValidatedForm;
		yourself.
	(self call: component)
		ifNotNil: [ self session save ]! !

!SSProjectView methodsFor: 'actions' stamp: 'pmm 9/18/2007 21:49'!
editConfigs	
	[
		| cfgName configuration message |
		cfgName := self call: (SSSimpleObjectChooser 
			model: (self model sortedConfigs collect: [ :each | each fileName])
			heading: 'Choose config	').

		cfgName ifNil: [^self].

		configuration := self model configs at: cfgName ifAbsent: [ ^self ].
		(self confirmDelete: configuration) ifTrue: [
			self model configs
				removeKey: cfgName
				ifAbsent: [ self inform: 'Delete failed!!' ].
			self session save ] .
	] repeat! !

!SSProjectView methodsFor: 'initialize-release' stamp: 'pmm 9/8/2007 18:51'!
feed
	^SSProjectRSS model: self model! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 9/5/2007 22:30'!
feedUrl
	^self session baseUrl
		addToPath: self model id;
		addToPath: 'feed.rss';
		yourself! !

!SSProjectView methodsFor: 'private' stamp: 'al 2/2/2006 09:49'!
filter: someVersions
	searchText isEmptyOrNil ifTrue: [
		^someVersions].
	^(searchText includes: $*)
		ifTrue: [
			someVersions select: [ :each |
				each stringsSatisfy: [ :str |
					str notNil and: [ searchText match: str ] ] ] ]
		ifFalse: [
			someVersions select: [ :each |
				each stringsSatisfy: [ :str |
					str notNil and: [ str includesSubstring: searchText
						caseSensitive: false ] ] ] ].
! !

!SSProjectView methodsFor: 'actions' stamp: 'lr 2/9/2004 12:23'!
import
	self call: (SSVersionImporter model: self model).
	self session save.! !

!SSProjectView methodsFor: 'initialize-release' stamp: 'pmm 10/8/2007 06:58'!
initializeAnnouncer
	announcer := Announcer new.
	announcer on: SSProjectViewCallAnnoucement send: #callFromTabContent: to: self! !

!SSProjectView methodsFor: 'initialize-release' stamp: 'pmm 10/8/2007 06:41'!
initializeTabPanel
	tabPanel := SSTabPanel new
		addTab: self projectOverview named: 'Overview';
		yourself.
	
	self showAllTabs ifTrue: [
		tabPanel
			addTab: self wiki named: 'Wiki';
			addTab: self feed named: 'News'.

		self model hasReleases ifTrue: [
			tabPanel addTab: self projectReleases named: 'Releases'].
		
		self model canBless ifTrue: [
			tabPanel addTab: self projectBlessedVersions named: 'Blessings'].
		
		tabPanel
			addTab: self projectVersions named: 'Versions';
			addTab: self projectLatestVersions named: 'Latest' ]
! !

!SSProjectView methodsFor: 'private' stamp: 'pmm 9/8/2007 21:02'!
instantiate: aClass
	^aClass
		model: self model
		announcer: self announcer
		searchTerm: self searchText! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 8/29/2006 07:09'!
project
	^self model! !

!SSProjectView methodsFor: 'private-components' stamp: 'pmm 9/8/2007 19:02'!
projectBlessedVersions
	^self instantiate: SSProjectBlessedVersions! !

!SSProjectView methodsFor: 'private-components' stamp: 'pmm 9/8/2007 19:02'!
projectLatestVersions
	^self instantiate: SSProjectLatestVersions! !

!SSProjectView methodsFor: 'private-components' stamp: 'pmm 10/9/2007 06:44'!
projectOverview
	^(SSOverview model: self model)
		announcer: self announcer;
		yourself! !

!SSProjectView methodsFor: 'private-components' stamp: 'pmm 9/8/2007 19:02'!
projectReleases
	^self instantiate: SSProjectReleases! !

!SSProjectView methodsFor: 'private-components' stamp: 'pmm 9/8/2007 19:02'!
projectVersions
	^self instantiate: SSProjectVersions! !

!SSProjectView methodsFor: 'rendering' stamp: 'pmm 9/8/2007 18:29'!
renderContentOn: html
	self renderTitleOn: html.
	html render: tabPanel! !

!SSProjectView methodsFor: 'rendering' stamp: 'pmm 8/25/2007 16:04'!
renderTitleOn: html
	html heading level1; with: self model title! !

!SSProjectView methodsFor: 'actions' stamp: 'pmm 9/1/2007 16:18'!
rss
	| entry component |
	entry := SSFeedEntry new
		author: self session user;
		title: self model title;
		message: String new;
		yourself.
		
	component := entry asComponent
		addTitle: 'Add Message'; 
		addValidatedForm;
		yourself.
	entry := self call: component.
	entry isNil ifFalse: [
		self model feeds add: entry.
		self resetModel.
		self session save ]! !

!SSProjectView methodsFor: 'accessing' stamp: 'bf 12/19/2005 10:16'!
searchText
	^searchText! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 9/8/2007 21:02'!
searchText: aString
	| announcement |
	searchText := aString ifNotNil: [ aString withBlanksTrimmed ].
	announcement := SSSearchAnnoucement searchText: self searchText.
	self announcer announce: announcement! !

!SSProjectView methodsFor: 'initialize-release' stamp: 'pmm 9/8/2007 20:14'!
setModel: aModel
	super setModel: aModel.
	self initializeAnnouncer.
	self initializeTabPanel! !

!SSProjectView methodsFor: 'testing' stamp: 'pmm 8/25/2007 17:55'!
showAllTabs
	^self model isMember: self session user allowedTo: SSAccessPolicy read! !

!SSProjectView methodsFor: 'updating' stamp: 'pmm 8/25/2007 17:54'!
updateRoot: html
	super updateRoot: html.
	html link beAlternate; beRss; title: self model title; url: self feedUrl! !

!SSProjectView methodsFor: 'updating' stamp: 'pmm 9/9/2007 12:51'!
updateUrl: anUrl
	anUrl addToPath: self model relativeHomepageUrl! !

!SSProjectView methodsFor: 'accessing' stamp: 'pmm 9/8/2007 18:50'!
wiki
	^SSWiki on: self model! !

SSComponent subclass: #SSRegisterSqueakMap
	instanceVariableNames: 'default form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSRegisterSqueakMap methodsFor: 'accessing' stamp: 'pmm 8/25/2007 17:57'!
children
	^Array with: form! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:53'!
package
	^default 
		propertyAt: SSVersion smPackageProperty
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:56'!
package: aString
	self version 
		propertyAt: SSVersion smPackageProperty
		put: aString! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:53'!
password
	^default 
		propertyAt: SSVersion smPasswordProperty
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:56'!
password: aString
	self version 
		propertyAt: SSVersion smPasswordProperty
		put: aString! !

!SSRegisterSqueakMap methodsFor: 'accessing' stamp: 'lr 2/11/2004 11:20'!
project
	^self model first! !

!SSRegisterSqueakMap methodsFor: 'rendering' stamp: 'lr 2/11/2004 11:21'!
renderContentOn: html
	html render: form! !

!SSRegisterSqueakMap methodsFor: 'rendering' stamp: 'pmm 9/1/2007 16:54'!
setModel: aModel
	super setModel: aModel.
	default := (self version propertyIncludes: SSVersion smPackageProperty)
		ifTrue: [ self version ]
		ifFalse: [
			self project versionsSorted
				detect: [ :each | 
					each packageName = self version packageName 
						and: [ each propertyIncludes: SSVersion smPackageProperty ] ]
				ifNone: [ SSVersion new ] ].
	form := SSMember new asRegisterComponent
		addTitle: 'SqueakMap Release for ' , self version fileName; 
		addValidatedForm;
		yourself.
	form onAnswer: [ :value | self answer: value ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:53'!
username
	^default 
		propertyAt: SSVersion smUsernameProperty
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'lr 2/11/2004 11:56'!
username: aString
	self version 
		propertyAt: SSVersion smUsernameProperty
		put: aString! !

!SSRegisterSqueakMap methodsFor: 'accessing' stamp: 'lr 2/11/2004 11:20'!
version
	^self model second! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'al 3/3/2004 18:22'!
versionComment
	^default 
		propertyAt: SSVersion smVersionCommentProperty 
		ifAbsent: [ nil ]! !

!SSRegisterSqueakMap methodsFor: 'accessing-settings' stamp: 'al 3/3/2004 18:22'!
versionComment: aString
	self version 
		propertyAt: SSVersion smVersionCommentProperty
		put: aString! !

SSComponent subclass: #SSSearchableWithReport
	instanceVariableNames: 'report searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

SSSearchableWithReport subclass: #SSMembers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSMembers methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:12'!
all
	^self model members! !

!SSMembers methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:15'!
heading
	^'Members'! !

!SSMembers methodsFor: 'actions' stamp: 'lr 3/15/2004 18:27'!
registerMember
	super registerMember.
	self resetModel.

! !

!SSMembers methodsFor: 'initialization' stamp: 'pmm 9/18/2007 19:55'!
setModel: aModel
	| sort |
	super setModel: aModel.
	report := MAReport new
		rowPeriod: 1;
		batchSize: self repository batchSize;
		rows: self all;
		addColumn: (sort := (MAColumn new
				selector: #fullname;
				title: 'Name';
				format: [ :each :html | 
					html anchor
						callback: [ self call: each view ];
						with: each fullname ];
				sorter: [ :a :b |
					a fullname caseInsensitiveLessOrEqual: b fullname ];
				yourself));
		addColumn: (MAColumn new
				selector: #initials;
				title: 'Initials';
				yourself);
		addColumn: (MAColumn new
				selector: #cachedProjectCount;
				title: 'Projects';
				sorter: [ :a : b | a cachedProjectCount > b cachedProjectCount ];
				yourself);
		addColumn: (MAColumn new
				selector: #cachedCommitCount;
				title: 'Commits';
				sorter: [ :a : b | a cachedCommitCount > b cachedCommitCount ];
				yourself);
		sortColumn: sort;
		yourself.! !

SSSearchableWithReport subclass: #SSProjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSProjects methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:11'!
all
	^self model visibleProjects! !

!SSProjects methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:15'!
heading
	^'Projects'! !

!SSProjects methodsFor: 'actions' stamp: 'lr 3/15/2004 19:50'!
registerProject
	super registerProject.
	self resetModel.! !

!SSProjects methodsFor: 'initialization' stamp: 'pmm 8/30/2007 17:00'!
renderMemberBlockFor: aSymbol
	^[ :item :html |
		(item perform: aSymbol)
			do: [ :each | html anchor
				callback: [ self call: each view ];
				with: each initials ]
			separatedBy: [ html text: ', ' ] ]! !

!SSProjects methodsFor: 'initialization' stamp: 'pmm 10/5/2007 22:57'!
setModel: aModel
	| sort |
	super setModel: aModel.
	report := MAReport new
		rowPeriod: 1;
		batchSize: self repository batchSize;
		rows: self all;
		addColumn: (sort := MAColumn new
				title: 'Project';
				format: [ :each :html |
					html anchor
						extraPath: each relativeHomepageUrl;
						callback: [ self call: (each view searchText: searchText) ];
						with: each title ];
				yourself);
		addColumn: (MAColumn new
				selector: #admins;
				title: 'Admins';
				format: (self renderMemberBlockFor: #admins);
				sorter: nil;
				yourself);
		addColumn: (MAColumn new
				selector: #developers;
				title: 'Developers';
				format: (self renderMemberBlockFor: #developers);
				sorter: nil;
				yourself);
		addColumn: (MAColumn new
				selector: #guests;
				title: 'Guests';
				format: (self renderMemberBlockFor: #guests);
				sorter: nil;
				yourself);
		addColumn: (MAColumn new
				selector: #yourself;
				title: 'Activity';
				format: [ :each :html |
					html table
						class: 'activityTable';
						cellspacing: 0;
						cellpadding: 0;
						with: [
							html tableRow: [
								html tableData
									style: 'background-color: ', (Color activity: each cachedRelativeActivity) asHTMLColor;
									with: [ html space; space; space ] ] ] ];
				sorter: [ :a : b | a cachedRelativeActivity > b cachedRelativeActivity ];
				yourself);
		addColumn: (MAColumn new
				selector: #cachedDownloads;
				title: 'Downloads';
				sorter: [ :a : b | a cachedDownloads > b cachedDownloads ];
				yourself);
		sortColumn: sort;
		yourself.
	
	self searchText isEmptyOrNil
		ifFalse: [ self search ].! !

SSProjects subclass: #SSProjectsWithTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSProjectsWithTag methodsFor: 'accessing' stamp: 'pmm 2/5/2006 15:21'!
all
	^self model projects! !

!SSProjectsWithTag methodsFor: 'accessing' stamp: 'pmm 2/5/2006 15:22'!
heading
	^self model name , ' Projects'! !

!SSSearchableWithReport methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:10'!
all
	self subclassResponsibility ! !

!SSSearchableWithReport methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:04'!
children
	^Array with: report! !

!SSSearchableWithReport methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:04'!
heading
	self subclassResponsibility ! !

!SSSearchableWithReport methodsFor: 'rendering' stamp: 'pmm 1/19/2006 10:14'!
renderContentOn: html
	html heading: self heading.
	self renderSearchOn: html.
	html render: report! !

!SSSearchableWithReport methodsFor: 'rendering' stamp: 'pmm 8/26/2007 14:52'!
renderSearchOn: html
	html form: [
		html div: [
			html textInput
				on: #searchText of: self.
			html space.
			html submitButton
				callback: [ self search ];
				text: 'Search'  ] ].
	html break.! !

!SSSearchableWithReport methodsFor: 'actions' stamp: 'al 2/2/2006 09:48'!
search
	| all found |
	all := self all.
	searchText isEmptyOrNil ifTrue: [
		^report rows: all].
	found := (searchText includes: $*)
		ifTrue: [
			all select: [ :each |
				each stringsSatisfy: [:str |
					str notNil and: [ searchText match: str ] ] ] ]
		ifFalse: [
			all select: [ :each |
				each stringsSatisfy: [ :str |
					str notNil and: [ str includesSubstring: searchText
						caseSensitive: false ] ] ] ].
	report rows: found.! !

!SSSearchableWithReport methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:09'!
searchText
	^searchText! !

!SSSearchableWithReport methodsFor: 'accessing' stamp: 'pmm 1/19/2006 10:10'!
searchText: aString
	searchText := aString ifNotNil: [ aString withBlanksTrimmed ]! !

SSComponent subclass: #SSSendPassword
	instanceVariableNames: 'initials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSSendPassword methodsFor: 'actions' stamp: 'pmm 8/25/2007 18:10'!
cancel
	self answer: nil! !

!SSSendPassword methodsFor: 'accessing' stamp: 'lr 3/30/2004 18:33'!
initials
	^initials! !

!SSSendPassword methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:10'!
initials: aString
	initials := aString! !

!SSSendPassword methodsFor: 'rendering' stamp: 'pmm 8/26/2007 14:50'!
renderContentOn: html
	html heading: 'I forgot my password'.
	html text: 'You will get an e-mail with a secure url that takes you to your personal member-settings where you are able to set a new password. The url will be available for a few minutes only, so check your e-mail soon.'.
	html break; break.
	html form: [
		html div: [
			html table
				border: 0;
				cellspacing: 0;
				cellpadding: 0;
					with: [
					html tableRow: [
						html tableData
							class: 'smallLabel';
							with: 'Initials: '.
						html tableData: [
							html textInput
								size: 5;
								on: #initials of: self ] ] ].
				html break.
				html submitButton
					callback: [ self send ];
					text: 'Send'; space.
				html submitButton
					callback: [ self cancel ];
					text: 'Cancel' ] ]! !

!SSSendPassword methodsFor: 'actions' stamp: 'pmm 8/25/2007 18:10'!
send
	self sendPasswordToUserWithLogin: self initials! !

!SSSendPassword methodsFor: 'actions' stamp: 'pmm 10/2/2007 21:47'!
sendMailWithUrl: aUrl toMember: aMember
	| messageText email |
	messageText := 'To: ' , aMember email , '
Subject: ', self repository title ,' -- Forgot Password

Hi ' , aMember fullname , ',

we received a request (presumeably by you) that you forgot your password. To log into your account and to change your password please visit the link below:

	' , aUrl , '
	
If you didn''t sent this request, please forget about this mail. Your account-information won''t be changed and you will be able to access your account with your old password.

-- 
' , self repository rootUrl.
	email := (self repository superUserEmail findTokens: ',') first.
	SeasidePlatformSupport
		deliverMailFrom: email
		to: (Array with: aMember email with: email)
		text: messageText
		usingServer: self repository smtpServer! !

!SSSendPassword methodsFor: 'actions' stamp: 'pmm 9/17/2007 20:25'!
sendPasswordToUserWithLogin: login
	| member url |
	member := self model memberAt: login.
	member isNil ifTrue: [
		self informOnlyAdmin: 'You specified an unknown account. Please contact the administrator.'.
		self answer ].
	member email isNil ifTrue: [
		self informOnlyAdmin: 'No e-mail address specified for this account. Please contact the administrator.'.
		self answer ].
	member isSuperUser ifTrue: [
		self inform: 'Superusers shoud never forget their password.'.
		self answer ].
	Continuation currentDo: [ :cc | 
		url := self session actionUrlForContinuation: cc.
		url := self repository rootUrl , url copyWithoutFirst.
		[ self sendMailWithUrl: url toMember: member ]
			on: Exception
			do: [ :error | self informOnlyAdmin: error messageText , '. Please contact the administrator.'; answer ].
		self inform: 'An e-mail has been successfully sent to you.'.
		self answer ].
	self editMember: 'Change your password'.
	self answer! !

SSComponent subclass: #SSSimpleObjectChooser
	instanceVariableNames: 'heading selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSSimpleObjectChooser class methodsFor: 'instance creation' stamp: 'lr 2/8/2004 12:03'!
model: aModel heading: aString
	^(self model: aModel)
		heading: aString;
		yourself! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'lr 2/8/2004 12:02'!
heading
	^heading! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:15'!
heading: aString
	heading := aString! !

!SSSimpleObjectChooser methodsFor: 'rendering' stamp: 'pmm 8/26/2007 14:50'!
renderContentOn: html
	html heading: self heading.
	html form: [
		html div: [
			html select
				size: 15;
				style: 'width: 100%';
				list: self model;
				on: #selection of: self.
			html break; break.
			html submitButton
				callback: [ self answer: self selection ];
				text: 'Ok'.
			html submitButton
				callback: [ self answer: nil ];
				text: 'Cancel' ] ]! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'lr 3/22/2004 19:05'!
selection
	^selection! !

!SSSimpleObjectChooser methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:15'!
selection: anObject
	selection := anObject! !

SSComponent subclass: #SSTabPanel
	instanceVariableNames: 'selectedTab tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSTabPanel methodsFor: 'actions' stamp: 'pmm 8/26/2007 11:06'!
addTab: aComponent named: aString
	tabs add: aString -> aComponent! !

!SSTabPanel methodsFor: 'actions' stamp: 'pmm 8/26/2007 11:06'!
addTabs: aCollection
	aCollection associationsDo: [ :each |
		self addTab: each value named: each key ]! !

!SSTabPanel methodsFor: 'accessing' stamp: 'pmm 8/26/2007 11:02'!
children
	^Array with: selectedTab! !

!SSTabPanel methodsFor: 'initialize-release' stamp: 'pmm 8/26/2007 11:07'!
initialize
	super initialize.
	tabs := OrderedCollection new! !

!SSTabPanel methodsFor: 'rendering' stamp: 'lr 3/19/2004 09:26'!
renderComponentOn: html
	html render: self selectedTab! !

!SSTabPanel methodsFor: 'rendering' stamp: 'lr 3/19/2004 09:25'!
renderContentOn: html
	self renderTabsOn: html.
	self renderLineOn: html.
	self renderComponentOn: html.! !

!SSTabPanel methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:36'!
renderLineOn: html
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		style: 'width: 100%';
		class: 'TabLine';
		with: [
			html tableRow: [
				html image
					width: '1';
					height: '1';
					url: '' ] ]! !

!SSTabPanel methodsFor: 'rendering' stamp: 'pmm 8/26/2007 11:04'!
renderTab: aComponent named: aString on: html
	| selected |
	selected := aComponent == self selectedTab.
	html tableData
		class: (selected ifTrue: ['TabSelected'] ifFalse: ['TabUnselected']);
		with: [
		selected
			ifTrue: [ html text: aString ]
			ifFalse: [ html anchor
				callback: [ selectedTab := aComponent ];
				with: aString ] ]! !

!SSTabPanel methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:36'!
renderTabSpacerOn: html
	html tableData
		class: 'TabSpacer'; 
		with: nil! !

!SSTabPanel methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:37'!
renderTabsOn: html
	html table
		border: 0;
		cellspacing: 0;
		cellpadding: 0;
		with: [
			html tableRow: [
				self renderTabSpacerOn: html.
				tabs 
					do: [ :each | self renderTab: each value named: each key on: html ]
					separatedBy: [ self renderTabSpacerOn: html ] ] ]! !

!SSTabPanel methodsFor: 'accessing' stamp: 'pmm 8/26/2007 11:10'!
selectedTab
	^ selectedTab ifNil: [ selectedTab := tabs first value ]! !

!SSTabPanel methodsFor: 'accessing' stamp: 'pmm 8/26/2007 11:11'!
selectedTabName
	^ (tabs detect: [ :association |
		association value = self selectedTab]) key! !

!SSTabPanel methodsFor: 'accessing' stamp: 'pmm 8/26/2007 11:02'!
states
	^Array with: selectedTab! !

SSComponent subclass: #SSTags
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSTags methodsFor: 'actions' stamp: 'pmm 3/15/2006 21:43'!
actions
	^super actions , #('Create Tag' #createTag)! !

!SSTags methodsFor: 'accessing' stamp: 'pmm 3/15/2006 21:48'!
all
	^self model tags! !

!SSTags methodsFor: 'private' stamp: 'pmm 3/15/2006 21:46'!
alreadyExists: aString
	self inform: 'A tag `' , aString , ''' already exists.'
	! !

!SSTags methodsFor: 'testing' stamp: 'pmm 3/15/2006 21:42'!
canCreateTag
	^self session isValidUser
		and: [
			self repository allowCreateTag
				or: [ self user isSuperUser ] ]! !

!SSTags methodsFor: 'accessing' stamp: 'pmm 8/25/2007 18:18'!
children
	^Array with: report! !

!SSTags methodsFor: 'actions' stamp: 'pmm 8/26/2007 12:29'!
createTag
	| name |
	self session isValidUser ifFalse: [
		self call: (SSLogin model: self repository) ].
	self canCreateTag
		ifFalse: [ self inform: 'You are not alllowed to create new tags.' ]
		ifTrue: [
			name := ''.
			[ name isEmptyOrNil ] whileTrue: [
				name := self request: 'Name of the tag: ' ].
			(self repository hasTagNamed: name)
				ifTrue: [ self alreadyExists: name ]
				ifFalse: [ 
					self repository createTagNamed: name.
					self session save.
					self resetModel ] ]
	! !

!SSTags methodsFor: 'actions' stamp: 'pmm 4/23/2007 00:54'!
deleteTag: aTag
	(self confirm: 'Do you really want to remove the tag `' , aTag name , '''?')
		ifTrue: [
			self repository deleteTag: aTag.
			self session save.
			self resetModel ]! !

!SSTags methodsFor: 'accessing' stamp: 'pmm 3/15/2006 21:48'!
heading
	^'Tags'! !

!SSTags methodsFor: 'actions' stamp: 'pmm 4/23/2007 00:54'!
renameTag: aTag
	| newName |
	newName := ''.
	[ newName isEmptyOrNil ] whileTrue: [
		newName := self request: 'New name of the tag: ' ].
	(self repository hasTagNamed: newName)
		ifTrue: [ self alreadyExists: newName ]
		ifFalse: [ 
			self repository renameTag: aTag to: newName.
			self session save.
			self resetModel ]! !

!SSTags methodsFor: 'rendering' stamp: 'pmm 1/24/2006 22:28'!
renderContentOn: html
	html heading: self heading.
	html render: report! !

!SSTags methodsFor: 'initialization' stamp: 'pmm 9/18/2007 19:55'!
setModel: aModel
	| sort tagActiviy maxActivity |
	super setModel: aModel.
	tagActiviy := aModel tagActiviy.
	maxActivity := tagActiviy sortedElements inject: 0 into: [ :result :assoc |
		result max: assoc value ].
	maxActivity = 0 ifTrue: [ maxActivity := 1 ].
	report := MAReport new
		rowPeriod: 1;
		batchSize: self repository batchSize;
		rows: self all;
		addColumn: (sort := MAColumn new
				selector: #yourself;
				title: 'Name';
				format: [ :each :html | 
					html anchor
						callback: [ self displayProjectsWithTag: each ];
						with: each name ]
				yourself);
		addColumn: (MAColumn new
				selector: #numberOfProjects;
				title: '#';
				sorter: [ :a : b | a numberOfProjects > b numberOfProjects ];
				yourself);
		addColumn: (MAColumn new
				selector: #yourself;
				title: 'Projects';
				format: [ :each :html | 
					html table
						cellspacing: 0;
						cellpadding: 0;
						class: 'activityTable';
						with: [
							html tableRow: [
								html tableData
									style: 'background-color: ', (Color activity: (tagActiviy occurrencesOf: each) / maxActivity) asHTMLColor;
									with: [ html space; space; space ] ] ] ];
				sorter: [ :a : b | a maxActivity > b maxActivity ];
				yourself);
		yourself.
	self session isSuperUser ifTrue: [
		report addColumn: (MAColumn new 
			selector: #yourself;
			title: 'Actions';
			format: [ :each :html | 
				html anchor
					callback: [ self renameTag: each ];
					with: 'rename'.
				html space.
				html anchor
					callback: [ self deleteTag: each ];
					with: 'delete' ];
			sorter: nil;
			yourself) ].

	report sortColumn: sort! !

SSComponent subclass: #SSVersionImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSVersionImporter methodsFor: 'rendering' stamp: 'lr 2/6/2004 16:51'!
renderContentOn: html
	self renderTitleOn: html.
	self renderUploadsOn: html.! !

!SSVersionImporter methodsFor: 'rendering' stamp: 'pmm 8/25/2007 18:22'!
renderTitleOn: html
	html heading: 'Import into ', self model title! !

!SSVersionImporter methodsFor: 'rendering' stamp: 'pmm 10/14/2007 20:08'!
renderUpload: anInteger on: html
	html tableRow: [
		html tableData
			class: 'label';
			with: anInteger displayString, ':'.
		html tableData: [
			html fileUpload
				callback: [ :file |
					(file notNil and: [ file contents notEmpty ])
						ifTrue: [ self uploadFile: file ] ] ] ]! !

!SSVersionImporter methodsFor: 'rendering' stamp: 'pmm 10/14/2007 20:04'!
renderUploadsOn: html
	html form
		multipart;
		with: [
			html div: [
				html table
					border: 0;
					cellspacing: 0;
					cellpadding: 0;
					with: [
						1 to: 10 do: [ :each |
							self renderUpload: each on: html ] ].
				html break.
				html submitButton
					callback: [ self answer ];
					text: 'Upload' ] ]! !

!SSVersionImporter methodsFor: 'actions' stamp: 'pmm 10/14/2007 20:28'!
uploadFile: aFile
	[
		| version |
	 	version := self model
			addVersion: aFile contents
			author: self session user.
		version setTimestampFromVersionInfo.
		self session save
	]
		on: Error
		do: [ :error |
			self inform: 'There was an error importing the file ', aFile fileName , '. The file has to be in mcz format!!' ] ! !

SSComponent subclass: #SSWindow
	instanceVariableNames: 'title content style'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSWindow methodsFor: 'accessing' stamp: 'pmm 8/26/2007 10:27'!
children
	^Array with: content! !

!SSWindow methodsFor: 'accessing' stamp: 'pmm 8/26/2007 10:26'!
content: aComponent
	content := aComponent! !

!SSWindow methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:08'!
renderCloseButtonOn: html
	html anchor
		callback: [self answer];
		with: 'close'! !

!SSWindow methodsFor: 'rendering' stamp: 'pmm 8/26/2007 10:34'!
renderContentOn: html
	html table
		cellspacing: 0;
		with: [
			html tableRow
				id: 'window-titlebar';
				with: [
					html tableData
						id: 'window-title';
						with: title.
					html tableData
						id: 'window-close';
						with: [ self renderCloseButtonOn: html ] ].
			html tableRow
				id: 'window-content';
				with: [
					html tableData
						colSpan: 2;
						with: content ] ]! !

!SSWindow methodsFor: 'accessing' stamp: 'pmm 8/26/2007 10:28'!
title: aString
	title := aString! !

!SSWindow methodsFor: 'updating' stamp: 'pmm 10/8/2007 06:44'!
updateRoot: html
	super updateRoot: html.
	html title: title! !

!WAComponent methodsFor: '*SqueakSource-View' stamp: 'pmm 9/2/2007 20:47'!
addTitle: aString
	self addDecoration: (SSHeadingDecoration message: aString)! !

!WAComponent methodsFor: '*SqueakSource-View' stamp: 'bf 1/7/2006 13:18'!
resetModel! !

Object subclass: #SSBareComponent
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Fake'!

!SSBareComponent class methodsFor: 'instance creation' stamp: 'lr 2/14/2004 13:14'!
session: aSession
	^self new
		setSession: aSession;
		yourself! !

!SSBareComponent methodsFor: 'rendering' stamp: 'pmm 8/30/2007 11:04'!
render
	| html |
	html := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root | 
			self updateRoot:root ];
		render: [ :canvas |
			self renderContentOn: canvas ].
	^WAResponse new
		contents: html;
		contentType: self session contentType;
		yourself! !

!SSBareComponent methodsFor: 'rendering' stamp: 'lr 1/29/2004 11:26'!
renderContentOn: html! !

!SSBareComponent methodsFor: 'accessing' stamp: 'bf 12/15/2005 19:24'!
repository
	^self session repository! !

!SSBareComponent methodsFor: 'accessing' stamp: 'lr 1/31/2004 22:43'!
session
	^session! !

!SSBareComponent methodsFor: 'initialization' stamp: 'lr 2/14/2004 13:14'!
setSession: aSession
	session := aSession! !

!SSBareComponent methodsFor: 'updating' stamp: 'pmm 8/30/2007 10:58'!
updateRoot: html
	"can be overridden by subclasses"! !

SSBareComponent subclass: #SSVersionListing
	instanceVariableNames: 'projects associations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Fake'!

SSVersionListing subclass: #SSBlessedVersionListing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Fake'!

!SSBlessedVersionListing methodsFor: 'rendering' stamp: 'avi 9/23/2004 22:46'!
renderProject: aProject version: aVersion on: html
	html anchorWithUrl: aVersion fileName do: aVersion package! !

!SSBlessedVersionListing methodsFor: 'testing' stamp: 'avi 9/23/2004 22:45'!
shouldRenderProject: aProject version: aVersion
	^ (super shouldRenderProject: aProject version: aVersion)
		and: [aProject isVersionBlessed: aVersion]
	! !

SSVersionListing subclass: #SSDirectoryListing
	instanceVariableNames: 'fakeZips'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Fake'!

!SSDirectoryListing class methodsFor: 'instance creation' stamp: 'pmm 10/8/2006 23:56'!
session: aSession project: aProject fakeZips: aBoolean
	^(super session: aSession project: aProject)
		fakeZips: aBoolean;
		yourself! !

!SSDirectoryListing methodsFor: 'accessing' stamp: 'pmm 10/8/2006 23:54'!
fakeZips
	^fakeZips! !

!SSDirectoryListing methodsFor: 'accessing' stamp: 'pmm 10/8/2006 23:54'!
fakeZips: aBoolean
	fakeZips := aBoolean! !

!SSDirectoryListing methodsFor: 'accessing' stamp: 'pmm 9/9/2007 12:49'!
homepageUrlText
	^self repository title , ' project page'! !

!SSDirectoryListing methodsFor: 'initialize-release' stamp: 'pmm 10/8/2006 23:54'!
initialize
	super initialize.
	self fakeZips: false! !

!SSDirectoryListing methodsFor: 'accessing' stamp: 'pmm 1/20/2006 11:34'!
project
	^self projects first! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'pmm 8/27/2007 10:41'!
render
	(self session currentRequest url endsWith: '/')
		ifFalse: [ self session redirectTo: self session currentRequest url , '/' ].
	^super render.! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'pmm 8/26/2007 11:15'!
renderConfigsOn: html

	projects do: [ :aProject |
		(aProject isMember: self session user allowedTo: SSAccessPolicy read)
			ifTrue: [ aProject configs do: [ :each |
				self renderProject: aProject config: each on: html ] ] ]! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'pmm 9/9/2007 12:49'!
renderContentOn: html
	html title: self title.
	html heading level1; with: self title.
	html anchor
		url: self project fullHomepageUrl;
		with: self homepageUrlText.
	html paragraph: [
		html withLineBreaks: self information ].
	super renderContentOn: html.
	self renderConfigsOn: html.! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'pmm 8/26/2007 11:16'!
renderProject: aProject config: aConfig on: html
	html anchor
		url: aConfig fileName;
		with: aConfig fileName.
	html break.
! !

!SSDirectoryListing methodsFor: 'rendering' stamp: 'pmm 8/26/2007 11:18'!
renderProject: aProject version: aVersion on: html
	| fileName |
	fileName := aVersion fileNameFaked: false.
	html anchor
		url: fileName;
		with: fileName.
	fileName := aVersion fileNameFaked: true.
	html anchor
		style: 'display: none';
		url: fileName;
		with: fileName.
	html break! !

SSVersionListing subclass: #SSRssListing
	instanceVariableNames: 'timezone'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Fake'!

!SSRssListing commentStamp: '<historical>' prior: 0!
http://blogs.law.harvard.edu/tech/rss!

!SSRssListing methodsFor: 'initialization' stamp: 'lr 3/19/2004 10:34'!
appendProject: aProject to: aStream
	super appendProject: aProject to: aStream.
	aProject feeds do: [ :feed |
		aStream nextPut: aProject -> feed ].! !

!SSRssListing methodsFor: 'accessing' stamp: 'lr 3/19/2004 10:34'!
associations
	^super associations
		first: (self defaultSize min: super associations size)! !

!SSRssListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 13:02'!
defaultSize
	^20! !

!SSRssListing methodsFor: 'rendering' stamp: 'pmm 9/5/2007 22:39'!
render
	| rss |
	rss := RRRssRenderCanvas builder
		fullDocument: true;
		render: [ :canvas |
			self renderContentOn: canvas ].
	^WAResponse
		document: rss
		mimeType: MIMEDocument contentTypeRss! !

!SSRssListing methodsFor: 'rendering' stamp: 'pmm 9/5/2007 23:03'!
renderContentOn: rss
	rss title: self title.
	rss description: [
		rss withLineBreaks: self information ].
	rss link: self url.
	rss generator: self repository title.
	rss webMaster: self superUserEmail.
	rss defaultDocumentation.
	super renderContentOn: rss! !

!SSRssListing methodsFor: 'rendering' stamp: 'pmm 9/9/2007 12:48'!
renderProject: aProject version: aVersionOrFeedEntry on: rss
	| author |
	rss item: [
		rss title: aVersionOrFeedEntry title.
		rss link: aProject fullHomepageUrl.
		rss description: [
			rss withLineBreaks: aVersionOrFeedEntry message ].
		
		rss publicationDate: (RRRfc822DateTime
			dateAndTime: aVersionOrFeedEntry timestamp
			timezoneString: self timezone).
		
		"author"
		author := aVersionOrFeedEntry author.
		(author notNil and: [ author hasRssAuthorString ]) ifTrue: [
			rss author: author fullEmailAddress ].

		"category"
		rss category: [
			rss text: aProject title.
			aProject tags do: [ :each |
				rss text: ', '.
				rss text: each name ] ].
		
		"enclosure"
		(aVersionOrFeedEntry isVersion and: [ aVersionOrFeedEntry size > 0 ]) ifTrue: [
			rss enclosure
				url: (aVersionOrFeedEntry url: aProject);
				length: aVersionOrFeedEntry size;
				type: MIMEDocument contentTypeMonticello ].
		
		"guid"
		aVersionOrFeedEntry hasGuid ifTrue: [
			rss guid
				beNoPermaLink;
				with: (aProject guidStringFor: aVersionOrFeedEntry) ] ]! !

!SSRssListing methodsFor: 'accessing' stamp: 'pmm 1/31/2006 20:29'!
superUserEmail
	^String streamContents: [ :stream |
		(self repository superUserEmail findTokens: ',')
			do: [ :each | stream nextPutAll: each withBlanksTrimmed ]
			separatedBy: [ stream nextPutAll: '; ' ] ]! !

!SSRssListing methodsFor: 'accessing' stamp: 'pmm 11/20/2006 12:41'!
timezone
	timezone isNil ifTrue: [
		timezone := self repository timezone ].
	^timezone! !

!SSRssListing methodsFor: 'path' stamp: 'pmm 9/5/2007 22:41'!
updateRoot: rss
	rss charSet: 'iso-8859-1'! !

!SSVersionListing class methodsFor: 'instance creation' stamp: 'pmm 9/11/2007 22:13'!
session: aSession project: aProject
	^self 
		session: aSession 
		projects: (Array with: aProject)! !

!SSVersionListing class methodsFor: 'instance creation' stamp: 'lr 2/14/2004 13:14'!
session: aSession projects: aCollection
	^(self session: aSession)
		setProjects: aCollection;
		yourself! !

!SSVersionListing methodsFor: 'initialization' stamp: 'lr 3/19/2004 09:50'!
appendProject: aProject to: aStream
	aProject versions do: [ :version |
		(self shouldRenderProject: aProject version: version)
			ifTrue: [ aStream nextPut: aProject -> version ] ]! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:05'!
associations
	^associations! !

!SSVersionListing methodsFor: 'accessing' stamp: 'SR 8/25/2007 17:49'!
information
	^self isOneProject
		ifTrue: [ self project information ]
		ifFalse: [ self title , ' all projects RSS feed' ]! !

!SSVersionListing methodsFor: 'testing' stamp: 'lr 2/14/2004 13:06'!
isOneProject
	^self projects size = 1! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:05'!
project
	^self projects anyOne! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/19/2004 12:05'!
projects
	^projects! !

!SSVersionListing methodsFor: 'rendering' stamp: 'lr 2/19/2004 12:06'!
renderContentOn: html
	self associations do: [ :assoc |
		self renderProject: assoc key version: assoc value on: html ]! !

!SSVersionListing methodsFor: 'rendering' stamp: 'lr 2/14/2004 13:01'!
renderProject: aProject version: aVersion on: html
	self subclassResponsiblity! !

!SSVersionListing methodsFor: 'initialization' stamp: 'pmm 8/26/2007 11:14'!
setProjects: aCollection
	projects := aCollection.
	associations := Array streamContents: [ :stream |
		projects do: [ :project |
			self appendProject: project to: stream ] ].
	associations sort: [ :x :y | x value timestamp > y value timestamp ].! !

!SSVersionListing methodsFor: 'testing' stamp: 'lr 2/14/2004 12:59'!
shouldRenderProject: aProject version: aVersion
	^aProject
		isMember: self session user
		allowedTo: SSAccessPolicy read 
		for: aVersion! !

!SSVersionListing methodsFor: 'accessing' stamp: 'lr 2/14/2004 13:08'!
title
	^self isOneProject
		ifTrue: [ self project title ]
		ifFalse: [ self repository title ]! !

!SSVersionListing methodsFor: 'accessing' stamp: 'pmm 8/26/2007 12:30'!
url
	^self repository rootUrl! !

Object subclass: #SSCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

SSCondition subclass: #SSAlphanumericCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSAlphanumericCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:35'!
isAbstract
	^false! !

!SSAlphanumericCondition methodsFor: 'evaluation' stamp: 'pmm 9/5/2007 19:35'!
value: aString
	^aString allSatisfy: [ :char | char isLetter or: [ char isDigit ] ]! !

!SSCondition methodsFor: 'evaluation' stamp: 'pmm 11/20/2007 14:34'!
numArgs
	"Answer the number of arguments that must be used to evaluate this condition."

	^ 1! !

!SSCondition methodsFor: 'evaluation' stamp: 'pmm 11/20/2007 14:30'!
value: anObject
	"Evaluate the receiver with the argument anObject. Answer a ==Boolean== telling if the condition is met for ==anObject==."

	self subclassResponsibility! !

SSCondition subclass: #SSPortCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSPortCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:36'!
isAbstract
	^false! !

!SSPortCondition methodsFor: 'evaluation' stamp: 'pmm 9/5/2007 19:37'!
value: aNumber
	^aNumber between: 1 and: 16rFFFF! !

SSCondition subclass: #SSSizeCondition
	instanceVariableNames: 'boundary comparator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSSizeCondition class methodsFor: 'instance-creation' stamp: 'pmm 9/2/2007 13:02'!
atLeast: anInteger
	^self new
		comparator: #>=;
		boundary: anInteger;
		yourself! !

!SSSizeCondition class methodsFor: 'instance-creation' stamp: 'pmm 9/2/2007 13:13'!
atMost: anInteger
	^self new
		comparator: #<=;
		boundary: anInteger;
		yourself! !

!SSSizeCondition class methodsFor: 'accessing-description' stamp: 'pmm 9/2/2007 13:00'!
descriptionBoundary
	^MANumberDescription new
		priority: 100;
		beInteger;
		beRequired;
		yourself! !

!SSSizeCondition class methodsFor: 'accessing-description' stamp: 'pmm 9/2/2007 13:00'!
descriptionComparator
	^MASymbolDescription new
		priority: 200;
		beRequired;
		yourself! !

!SSSizeCondition class methodsFor: 'testing' stamp: 'pmm 9/2/2007 13:12'!
isAbstract
	^false! !

!SSSizeCondition methodsFor: 'accessing' stamp: 'pmm 9/2/2007 12:57'!
boundary
	^boundary! !

!SSSizeCondition methodsFor: 'accessing' stamp: 'pmm 9/2/2007 12:58'!
boundary: anInteger
	boundary := anInteger! !

!SSSizeCondition methodsFor: 'accessing' stamp: 'pmm 9/2/2007 12:58'!
comparator
	^comparator! !

!SSSizeCondition methodsFor: 'accessing' stamp: 'pmm 9/2/2007 12:58'!
comparator: aSymbol
	comparator := aSymbol! !

!SSSizeCondition methodsFor: 'evaluation' stamp: 'pmm 9/2/2007 13:01'!
value: anObject
	^anObject size
		perform: self comparator
		with: self boundary! !

SSCondition subclass: #SSUniqueGroupIdCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSUniqueGroupIdCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:28'!
isAbstract
	^false! !

!SSUniqueGroupIdCondition methodsFor: 'evaluation' stamp: 'pmm 9/5/2007 19:29'!
value: anObject
	^SSRepository current isUniqueProjectId: anObject! !

SSCondition subclass: #SSUniqueMemberInitialsCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSUniqueMemberInitialsCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:25'!
isAbstract
	^false! !

!SSUniqueMemberInitialsCondition methodsFor: 'evaluation' stamp: 'pmm 9/5/2007 19:25'!
value: anObject
	^SSRepository current isUniqueMemberInitials: anObject! !

SSCondition subclass: #SSUniqueProjectIdCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSUniqueProjectIdCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:29'!
isAbstract
	^false! !

!SSUniqueProjectIdCondition methodsFor: 'evaluation' stamp: 'pmm 9/5/2007 19:29'!
value: anObject
	^SSRepository current isUniqueGroupId: anObject! !

SSCondition subclass: #SSYouAreMemberCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSYouAreMemberCondition class methodsFor: 'testing' stamp: 'pmm 9/5/2007 19:33'!
isAbstract
	^false! !

!SSYouAreMemberCondition methodsFor: 'evaluation' stamp: 'pmm 9/5/2007 19:34'!
value: admins
	| currentUser |
	currentUser := WACurrentSession value user.
	^currentUser isSuperUser
		or: [
			admins anySatisfy: [ :each |
				each isGroup
					ifTrue: [ each hasMember: currentUser ]
					ifFalse: [ each = currentUser ] ] ]! !

Object subclass: #SSFullnameReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSFullnameReference methodsFor: 'converting' stamp: 'pmm 9/2/2007 20:44'!
toString: anObject
	^anObject fullname! !

Object subclass: #SSModel
	instanceVariableNames: 'timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

SSModel subclass: #SSAccessPolicy
	instanceVariableNames: 'admins developers guests globalRight blessing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSAccessPolicy class methodsFor: 'action' stamp: 'al 1/31/2004 13:51'!
admin
	^#admin! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 2/2/2004 22:28'!
allowAllRead
	^#read! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 2/2/2004 22:28'!
allowAllWrite
	^#readAndWrite! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 2/2/2004 22:29'!
allowNothing
	^#noAccess! !

!SSAccessPolicy class methodsFor: 'action' stamp: 'avi 9/23/2004 15:36'!
bless
	^ #bless! !

!SSAccessPolicy class methodsFor: 'global rights' stamp: 'al 7/29/2004 10:12'!
globalRights
	^Array
		with: self allowAllRead
		with: self allowAllWrite
		with: self allowNothing! !

!SSAccessPolicy class methodsFor: 'migration' stamp: 'lr 2/27/2004 18:41'!
migrateGuests
	self allInstances do: [ :each |
		each guests isNil
			ifTrue: [ each guests: Set new ] ]! !

!SSAccessPolicy class methodsFor: 'action' stamp: 'al 1/31/2004 13:51'!
read
	^#read! !

!SSAccessPolicy class methodsFor: 'action' stamp: 'al 1/31/2004 13:51'!
write
	^#write! !

!SSAccessPolicy methodsFor: 'adding' stamp: 'lr 2/2/2004 13:23'!
addAdmin: aMember
	admins add: aMember! !

!SSAccessPolicy methodsFor: 'adding' stamp: 'lr 2/2/2004 13:23'!
addDeveloper: aMember
	developers add: aMember! !

!SSAccessPolicy methodsFor: 'adding' stamp: 'lr 2/27/2004 18:36'!
addGuest: aMember
	guests add: aMember! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:37'!
admins
	^admins! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:38'!
admins: aCollection
	admins := aCollection! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'lr 2/27/2004 18:55'!
allowAllRead
	^self allowAllWrite 
		or: [ globalRight = self class allowAllRead ]! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 2/7/2004 19:24'!
allowAllWrite
	^globalRight = self class allowAllWrite! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'avi 9/24/2004 10:26'!
canBless
	^ blessing ifNil: [false]! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'avi 9/24/2004 10:26'!
canBless: aBoolean
	blessing := aBoolean! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:37'!
developers
	^developers! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 1/31/2004 13:38'!
developers: aCollection
	developers := aCollection! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 2/2/2004 22:30'!
globalRight
	^globalRight! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'al 2/2/2004 22:30'!
globalRight: aSymbol
	globalRight := aSymbol! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'lr 2/27/2004 18:35'!
guests
	^guests! !

!SSAccessPolicy methodsFor: 'accessing' stamp: 'lr 2/27/2004 18:34'!
guests: aCollection
	guests := aCollection! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'bf 5/25/2005 10:59'!
hasMember: aMember
	^(self isMember: aMember in: self admins)
		or: [self isMember: aMember in: self developers]
		or: [self isMember: aMember in: self guests]
	
! !

!SSAccessPolicy methodsFor: 'initialization' stamp: 'al 7/29/2004 10:16'!
initialize
	super initialize.
	self developers: Set new.
	self admins: Set new.
	self guests: Set new.	
	self globalRight: self class allowAllRead.
! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'bf 5/24/2005 15:04'!
isMember: aMember allowedTo: aSymbol
	(aMember notNil and: [ aMember isSuperUser ])
		ifTrue: [ ^true ].
	aSymbol = self class read ifTrue: [
		^self allowAllRead
			or: [ self allowAllWrite ]
			or: [ self isMember: aMember in: self developers ]
			or: [ self isMember: aMember in: self admins ]
			or: [ self isMember: aMember in: self guests ] ].
	aSymbol = self class write ifTrue: [
		^self allowAllWrite
			or: [ self isMember: aMember in: self developers ]
			or: [ self isMember: aMember in: self admins ] ].
	aSymbol = self class admin ifTrue: [
		^self isMember: aMember in: self admins ].
	aSymbol = self class bless ifTrue: [
		^ self canBless and:
			[(self isMember: aMember in: self developers)	
				or: [self isMember: aMember in: self admins] ]].
	^self error: 'Action ', aSymbol, ' unknown'
				! !

!SSAccessPolicy methodsFor: 'testing' stamp: 'bf 5/24/2005 15:10'!
isMember: aMember in: aList
	^(aList includes: aMember)
		or: [(aList select: [:ea | ea isGroup])
				anySatisfy: [:group | group hasMember: aMember]]! !

SSModel subclass: #SSInstanceSideDescribedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

SSInstanceSideDescribedObject subclass: #SSFeedEntry
	instanceVariableNames: 'title message author'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:56'!
author
	^author! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:56'!
author: aMember
	author := aMember! !

!SSFeedEntry methodsFor: 'accessing-descriptions' stamp: 'pmm 9/1/2007 16:21'!
descriptionMessage
	^ MAMemoDescription new
		label: 'Message';
		selectorAccessor: #message;
		default: '';
		priority: 150;
		yourself! !

!SSFeedEntry methodsFor: 'accessing-descriptions' stamp: 'pmm 10/5/2007 07:02'!
descriptionTitle
	^ MAStringDescription new
		label: 'Title';
		selectorAccessor: #title;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Title must be less than 50 characters';
		priority: 100;
		beRequired;
		yourself! !

!SSFeedEntry methodsFor: 'testing' stamp: 'pmm 10/26/2006 21:19'!
hasGuid
	^false! !

!SSFeedEntry methodsFor: 'testing' stamp: 'pmm 10/9/2006 11:53'!
isVersion
	^false! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:55'!
message
	^message! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:55'!
message: aMessage
	message := aMessage! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:54'!
title
	^title! !

!SSFeedEntry methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:54'!
title: aString
	title := aString! !

!SSFeedEntry methodsFor: 'conveniance' stamp: 'pmm 9/9/2007 12:22'!
url: aProject
	^self repository rootUrl! !

SSInstanceSideDescribedObject subclass: #SSGroup
	instanceVariableNames: 'id fullname members'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSGroup methodsFor: 'accessing-descriptions' stamp: 'pmm 10/2/2007 21:33'!
descriptionIdentifier
	^ MAStringDescription new
		label: 'Id';
		selectorAccessor: #id;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Name must be less than 50 characters';
		addCondition: SSUniqueGroupIdCondition new labelled: 'this group already exists';
		priority: 100;
		beRequired;
		yourself! !

!SSGroup methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 20:39'!
descriptionMembers
	^ MAMultipleOptionDescription new
		selectorAccessor: #members;
		options: self repository members;
		reference: SSFullnameReference new;
		componentClass: SSListCompositonComponent;
		label: 'Members';
		priority: 300;
		beSorted;
		beDistinct;
		yourself! !

!SSGroup methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 06:58'!
descriptionName
	^ MAStringDescription new
		label: 'Name';
		selectorAccessor: #fullname;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Name must be less than 50 characters';
		priority: 200;
		beRequired;
		yourself! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:32'!
fullname
	^fullname! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:32'!
fullname: aString
	fullname := aString! !

!SSGroup methodsFor: 'accessing' stamp: 'pmm 6/21/2006 09:55'!
fullnameOrUnknown
	^self fullname! !

!SSGroup methodsFor: 'testing' stamp: 'bf 5/24/2005 15:11'!
hasMember: aMember
	^self members includes: aMember! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:32'!
id
	^id! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 14:33'!
id: aString
	id := aString! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 12/20/2005 00:40'!
initials
	^ self id
! !

!SSGroup methodsFor: 'testing' stamp: 'bf 5/24/2005 15:10'!
isGroup
	^true! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 16:52'!
members
	^members ifNil: [members := Set new]! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 16:52'!
members: someMembers
	members := someMembers! !

!SSGroup methodsFor: 'printing' stamp: 'bf 5/24/2005 16:17'!
printInitialsOn: aStream
	self members do: [:each | aStream nextPutAll: each initials]
		separatedBy: [aStream nextPutAll: ', '].
! !

!SSGroup methodsFor: 'printing' stamp: 'pmm 9/2/2007 20:49'!
printOn: aStream
	aStream 
		nextPutAll: '* ';
		nextPutAll: (self fullname ifNil: [ '' ]);
		nextPutAll: ' ('.
	self printInitialsOn: aStream.
	aStream nextPut: $)! !

!SSGroup methodsFor: 'accessing' stamp: 'bf 5/24/2005 18:22'!
title
	^self fullname! !

!SSGroup methodsFor: 'actions' stamp: 'bf 5/24/2005 18:08'!
view
	^ SSGroupView model: self! !

!SSInstanceSideDescribedObject methodsFor: 'accessing-description' stamp: 'pmm 10/2/2007 21:35'!
asRegisterComponent
	^self instanceSideDescription asComponentOn: self! !

!SSInstanceSideDescribedObject methodsFor: 'accessing-description' stamp: 'pmm 10/2/2007 21:33'!
description
	^self instanceSideDescription reject: [ :each |
		#(initials id) includes: each accessor selector ]! !

!SSInstanceSideDescribedObject methodsFor: 'accessing-description' stamp: 'pmm 10/2/2007 21:32'!
instanceSideDescription
	| description |
	description := super description copy.
	self class selectors do: [ :each |
		each isDescriptionSelector ifTrue: [
			description add: (self perform: each) ] ].
	^description! !

SSInstanceSideDescribedObject subclass: #SSMember
	instanceVariableNames: 'initials fullname passwordHash superuser email description cache'
	classVariableNames: 'AnonymousMember'
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSMember class methodsFor: 'instance creation' stamp: 'al 2/16/2004 19:23'!
anonymousMember
	^AnonymousMember
		ifNil: [ AnonymousMember := self new
			initials: String new;
			fullname: String new;
			yourself ]! !

!SSMember class methodsFor: 'cache' stamp: 'pmm 10/16/2006 12:50'!
cachedCommitCountKey
	^#commitCount! !

!SSMember class methodsFor: 'cache' stamp: 'pmm 10/16/2006 12:51'!
cachedProjectCountKey
	^#projectCount! !

!SSMember class methodsFor: 'instance creation' stamp: 'lr 2/2/2004 13:29'!
initials: aString
	^self new
		setInitials: aString;
		yourself! !

!SSMember methodsFor: 'comparing' stamp: 'pmm 7/3/2007 21:40'!
<= aMember
	^self fullname caseInsensitiveLessOrEqual: aMember fullname! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 10/11/2006 01:11'!
adminInProjects
	^self repository visibleProjectsSelect: [ :each |
		each admins includes: self ]! !

!SSMember methodsFor: 'private' stamp: 'lr 1/31/2004 19:49'!
buildHash: aString
	^SecureHashAlgorithm new
		hashMessage: aString! !

!SSMember methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 12:41'!
cache
	cache isNil ifTrue: [
		cache := IdentityDictionary new ].
	^cache! !

!SSMember methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 12:42'!
cachedCommitCount
	^self cache
		at: self class cachedCommitCountKey
		ifAbsentPut: [ self commitCount ]! !

!SSMember methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 12:43'!
cachedCommitCount: anInteger
	^self cache
		at: self class cachedCommitCountKey
		put: anInteger! !

!SSMember methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 12:51'!
cachedProjectCount
	^self cache
		at: self class cachedProjectCountKey
		ifAbsentPut: [ self projectCount ]! !

!SSMember methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 12:51'!
cachedProjectCount: anInteger
	^self cache
		at: self class cachedProjectCountKey
		put: anInteger! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 10/16/2006 12:01'!
commitCount
	| sum |
	sum := 0.
	self projectsDo: [ :each |
		sum := sum + (each numberOfCommitsBy: self) ].
	^sum! !

!SSMember methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:03'!
descriptionEmail
	^ MAStringDescription new
		label: 'E-mail';
		selectorAccessor: #email;
		priority: 400;
		yourself! !

!SSMember methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:03'!
descriptionInformation
	^ MAMemoDescription new
		label: 'Description';
		selectorAccessor: #information;
		priority: 600;
		yourself! !

!SSMember methodsFor: 'accessing-descriptions' stamp: 'pmm 10/2/2007 21:33'!
descriptionInitials
	^ MAStringDescription new
		label: 'Initials';
		selectorAccessor: #initials;
		addCondition: (self class defaultLengthAtMost: 5) labelled: 'Initials must not be longer than 5 characters';
		addCondition: SSUniqueMemberInitialsCondition new labelled: 'These initials already exist';
		priority: 200;
		beRequired;
		yourself! !

!SSMember methodsFor: 'accessing-descriptions' stamp: 'pmm 9/2/2007 20:56'!
descriptionName
	^ MAStringDescription new
		label: 'Name';
		selectorAccessor: #fullname;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Name must be less than 50 characters';
		priority: 100;
		beRequired;
		yourself! !

!SSMember methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:03'!
descriptionPassword
	^ MAPasswordDescription new
		label: 'Password';
		selectorAccessor: #password;
		addCondition: (self class defaultLengthAtLeast: 4) labelled: 'Password must have at least 4 characters';
		priority: 300;
		beRequired;
		yourself! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 10/11/2006 01:11'!
developerInProjects
	^self repository visibleProjectsSelect: [ :each |
		each developers includes: self ]! !

!SSMember methodsFor: 'accessing' stamp: 'lr 3/15/2004 19:55'!
email
	^email! !

!SSMember methodsFor: 'accessing' stamp: 'lr 3/15/2004 19:55'!
email: aString
	email := aString! !

!SSMember methodsFor: 'accessing' stamp: 'pmm 9/5/2007 22:54'!
fullEmailAddress
	^RREmailAddress
		address: self email
		username: self fullname! !

!SSMember methodsFor: 'accessing' stamp: 'lr 1/29/2004 10:50'!
fullname
	^fullname! !

!SSMember methodsFor: 'accessing' stamp: 'lr 1/29/2004 10:50'!
fullname: aString
	fullname := aString! !

!SSMember methodsFor: 'accessing' stamp: 'pmm 6/21/2006 09:55'!
fullnameOrUnknown
	^self fullname! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 9/9/2007 12:21'!
groups
	^self repository groups select: [ :each | 
		each hasMember: self]! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 10/11/2006 01:11'!
guestInProjects
	^self repository visibleProjectsSelect: [ :each |
		each guests includes: self ]! !

!SSMember methodsFor: 'testing' stamp: 'pmm 1/17/2006 21:46'!
hasRssAuthorString
	^self email isEmptyOrNil not! !

!SSMember methodsFor: 'accessing' stamp: 'SR 8/25/2007 17:51'!
information
	^description! !

!SSMember methodsFor: 'accessing' stamp: 'SR 8/25/2007 17:51'!
information: aString
	description := aString! !

!SSMember methodsFor: 'initialization' stamp: 'pmm 10/16/2006 12:41'!
initialize
	super initialize.
	superuser := false.
	cache := IdentityDictionary new.! !

!SSMember methodsFor: 'accessing' stamp: 'lr 1/26/2004 21:55'!
initials
	^initials! !

!SSMember methodsFor: 'accessing' stamp: 'al 2/3/2004 21:46'!
initials: aString
	self initials isEmptyOrNil ifFalse: [ ^self error: 'Member initials are immutable' ].
	initials := aString! !

!SSMember methodsFor: 'testing' stamp: 'bf 5/24/2005 15:10'!
isGroup
	^false! !

!SSMember methodsFor: 'testing' stamp: 'lr 1/31/2004 19:51'!
isPasswordValid: aString
	^(self buildHash: aString) = passwordHash! !

!SSMember methodsFor: 'testing' stamp: 'lr 2/6/2004 18:43'!
isSuperUser
	^superuser! !

!SSMember methodsFor: 'accessing' stamp: 'al 2/6/2004 21:23'!
password
	^passwordHash ifNotNil: ['****************']! !

!SSMember methodsFor: 'accessing' stamp: 'al 2/3/2004 21:45'!
password: aString
	aString = self password ifFalse: [
		passwordHash := self buildHash: aString ]! !

!SSMember methodsFor: 'printing' stamp: 'lr 2/7/2004 13:57'!
printOn: aStream
	aStream nextPutAll: self fullname.! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 10/16/2006 12:03'!
projectCount
	| count |
	count := 0.
	self projectsDo: [ :each |
		count := count + 1 ].
	^count! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 10/16/2006 13:10'!
projects
	^Array streamContents: [ :stream |
		self projectsDo: [ :each |
			stream nextPut: each ] ]! !

!SSMember methodsFor: 'conveniance' stamp: 'pmm 10/16/2006 12:00'!
projectsDo: aBlock
	^self repository projectsDo: [ :each |
		(each hasMember: self) ifTrue: [
			aBlock value: each ] ]! !

!SSMember methodsFor: 'initialization' stamp: 'lr 2/2/2004 13:27'!
setInitials: aString
	initials := aString! !

!SSMember methodsFor: 'testing' stamp: 'al 1/19/2006 15:23'!
stringsSatisfy: aBlock
	^(aBlock value: fullname) or: [
		aBlock value: initials ].! !

!SSMember methodsFor: 'accessing' stamp: 'lr 2/4/2004 23:52'!
superuser
	^superuser! !

!SSMember methodsFor: 'accessing' stamp: 'lr 2/4/2004 23:52'!
superuser: aBoolean
	superuser := aBoolean! !

!SSMember methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 12:52'!
udateCachedCommitCount
	^self cachedCommitCount: self commitCount! !

!SSMember methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 12:52'!
udateCachedProjectCount
	^self cachedProjectCount: self projectCount! !

!SSMember methodsFor: 'actions' stamp: 'bf 5/24/2005 18:08'!
view
	^ SSMemberView model: self! !

SSInstanceSideDescribedObject subclass: #SSProject
	instanceVariableNames: 'id title description creator accessPolicy versions dateCreated feeds wiki blessings configs tags cache license'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSProject class methodsFor: 'cache' stamp: 'pmm 10/16/2006 11:34'!
absoluteActivityKey
	^#absoluteActivity! !

!SSProject class methodsFor: 'instance creation' stamp: 'al 2/2/2004 22:36'!
creator: aMember
	^self new
		setCreator: aMember;
		yourself! !

!SSProject class methodsFor: 'cache' stamp: 'pmm 10/16/2006 13:09'!
downloadsKey
	^#downloads! !

!SSProject class methodsFor: 'cache' stamp: 'pmm 11/15/2006 11:48'!
numberOfNormalVersionsKey
	^#numberOfNormalVersions! !

!SSProject class methodsFor: 'cache' stamp: 'pmm 11/15/2006 11:48'!
numberOfReleasesKey
	^#numberOfReleases! !

!SSProject class methodsFor: 'cache' stamp: 'pmm 10/16/2006 11:34'!
relativeActivityKey
	^#relativeActivity! !

!SSProject methodsFor: 'comparing' stamp: 'lr 3/15/2004 16:44'!
<= anObject
	^self title <= anObject title! !

!SSProject methodsFor: 'accessing' stamp: 'al 1/31/2004 16:08'!
accessPolicy
	^accessPolicy! !

!SSProject methodsFor: 'accessing' stamp: 'al 1/31/2004 16:08'!
accessPolicy: anAccessPolicy
	accessPolicy := anAccessPolicy! !

!SSProject methodsFor: 'conveniance' stamp: 'pmm 10/16/2006 11:38'!
activity
	| activity |
	activity := 0.0.
	self versionsDo: [ :each |
		activity := activity + each activity ].
	^activity! !

!SSProject methodsFor: 'accessing-configs' stamp: 'bf 3/23/2006 14:14'!
addConfig: aString author: aUser url: anUrl
	| config |
	config := (MCMcmReader on: aString readStream fileName: anUrl) version.
	self fixConfig: config.
	^self configs at: config fileName put: config
! !

!SSProject methodsFor: 'accessing-versions' stamp: 'pmm 10/9/2007 22:38'!
addVersion: aString author: aUser
	| array version versionName |
	array := aString asByteArray.
	version := SSVersion 
		array: array 
		author: aUser.
	versionName := version fileName.
	(versions includesKey: versionName)
		ifTrue: [ SSVersionAlreadyExists raiseSignal: versionName ].
		
	SSRepository storage saveMonticello: array of: version to: self.
	^versions at: versionName put: version.
		! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 1/31/2004 16:45'!
adminNames
	^String streamContents: [ :stream |
		self admins 
			do: [ :each | stream nextPutAll: each initials ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 1/31/2004 16:44'!
admins
	^self accessPolicy admins! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/3/2004 21:06'!
admins: aCollection
	self accessPolicy admins: aCollection! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 21:50'!
allBlessedVersions
	^ self blessings keys asSortedCollection collect: [:ea | self blessedVersionForPackage: ea]! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 15:34'!
blessVersion: aVersion ifForbidden: errorBlock
	(self canBlessVersion: aVersion) ifFalse: [^ errorBlock value].
	(self blessedVersionListForPackage: aVersion package) addLast: aVersion! !

!SSProject methodsFor: 'accessing' stamp: 'pmm 3/1/2006 22:14'!
blessedVersionForPackage: aPackage
	| list |
	list := self blessedVersionListForPackage: aPackage.
	^ list isEmpty ifFalse: [list last]! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 15:49'!
blessedVersionListForPackage: aPackage
	^ self blessings at: aPackage ifAbsentPut: [OrderedCollection new]! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 15:28'!
blessings
	^ blessings ifNil: [blessings := Dictionary new]! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 11:22'!
cache
	cache isNil ifTrue: [
		cache := IdentityDictionary new ].
	^cache! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 11:38'!
cachedAbsoluteActivity
	^self cache
		at: self class absoluteActivityKey
		ifAbsentPut: [  self activity ]! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 11:36'!
cachedAbsoluteActivity: anInteger
	^self cache at: self class absoluteActivityKey put: anInteger! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 11:28'!
cachedDownloads
	^self cache
		at: self class downloadsKey
		ifAbsentPut: [ self numberOfTotalDownloads ]! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 11:27'!
cachedDownloads: anInteger
	^self cache at: self class downloadsKey put: anInteger! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 11/15/2006 11:49'!
cachedNumberOfNormalVersions
	^self cache
		at: self class numberOfNormalVersionsKey
		ifAbsentPut: [ self numberOfNormalVersions ]! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 11/15/2006 11:50'!
cachedNumberOfNormalVersions: anInteger
	^self cache at: self class numberOfNormalVersionsKey put: anInteger! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 11/15/2006 11:50'!
cachedNumberOfReleases
	^self cache
		at: self class numberOfReleasesKey
		ifAbsentPut: [ self numberOfReleases ]! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 11/15/2006 11:50'!
cachedNumberOfReleases: anInteger
	^self cache at: self class numberOfReleasesKey put: anInteger! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 13:08'!
cachedRelativeActivity
	^self cache
		at: self class relativeActivityKey
		ifAbsent: [ 0.0 ]! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 11:36'!
cachedRelativeActivity: anInteger
	^self cache at: self class relativeActivityKey put: anInteger! !

!SSProject methodsFor: 'accessing-policy' stamp: 'avi 9/24/2004 10:29'!
canBless
	^ self accessPolicy canBless! !

!SSProject methodsFor: 'accessing-policy' stamp: 'avi 9/24/2004 10:29'!
canBless: aBoolean
	self accessPolicy canBless: aBoolean! !

!SSProject methodsFor: 'testing' stamp: 'avi 9/23/2004 16:05'!
canBlessVersion: aVersion
	| previous |
	previous := self blessedVersionForPackage: aVersion package.
	^ previous isNil or: [aVersion hasAncestor: previous project: self]! !

!SSProject methodsFor: 'accessing-configs' stamp: 'bf 4/18/2005 18:45'!
configs
	^configs ifNil: [configs := Dictionary new].
! !

!SSProject methodsFor: 'statistics' stamp: 'pmm 11/15/2006 12:07'!
countVersions: aBlock
	| count |
	count := 0.
	self versionsDo: [ :each |
		(aBlock value: each)
			ifTrue: [ count := count + 1 ] ].
	^count! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/2/2004 13:13'!
creator
	^creator! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/2/2004 13:33'!
creatorName
	^self creator initials! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/3/2004 16:27'!
creators
	^Array with: creator! !

!SSProject methodsFor: 'accessing-defaults' stamp: 'SR 8/25/2007 17:04'!
defaultGlobalRights
	^ SSAccessPolicy globalRights collect: [ :each | each -> each asCapitalizedPhrase ]! !

!SSProject methodsFor: 'accessing-defaults' stamp: 'SR 8/25/2007 17:08'!
defaultLicenses
	^ self licenses collect: [ :each | each last -> each first ]! !

!SSProject methodsFor: 'accessing-defaults' stamp: 'SR 8/25/2007 17:08'!
defaultTags
	^ self repository tags collect: [ :each | each -> each name ]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'pmm 3/16/2006 17:25'!
deleteVersion: aVersion
	aVersion beDeleted! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'pmm 11/2/2007 22:49'!
descriptionAdmins
	^ MAMultipleOptionDescription new
		selectorAccessor: #admins;
		label: 'Admins';
		options: self repository members;
		priority: 800;
		reference: SSFullnameReference new;
		componentClass: SSListCompositonComponent;
		addCondition: SSYouAreMemberCondition new labelled: 'You can''t remove yourself from the list of administrators';
		beSorted;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:06'!
descriptionBlessing
	^ MABooleanDescription new
		label: 'Enable Bleessing';
		selectorAccessor: #canBless;
		priority: 600;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:06'!
descriptionDevelopers
	^ MAMultipleOptionDescription new
		selectorAccessor: #developers;
		label: 'Developers';
		options: self repository members;
		priority: 900;
		reference: SSFullnameReference new;
		componentClass: SSListCompositonComponent;
		beSorted;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:06'!
descriptionGlobalRight
	^ MASingleOptionDescription new
		selectorAccessor: #globalRight;
		label: 'Global Right';
		priority: 700;
		optionsAndLabels: self defaultGlobalRights;
		beRequired;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:07'!
descriptionGuests
	^ MAMultipleOptionDescription new
		selectorAccessor: #guests;
		label: 'Guests';
		priority: 1000;
		options: self repository members;
		reference: SSFullnameReference new;
		componentClass: SSListCompositonComponent;
		beSorted;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'pmm 10/8/2007 06:42'!
descriptionIdentifier
	^ MAStringDescription new
		label: 'Id';
		comment: 'used to construct the URL of the homepage';
		selectorAccessor: #id;
		addCondition: (self class defaultLengthAtMost: 20) labelled: 'Name must be not more than 20 characters';
		addCondition: SSAlphanumericCondition new labelled: 'identifier can only contain letters and digits';
		addCondition: SSUniqueProjectIdCondition new labelled: 'There is a project having this identifier';
		priority: 100;
		beRequired;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:05'!
descriptionInformation
	^ MAMemoDescription new
		label: 'Description';
		selectorAccessor: #information;
		priority: 300;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:10'!
descriptionLicense
	^ MASingleOptionDescription new
		selectorAccessor: #license;
		label: 'License';
		priority: 500;
		optionsAndLabels: self defaultLicenses;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:05'!
descriptionTags
	^ MAMultipleOptionDescription new
		selectorAccessor: #tags;
		label: 'Tags';
		priority: 400;
		optionsAndLabels: self defaultTags;
		componentClass: MACheckboxGroupComponent;
		yourself! !

!SSProject methodsFor: 'accessing-descriptions' stamp: 'pmm 9/17/2007 19:08'!
descriptionTitle
	^ MAStringDescription new
		label: 'Title';
		comment: 'the human readable title';
		selectorAccessor: #title;
		addCondition: (self class defaultLengthAtMost: 50) labelled: 'Title must be less than 50 characters';
		priority: 200;
		beRequired;
		yourself! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 1/31/2004 16:43'!
developerNames
	^String streamContents: [ :stream |
		self developers 
			do: [ :each | stream nextPutAll: each initials ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 1/31/2004 16:43'!
developers
	^self accessPolicy developers! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/3/2004 21:07'!
developers: aCollection
	self accessPolicy developers: aCollection! !

!SSProject methodsFor: 'accessing' stamp: 'lr 3/19/2004 09:57'!
feeds
	feeds isNil
		ifTrue: [ feeds := OrderedCollection new ].
	^feeds! !

!SSProject methodsFor: 'accessing-configs' stamp: 'bf 3/23/2006 14:17'!
fixConfig: aConfig
	"SSProject allInstancesDo: [:prj | prj configs do: [:cfg | prj fixConfig: cfg]]"
	aConfig repositories: (aConfig repositories collect: [:repo |
		repo class == MCHttpRepository
			ifTrue: [MCHttpRepository new location: repo description]
			ifFalse: [self flag: #todo. repo copy]]).
	^aConfig! !

!SSProject methodsFor: 'conveniance' stamp: 'pmm 9/9/2007 12:46'!
fullDirectoryUrl
	"http://www.squeaksource.com/Seaside"
	^self repository rootUrl, self id! !

!SSProject methodsFor: 'conveniance' stamp: 'pmm 9/9/2007 12:48'!
fullHomepageUrl
	"http://www.squeaksource.com/Seaside.html"
	^self fullDirectoryUrl, '.html'! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/2/2004 22:30'!
globalRight
	^self accessPolicy globalRight! !

!SSProject methodsFor: 'accessing-policy' stamp: 'al 2/2/2004 22:31'!
globalRight: aSymbol
	self accessPolicy globalRight: aSymbol! !

!SSProject methodsFor: 'accessing-policy' stamp: 'lr 2/27/2004 18:54'!
guestNames
	^String streamContents: [ :stream |
		self guests 
			do: [ :each | stream nextPutAll: each initials ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!SSProject methodsFor: 'accessing-policy' stamp: 'lr 2/27/2004 18:48'!
guests
	^self accessPolicy guests! !

!SSProject methodsFor: 'accessing-policy' stamp: 'lr 2/27/2004 18:48'!
guests: aCollection
	self accessPolicy guests: aCollection! !

!SSProject methodsFor: 'conveniance' stamp: 'pmm 9/11/2007 22:09'!
guidStringFor: aVersion
	^String streamContents: [ :stream |
		stream nextPutAll: 'mcz'.
		stream nextPutAll: (self fullDirectoryUrl allButFirst: 4). "replace http:// with mcz://"
		stream nextPut: $/.
		stream nextPutAll: aVersion versionInfo id displayString ]! !

!SSProject methodsFor: 'conveniance' stamp: 'bf 2/3/2006 11:51'!
hasConfigs
	^self configs isEmpty not! !

!SSProject methodsFor: 'testing' stamp: 'bf 5/25/2005 10:57'!
hasMember: aMember
	^self accessPolicy hasMember: aMember
! !

!SSProject methodsFor: 'conveniance' stamp: 'bf 2/3/2006 11:47'!
hasReleases
	^self versions 
		anySatisfy: [ :each | each isRelease ]! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:35'!
hasTag: aLabel
	^self tags includes: aLabel! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:37'!
hasTagNamed: aString
	^self tags anySatisfy: [ :each |
		each name = aString ]! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:52'!
hasTags
	^self tags isEmpty not! !

!SSProject methodsFor: 'accessing' stamp: 'lr 1/28/2004 23:03'!
id
	^id! !

!SSProject methodsFor: 'accessing' stamp: 'al 2/2/2004 22:52'!
id: aString
	id isEmptyOrNil ifFalse: [ self error: 'Cannot redefine id of a project' ].
	id := aString! !

!SSProject methodsFor: 'accessing-versions' stamp: 'bf 12/14/2004 12:39'!
importVersionsFromStorage
	SSRepository storage importVersionsFor: self! !

!SSProject methodsFor: 'accessing-versions' stamp: 'al 3/16/2006 15:01'!
includesVersionAt: aFileName
	"Takes deleted versions into account"
		
	^versions includesKey: aFileName! !

!SSProject methodsFor: 'accessing' stamp: 'SR 8/25/2007 17:45'!
information
	^information! !

!SSProject methodsFor: 'accessing' stamp: 'SR 8/25/2007 17:52'!
information: aString
	description := aString! !

!SSProject methodsFor: 'initialization' stamp: 'pmm 10/16/2006 11:21'!
initialize
	super initialize.
	id := title := description := String new.
	accessPolicy := SSAccessPolicy new.
	versions := Dictionary new.
	dateCreated := Date today.
	tags := SortedCollection new.
	cache := IdentityDictionary new! !

!SSProject methodsFor: 'testing' stamp: 'al 2/7/2004 20:02'!
isMember: aMember allowedTo: aSymbol
	^self accessPolicy isMember: aMember allowedTo: aSymbol! !

!SSProject methodsFor: 'testing' stamp: 'lr 2/7/2004 21:22'!
isMember: aMember allowedTo: aSymbol for: aVersion
	^(self isMember: aMember allowedTo: aSymbol)
		or: [ aVersion isRelease
		and: [ SSAccessPolicy read = aSymbol ] ]		! !

!SSProject methodsFor: 'testing' stamp: 'avi 9/23/2004 15:31'!
isVersionBlessed: aVersion
	^ (self blessedVersionForPackage: aVersion package) = aVersion! !

!SSProject methodsFor: 'accessing-versions' stamp: 'bf 3/18/2005 17:10'!
latestVersions
	| latest |
	latest := Dictionary new.
	self versions do: [:each |
		| last |
		last := -1.
		latest at: each packageName ifPresent: [:v | last := v packageVersion].
		each packageVersion > last
			ifTrue: [latest at: each packageName put: each]].
	^latest asSortedCollection
! !

!SSProject methodsFor: 'accessing' stamp: 'pmm 7/3/2007 07:31'!
license
	^license! !

!SSProject methodsFor: 'accessing' stamp: 'pmm 7/3/2007 07:31'!
license: aCollection
	license := aCollection! !

!SSProject methodsFor: 'accessing' stamp: 'pmm 9/17/2007 19:10'!
licenses
	^#(
		('MIT' 'http://www.opensource.org/licenses/mit-license.php')
		('BSD' 'http://www.opensource.org/licenses/bsd-license.php')
		('Squeak' 'http://www.squeak.org/SqueakLicense/')
		('GPLv2' 'http://www.opensource.org/licenses/gpl-license.php')
		('GPLv3' 'http://www.opensource.org/licenses/gpl-license.php')
		('WTFPL' 'http://sam.zoy.org/wtfpl/COPYING')
	)! !

!SSProject methodsFor: 'statistics' stamp: 'pmm 11/15/2006 12:07'!
numberOfCommitsBy: aMember
	^self countVersions: [ :each |
		each author = aMember ]! !

!SSProject methodsFor: 'statistics' stamp: 'pmm 11/15/2006 12:08'!
numberOfNormalVersions
	^self countVersions: [ :each |
		each isRelease not ]! !

!SSProject methodsFor: 'statistics' stamp: 'pmm 11/15/2006 12:08'!
numberOfReleases
	^self countVersions: [ :each |
		each isRelease ]! !

!SSProject methodsFor: 'statistics' stamp: 'pmm 10/16/2006 11:12'!
numberOfTotalDownloads
	| sum |
	sum := 0.
	self versionsDo: [ :each |
		sum := sum + each totalDownloads ].
	^sum! !

!SSProject methodsFor: 'printing' stamp: 'pmm 9/11/2007 22:18'!
printOn: aStream
	aStream nextPutAll: self title! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:36'!
reSortTags
	self tags reSort! !

!SSProject methodsFor: 'actions' stamp: 'pmm 10/23/2006 16:26'!
reinititalizeInfos
	self versionsDo: [ :each |
		each reinititalizeInfoFor: self ]! !

!SSProject methodsFor: 'conveniance' stamp: 'pmm 9/9/2007 12:50'!
relativeHomepageUrl
	"Seaside.html"
	^self id, '.html'! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/13/2004 12:34'!
releases
	^self versions 
		select: [ :each | each isRelease ]! !

!SSProject methodsFor: 'conveniance' stamp: 'lr 2/13/2004 12:35'!
releasesSorted
	^self releases
		asSortedCollection! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:36'!
removeTag: aTag
	self tags remove: aTag! !

!SSProject methodsFor: 'initialization' stamp: 'pmm 9/9/2007 12:01'!
setCreator: aMember
	self accessPolicy addAdmin: (creator := aMember).! !

!SSProject methodsFor: 'accessing-configs' stamp: 'bf 2/3/2006 13:41'!
sortedConfigs
	^self configs asSortedCollection: [:a :b | a name < b name].! !

!SSProject methodsFor: 'testing' stamp: 'pmm 10/26/2006 22:16'!
stringsSatisfy: aBlock
	^(aBlock value: title)
		or: [aBlock value: description]
		or: [self versionsDo: [ :any |
				(aBlock value: any versionInfo name)
					ifTrue: [ ^true ] ].
			false ].
! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:36'!
tags
	tags isNil ifTrue: [
		tags := SortedCollection new ].
	^tags! !

!SSProject methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:36'!
tags: aCollection
	tags := aCollection asSortedCollection! !

!SSProject methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:17'!
title
	^title! !

!SSProject methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:18'!
title: aString
	title := aString! !

!SSProject methodsFor: 'accessing' stamp: 'avi 9/23/2004 15:35'!
unblessVersion: aVersion
	(self blessedVersionListForPackage: aVersion package) remove: aVersion ifAbsent: []! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 13:07'!
updateCachedAbsoluteActivity
	^self cachedAbsoluteActivity: self activity! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 11:29'!
updateCachedDownloads
	^self cachedDownloads: self numberOfTotalDownloads! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 11/15/2006 11:51'!
updateCachedNumberOfNormalVersions
	^self cachedNumberOfNormalVersions: self numberOfNormalVersions! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 11/15/2006 11:51'!
updateCachedNumberOfReleases
	^self cachedNumberOfReleases: self numberOfReleases! !

!SSProject methodsFor: 'accessing-cache' stamp: 'pmm 10/16/2006 11:40'!
updateCachedRelativeActivity: maximumAbsoluteActivity
	^self cachedRelativeActivity: (self cachedAbsoluteActivity) / maximumAbsoluteActivity! !

!SSProject methodsFor: 'accessing-versions' stamp: 'lr 2/4/2004 17:52'!
versionAt: aFilename
	^self versionAt: aFilename ifAbsent: [ nil ]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'pmm 10/18/2006 21:56'!
versionAt: aFileName ifAbsent: aBlock
	| key |
	key := (aFileName endsWith: '.zip')
		ifTrue: [ (aFileName allButLast: 4), '.mcz'  ]
		ifFalse: [ aFileName ].
	^self versions
		at: key
		ifAbsent: aBlock! !

!SSProject methodsFor: 'accessing-versions' stamp: 'pmm 3/16/2006 17:25'!
versions
	^versions reject: [:each | each isDeleted ]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'pmm 10/16/2006 11:12'!
versionsDo: aBlock
	versions do: [ :each |
		each isDeleted ifFalse: [
			aBlock value: each ] ]! !

!SSProject methodsFor: 'accessing-versions' stamp: 'al 1/17/2006 16:26'!
versionsSorted
	^self versions 
		asSortedCollection! !

!SSProject methodsFor: 'actions' stamp: 'bf 5/24/2005 18:07'!
view
	^ SSProjectView model: self! !

!SSProject methodsFor: 'accessing' stamp: 'lr 3/27/2004 09:45'!
wiki
	wiki isNil 
		ifTrue: [ wiki := TWFolder new ].
	^wiki! !

SSInstanceSideDescribedObject subclass: #SSRepository
	instanceVariableNames: 'title members projects groups properties tags'
	classVariableNames: 'StatisticsThread Storage Statistics Current'
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

SSRepository class
	instanceVariableNames: 'cacheTread'!

SSRepository class
	instanceVariableNames: 'cacheTread'!

!SSRepository class methodsFor: 'accessing' stamp: 'lr 1/31/2004 20:09'!
current
	^Current! !

!SSRepository class methodsFor: 'private' stamp: 'Noury Bouraqadi 1/13/2006 10:25'!
defaultPort
	^8888! !

!SSRepository class methodsFor: 'private' stamp: 'SR 8/25/2007 17:46'!
defaultRepository
	| lukas adrian stef ss fpm traits |
	
	" member "
	lukas := (SSMember initials: 'lr')
		fullname: 'Lukas Renggli';
		superuser: true;
		password: 'p';
		yourself.
	adrian := (SSMember initials: 'al')
		fullname: 'Adrian Lienhard';
		password: 'p';
		yourself.
	stef := (SSMember initials: 'sd')
		fullname: 'Stephane Ducasse';
		password: 'p';
		yourself.

	" projects "
	ss := (SSProject creator: adrian)
		id: 'ss';
		title: 'SqueakSource';
		yourself.
	fpm := (SSProject creator: lukas)
		id: 'fpm';
		title: 'Functional Pattern Matching';
		yourself.
	traits := (SSProject creator: adrian)
		id: 'traits';
		title: 'Traits';
		information: 'Composable Units of Behavior';
		yourself.
		
	" policies "
	ss accessPolicy
		addAdmin: lukas;
		addDeveloper: stef.
	traits accessPolicy
		addDeveloper: stef.
		
	" repository "
	^SSRepository new
		title: 'SqueakSource (Alpha)';
		addMember: lukas;
		addMember: adrian;
		addMember: stef;
		addProject: ss;
		addProject: fpm;
		addProject: traits.! !

!SSRepository class methodsFor: 'private' stamp: 'pmm 9/11/2007 22:09'!
defaultRootUrl
	| hostName |
	hostName := NetNameResolver nameForAddress: (NetNameResolver localHostAddress) timeout: 5.
	hostName ifNil: [hostName := NetNameResolver localAddressString].
	^'http://', hostName, ':', self defaultPort displayString, '/'! !

!SSRepository class methodsFor: 'private' stamp: 'lr 1/31/2004 20:08'!
defaultStorage
	^SSFilesystem new! !

!SSRepository class methodsFor: 'initialization' stamp: 'lr 2/15/2004 17:02'!
initialize

	" -- initialize default repository -- "
	" Current := self defaultRepository.
	  RootUrl := self defaultRootUrl.
	  Storage := self defaultStorage. "

	" -- save the current repository -- "
	" self storage saveRepository: self current. "
	
	" -- load the last repository -- "
	" Current := self storage loadRepository. "
	
	" -- clear seaside caches -- "
	" WARegistry clearAllHandlers.
	  Smalltalk garbageCollect. "! !

!SSRepository class methodsFor: 'cache' stamp: 'pmm 10/16/2006 12:56'!
isCacheTreadRunning
	^cacheTread notNil! !

!SSRepository class methodsFor: 'statistics thread' stamp: 'al 7/26/2004 14:48'!
isStatisticsThreadRunning
	^StatisticsThread isNil not! !

!SSRepository class methodsFor: 'cache' stamp: 'pmm 10/23/2006 16:27'!
reinititalizeInfos
	"self reinititalizeInfos"
	self current reinititalizeInfos! !

!SSRepository class methodsFor: 'accessing' stamp: 'bf 12/15/2005 21:20'!
rootUrl
	^self current rootUrl! !

!SSRepository class methodsFor: 'startup' stamp: 'al 7/16/2007 16:20'!
shutDown
	"Smalltalk addToShutDownList: self"
	SSKom stop.
	self storage ifNotNilDo: [ :s | s shutdown ].
	"Current := nil."
	self stopCacheTread.
! !

!SSRepository class methodsFor: 'cache' stamp: 'pmm 9/1/2007 16:43'!
startCacheTread
	self isCacheTreadRunning ifTrue: [
		self stopCacheTread ].

	cacheTread := 
		[
			SeasidePlatformSupport doTransaction: [
				self updateCache.
				self updateStatistics ].
			(Delay forDuration: 1 day) wait.
		]	forkAt: Processor userBackgroundPriority
			named: 'Cache-Thread'! !

!SSRepository class methodsFor: 'statistics thread' stamp: 'al 7/26/2004 15:08'!
startStatisticsThread
	StatisticsThread isNil ifTrue: [
		StatisticsThread := [ [
			self current statistics calculate.
			Transcript show: '.'.
			(Delay forSeconds: 60 * 60) wait ] repeat ] fork.
		StatisticsThread priority: 60 ]! !

!SSRepository class methodsFor: 'startup' stamp: 'al 7/16/2007 16:21'!
startUp
	"Smalltalk removeFromStartUpList: self. Smalltalk addToStartUpList: self"
	
	"Current _ self storage loadRepository."
	self current ifNil: [ ^self ].
	
	self current projects do: [ :each |
		self storage importVersionsFor: (self current
			projectAt: each id) ].
	SSKom startOn: self defaultPort.
	self startCacheTread.! !

!SSRepository class methodsFor: 'cache' stamp: 'pmm 10/16/2006 12:57'!
stopCacheTread
	self isCacheTreadRunning ifFalse: [ ^self ].

	cacheTread terminate.
	cacheTread := nil! !

!SSRepository class methodsFor: 'statistics thread' stamp: 'al 7/26/2004 14:48'!
stopStatisticsThread
	StatisticsThread ifNotNil: [
		StatisticsThread terminate.
		StatisticsThread := nil ]! !

!SSRepository class methodsFor: 'accessing' stamp: 'lr 1/31/2004 20:09'!
storage
	^Storage! !

!SSRepository class methodsFor: 'cache' stamp: 'pmm 10/16/2006 12:53'!
updateCache
	"self updateCache"
	self current updateCache! !

!SSRepository class methodsFor: 'cache' stamp: 'pmm 10/26/2006 21:00'!
updateStatistics
	"self updateStatistics"
	self current statistics calculate! !

!SSRepository methodsFor: 'accessing-groups' stamp: 'bf 5/24/2005 14:36'!
addGroup: aGroup
	self groups. "init"
	groups at: aGroup id put: aGroup! !

!SSRepository methodsFor: 'accessing-members' stamp: 'lr 2/1/2004 18:40'!
addMember: aMember
	members at: aMember initials put: aMember! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:41'!
addProject: aProject
	projects at: aProject id put: aProject! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:34'!
addTag: aTag
	tags at: aTag name put: aTag! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 19:37'!
allProjectsVisible
	^self properties
		at: #allProjectsVisible
		ifAbsent: [true]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 19:38'!
allProjectsVisible: aBoolean
	^self properties
		at: #allProjectsVisible
		put: aBoolean! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 3/15/2006 21:41'!
allowCreateTag
	^self properties
		at: #allowCreateTag
		ifAbsent: [false]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 3/15/2006 21:43'!
allowCreateTag: aBoolean
	^self properties
		at: #allowCreateTag
		put: aBoolean! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 18:22'!
allowRegisterProject
	^self properties
		at: #allowRegisterProject
		ifAbsent: [true]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 18:23'!
allowRegisterProject: aBoolean
	^self properties
		at: #allowRegisterProject
		put: aBoolean! !

!SSRepository methodsFor: 'authentication' stamp: 'pmm 3/14/2006 18:13'!
authenticateUser: aUsername password: aPassword
	| user |
	user := self 
		memberAt: aUsername 
		ifAbsent: [ ^nil ].
	aPassword isEmpty
		ifTrue: [ ^nil ].
	^(user isPasswordValid: aPassword)
		ifTrue: [ user ]
		ifFalse: [ nil ].! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/19/2005 09:15'!
batchSize
	^self properties
		at: #batchSize
		ifAbsent: [20]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/19/2005 09:15'!
batchSize: anInteger
	^self properties
		at: #batchSize
		put: anInteger! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:34'!
createTagNamed: aString
	self addTag: (SSTag name: aString)! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:39'!
deleteTag: aTag
	self projectsDo: [ :each |
		(each hasTag: aTag) ifTrue: [
			each removeTag: aTag ] ].
	tags removeKey: aTag name! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/1/2007 16:24'!
descriptionBatchSize
	^ MANumberDescription  new
		label: 'Batch size for table reports';
		selectorAccessor: #batchSize;
		default: 20;
		priority: 450;
		addCondition: [ :each | each > 1 ] asCondition labelled: 'Batch size must be greater than 1';
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/13/2007 06:52'!
descriptionGoogleAnalysticsAccount
	^ MAStringDescription  new
		label: 'Google Analytics Account';
		selectorAccessor: #googleAnalyticsAccount;
		priority: 900;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/13/2007 06:52'!
descriptionIntroductionText
	^ MAMemoDescription  new
		label: 'Override home text';
		selectorAccessor: #introText;
		priority: 700;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/13/2007 06:57'!
descriptionLogo
	^ MAFileDescription  new
		kind: MAMemoryFileModel;
		label: 'logo';
		selectorAccessor: #logo;
		priority: 600;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/5/2007 19:37'!
descriptionPort
	^ MANumberDescription new
		label: 'Port';
		selectorAccessor: #port;
		priority: 150;
		addCondition: SSPortCondition new labelled: 'Invalid Port. Must be between 1 and 65535';
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/1/2007 16:24'!
descriptionProjectRegistration
	^ MABooleanDescription  new
		label: 'Everyone can register projects';
		selectorAccessor: #allowRegisterProject;
		default: true;
		priority: 350;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/1/2007 16:24'!
descriptionProjectVisibility
	^ MABooleanDescription  new
		label: 'Everyone can see all projects';
		selectorAccessor: #allProjectsVisible;
		default: true;
		priority: 300;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/1/2007 16:21'!
descriptionRootUrl
	^ MAStringDescription new
		label: 'Root URL';
		selectorAccessor: #rootUrl;
		priority: 100;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/1/2007 16:24'!
descriptionSmtpServer
	^ MAStringDescription new
		label: 'SMTP Server';
		selectorAccessor: #smtpServer;
		priority: 200;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/16/2007 21:49'!
descriptionStyleColor
	^ MAColorDescription  new
		label: 'Style color';
		selectorAccessor: #styleColor;
		componentClass: SSColorComponent;
		default: Color blue;
		priority: 500;
		addCondition: [ :each | each ~= Color white ] asCondition labelled: 'Color must not be white';
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/1/2007 16:24'!
descriptionSuperUserEmail
	^ MAStringDescription new
		label: 'Super User E-mail';
		selectorAccessor: #superUserEmail;
		priority: 250;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/1/2007 16:24'!
descriptionTagCreation
	^ MABooleanDescription  new
		label: 'Everyone can create tags';
		selectorAccessor: #allowCreateTag;
		default: true;
		priority: 400;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing-descriptions' stamp: 'pmm 9/13/2007 06:52'!
descriptionTimezone
	^ MAStringDescription  new
		label: 'Timezone';
		selectorAccessor: #timezone;
		priority: 800;
		beRequired;
		yourself! !

!SSRepository methodsFor: 'accessing' stamp: 'bf 7/28/2005 18:34'!
dirty
	^self properties at: #dirty ifAbsent: [false]! !

!SSRepository methodsFor: 'accessing' stamp: 'bf 7/28/2005 18:34'!
dirty: aBoolean
	^self properties at: #dirty put: aBoolean! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 1/20/2006 12:59'!
favicon
	^#(0 0 1 0 2 0 16 16 0 0 0 0 0 0 104 5 0 0 38 0 0 0 32 32 0 0 0 0 0 0 168 8 0 0 142 5 0 0 40 0 0 0 16 0 0 0 32 0 0 0 1 0 8 0 0 0 0 0 64 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 255 255 255 0 177 132 75 0 255 206 141 0 84 68 45 0 158 158 158 0 207 207 207 0 217 169 107 0 124 106 82 0 201 184 163 0 157 138 113 0 250 220 181 0 239 234 227 0 186 162 132 0 92 92 92 0 109 86 53 0 200 151 87 0 241 188 119 0 231 202 164 0 149 113 66 0 141 141 140 0 62 51 36 0 181 180 180 0 77 77 77 0 153 126 88 0 207 197 183 0 234 219 199 0 195 159 109 0 180 169 154 0 128 98 60 0 165 152 137 0 220 220 220 0 236 194 139 0 169 138 95 0 254 214 160 0 235 177 103 0 203 178 144 0 231 210 182 0 246 244 242 0 222 164 90 0 192 192 192 0 113 94 69 0 139 116 84 0 226 184 129 0 163 122 68 0 251 197 128 0 186 150 99 0 219 201 176 0 222 215 205 0 189 139 75 0 242 227 207 0 210 160 95 0 140 104 58 0 180 141 88 0 223 179 117 0 192 174 151 0 210 193 171 0 74 61 42 0 228 228 227 0 174 145 104 0 158 146 129 0 199 199 199 0 245 203 147 0 200 165 118 0 119 92 55 0 167 130 81 0 173 159 139 0 231 198 154 0 178 156 128 0 247 215 172 0 141 113 74 0 129 104 73 0 186 154 111 0 242 193 130 0 209 164 104 0 177 128 66 0 195 145 81 0 179 164 145 0 227 172 101 0 103 86 60 0 214 212 210 0 216 174 119 0 251 250 249 0 175 135 83 0 186 174 158 0 151 120 82 0 112 91 60 0 255 211 152 0 147 125 94 0 192 171 143 0 209 201 190 0 163 134 91 0 251 201 136 0 243 198 138 0 197 179 155 0 158 142 120 0 185 166 139 0 117 97 62 0 199 187 170 0 202 161 106 0 156 116 65 0 148 116 73 0 221 174 111 0 127 110 87 0 174 164 150 0 204 157 97 0 125 100 69 0 154 154 154 0 144 109 64 0 186 171 151 0 239 224 202 0 255 202 131 0 221 217 211 0 215 197 173 0 231 177 108 0 251 195 122 0 172 141 100 0 241 241 241 0 123 97 63 0 181 138 83 0 204 204 203 0 184 136 75 0 230 226 222 0 135 102 60 0 157 130 89 0 237 188 123 0 246 201 142 0 226 218 207 0 247 218 177 0 255 209 147 0 241 186 114 0 169 157 142 0 179 162 140 0 195 161 114 0 195 195 195 0 206 194 179 0 172 156 135 0 145 141 137 0 107 82 51 0 245 196 132 0 243 191 122 0 212 163 98 0 149 124 89 0 231 173 99 0 246 246 246 0 255 200 127 0 153 124 82 0 144 112 71 0 239 194 133 0 192 156 110 0 111 90 64 0 136 101 56 0 139 105 62 0 228 198 157 0 205 156 93 0 253 252 252 0 242 192 126 0 255 216 163 0 146 115 76 0 254 203 137 0 252 200 132 0 222 213 202 0 169 130 78 0 248 248 248 0 240 225 205 0 242 199 141 0 189 175 157 0 132 101 60 0 255 212 155 0 255 207 144 0 237 194 136 0 86 70 46 0 240 236 229 0 255 202 134 0 247 205 148 0 234 193 137 0 233 175 100 0 227 186 131 0 167 152 135 0 233 218 197 0 154 125 84 0 218 175 118 0 63 51 34 0 121 92 56 0 250 219 179 0 142 111 71 0 231 209 180 0 255 200 130 0 238 195 139 0 174 157 135 0 187 166 139 0 254 254 254 0 142 114 73 0 147 115 74 0 254 206 143 0 242 197 137 0 202 185 164 0 181 168 153 0 253 253 253 0 241 227 206 0 255 214 159 0 142 141 141 0 175 136 84 0 144 141 138 0 237 194 138 0 235 194 137 0 234 194 138 0 220 174 110 0 194 158 109 0 255 211 153 0 255 209 148 0 252 200 133 0 252 200 131 0 246 201 141 0 194 145 81 0 234 193 138 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 117 40 107 20 201 5 61 144 1 1 1 1 1 1 198 134 137 84 47 37 186 113 28 203 6 1 1 1 1 191 22 77 67 204 93 126 213 195 32 153 131 134 1 1 1 120 96 177 156 92 194 129 169 159 45 17 43 189 31 1 163 66 181 7 212 3 210 87 210 3 173 140 105 81 104 198 80 149 29 53 70 180 116 215 205 124 146 192 65 123 72 58 98 162 152 15 97 86 79 21 57 182 4 171 64 151 119 90 89 16 114 74 46 208 59 174 175 91 54 207 130 176 214 196 13 76 35 202 145 99 23 63 24 14 125 102 141 143 49 94 190 121 78 101 187 139 42 165 170 33 111 115 19 39 75 9 135 44 51 193 160 27 206 168 209 133 148 211 185 154 100 48 38 147 83 158 188 88 34 157 200 62 142 73 167 2 85 155 1 166 108 150 95 18 128 11 184 69 36 68 138 52 25 1 1 155 10 118 56 26 164 50 199 110 179 55 183 136 1 1 1 1 82 178 71 109 127 172 12 161 132 106 197 191 1 1 1 1 1 1 112 60 8 41 41 103 30 122 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 40 0 0 0 32 0 0 0 64 0 0 0 1 0 8 0 0 0 0 0 128 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 255 255 255 0 180 131 67 0 255 209 136 0 85 69 47 0 171 171 171 0 222 213 202 0 117 108 95 0 208 168 114 0 158 137 112 0 126 90 45 0 214 190 159 0 254 221 173 0 209 152 79 0 230 231 233 0 192 192 191 0 180 161 137 0 147 118 76 0 244 187 112 0 150 148 147 0 186 150 103 0 232 191 137 0 227 170 97 0 126 101 69 0 245 230 211 0 227 206 178 0 99 82 58 0 193 178 161 0 140 123 99 0 245 207 156 0 251 244 234 0 160 131 91 0 201 173 135 0 240 219 189 0 143 107 60 0 104 96 84 0 186 142 85 0 166 161 156 0 217 218 219 0 160 148 130 0 219 180 128 0 205 204 203 0 159 118 65 0 206 193 176 0 176 150 116 0 189 159 118 0 114 91 61 0 113 80 38 0 252 196 125 0 207 161 101 0 169 140 101 0 255 218 158 0 224 176 114 0 166 126 75 0 243 214 173 0 206 181 147 0 188 169 145 0 193 139 70 0 195 186 175 0 232 227 218 0 247 202 142 0 216 206 193 0 219 162 88 0 240 240 240 0 133 115 90 0 226 198 162 0 219 189 147 0 145 130 109 0 176 135 83 0 238 189 126 0 177 169 159 0 234 178 105 0 193 150 92 0 195 159 109 0 181 179 178 0 124 107 83 0 137 113 81 0 147 122 89 0 229 184 121 0 113 84 49 0 127 98 59 0 215 168 105 0 192 166 131 0 248 248 248 0 93 76 52 0 230 220 206 0 203 146 72 0 255 210 147 0 180 166 147 0 229 213 191 0 202 198 193 0 198 184 165 0 151 114 65 0 151 129 100 0 207 173 126 0 239 231 221 0 216 198 176 0 198 162 116 0 212 212 211 0 181 157 126 0 249 226 195 0 213 182 141 0 248 213 165 0 225 226 228 0 203 155 91 0 226 187 134 0 189 180 168 0 178 140 89 0 189 186 185 0 197 190 180 0 251 201 136 0 154 124 83 0 165 152 137 0 197 176 148 0 246 240 232 0 238 223 201 0 166 122 65 0 164 145 121 0 250 220 180 0 185 138 77 0 187 146 94 0 164 129 81 0 214 174 121 0 136 103 60 0 142 108 65 0 234 202 157 0 196 155 100 0 184 171 154 0 199 169 128 0 194 145 83 0 160 159 158 0 180 150 110 0 216 209 201 0 118 97 65 0 155 119 74 0 173 140 96 0 179 172 165 0 167 143 110 0 203 164 110 0 188 155 109 0 120 90 51 0 201 200 201 0 209 197 181 0 220 177 121 0 141 118 89 0 146 144 143 0 200 180 155 0 212 178 134 0 255 218 166 0 244 191 119 0 203 150 82 0 167 150 127 0 234 230 226 0 143 117 83 0 209 189 165 0 174 144 101 0 133 107 75 0 230 208 180 0 144 123 96 0 171 131 79 0 234 183 115 0 222 171 105 0 172 163 151 0 188 161 126 0 238 229 214 0 205 178 142 0 233 217 196 0 222 207 190 0 152 132 107 0 187 176 161 0 237 236 235 0 239 196 138 0 228 220 212 0 255 213 154 0 152 127 93 0 255 214 142 0 254 206 140 0 247 204 147 0 210 193 171 0 187 166 138 0 222 204 181 0 224 193 151 0 110 98 81 0 215 162 93 0 195 174 144 0 121 103 79 0 242 226 205 0 134 118 95 0 140 125 105 0 224 168 96 0 127 101 63 0 226 224 222 0 254 202 129 0 200 150 87 0 236 233 228 0 219 214 207 0 158 131 98 0 215 170 108 0 78 64 42 0 222 202 174 0 212 155 83 0 176 175 174 0 189 150 97 0 244 241 238 0 213 207 198 0 248 198 130 0 231 194 144 0 128 105 75 0 121 108 90 0 244 209 163 0 199 197 195 0 211 200 187 0 238 197 143 0 191 146 88 0 204 189 170 0 234 188 128 0 201 159 103 0 174 159 138 0 97 79 53 0 246 238 226 0 244 245 245 0 120 95 58 0 147 109 61 0 209 209 211 0 147 120 81 0 245 193 125 0 204 195 183 0 202 157 96 0 205 168 120 0 214 173 116 0 196 165 125 0 252 252 251 0 124 93 52 0 231 224 214 0 199 194 187 0 209 159 93 0 181 177 172 0 227 183 123 0 190 174 153 0 246 223 192 0 160 125 80 0 185 135 71 0 241 201 145 0 183 139 83 0 181 147 102 0 216 166 99 0 217 190 154 0 221 184 134 0 173 151 121 0 177 161 142 0 182 165 144 0 187 163 132 0 192 169 139 0 228 215 199 0 220 210 196 0 165 139 103 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 1 1 231 220 14 98 15 5 130 19 145 145 19 19 130 201 210 38 170 83 231 1 1 1 1 1 1 0 1 1 1 1 1 1 83 103 223 210 90 234 109 109 58 58 58 109 109 234 210 141 223 14 1 1 1 1 1 1 1 0 1 1 1 1 1 14 41 201 37 162 27 178 199 25 157 157 157 25 96 214 169 162 37 74 98 63 1 1 1 1 1 0 1 1 1 63 38 15 136 162 16 252 55 181 125 209 209 102 209 209 125 66 165 179 249 162 236 141 103 220 1 1 1 0 1 1 231 38 108 70 250 113 66 206 21 171 60 60 177 177 177 60 171 171 21 206 66 184 88 136 210 103 1 1 1 0 1 1 170 210 70 16 32 105 171 60 110 110 110 110 176 176 176 110 110 205 205 110 171 247 128 249 136 41 220 1 1 0 231 231 98 106 56 128 40 69 205 110 176 176 176 87 87 87 176 176 176 110 192 48 225 69 143 230 250 58 191 1 1 0 83 63 109 56 94 143 78 225 192 3 175 87 87 173 173 87 87 87 87 176 3 192 48 160 52 8 128 238 90 220 231 0 63 59 238 45 138 81 197 160 225 205 110 60 87 87 173 173 87 87 110 110 205 225 160 161 49 49 138 163 27 152 220 0 191 253 82 135 68 213 227 216 216 138 8 122 40 212 173 51 87 171 122 8 8 138 126 72 36 243 107 135 179 85 170 0 132 180 45 134 124 134 121 121 17 17 111 31 155 97 40 105 40 139 31 224 224 17 17 134 134 92 124 134 45 89 191 0 226 11 244 222 232 221 190 190 46 46 133 133 23 207 156 76 76 133 218 84 218 84 218 46 80 232 232 222 20 199 132 0 91 165 107 42 34 80 221 221 133 133 133 133 46 26 84 84 84 4 198 4 84 84 218 46 80 123 34 42 120 246 142 0 113 94 213 119 243 68 240 17 17 224 224 224 153 153 77 77 153 23 46 23 17 17 17 121 68 243 119 241 72 101 214 0 252 94 227 183 161 81 227 202 202 20 20 50 255 45 247 21 94 155 31 135 138 197 197 161 71 71 189 13 104 147 146 0 251 228 235 22 71 161 49 197 52 52 73 93 28 44 105 21 97 93 28 131 78 225 160 160 18 18 71 62 104 94 113 0 163 97 104 62 22 104 213 81 225 225 138 64 35 28 97 8 50 208 7 137 78 225 160 81 245 22 22 200 193 94 113 0 99 97 193 62 189 213 68 49 48 3 143 77 182 158 228 143 139 158 187 131 69 192 160 227 36 193 62 13 129 228 113 0 251 97 213 200 183 243 121 126 205 3 215 244 174 131 21 60 105 139 155 138 205 3 149 72 53 119 200 86 119 128 146 0 56 230 36 150 235 68 240 126 225 205 237 138 97 40 177 51 177 122 73 229 110 175 225 202 134 159 150 57 68 32 214 0 214 32 68 119 193 68 240 216 69 237 138 228 105 177 173 51 87 105 228 8 215 110 225 126 134 53 129 2 159 55 61 0 6 146 121 116 243 121 121 138 215 8 155 97 177 51 51 51 173 242 40 97 73 237 69 126 134 134 119 116 121 154 59 0 194 96 31 92 53 134 111 139 40 45 137 128 29 148 148 148 148 173 212 45 50 97 143 202 124 222 116 42 50 167 203 0 220 85 248 134 92 123 156 196 45 163 82 66 102 12 12 148 148 148 29 32 44 45 97 31 80 10 222 240 179 95 231 0 231 114 91 255 124 140 46 64 151 113 65 54 118 118 118 118 118 118 54 65 55 184 99 144 79 47 124 44 211 231 231 0 1 231 233 250 153 79 46 28 88 180 33 100 239 239 239 239 239 239 239 33 157 178 250 144 79 79 77 27 194 1 1 0 1 1 231 211 117 207 23 93 238 180 166 186 186 24 24 24 24 24 186 115 89 178 16 77 23 76 217 132 231 1 1 0 1 1 1 194 226 151 158 144 137 56 142 85 95 114 30 30 30 219 164 253 178 16 93 76 93 249 204 170 1 1 1 0 1 1 1 1 83 132 88 168 93 117 238 142 6 233 59 95 59 172 254 43 56 9 158 9 169 172 231 1 1 1 1 0 1 1 1 1 1 1 152 142 238 250 88 88 127 127 127 127 127 127 127 88 250 250 27 61 114 1 1 1 1 1 1 0 1 1 1 1 1 1 83 152 204 169 39 188 64 75 185 185 185 75 187 67 112 58 195 170 231 1 1 1 1 1 1 0 255 255 255 255 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1 0 0 0 1) asByteArray! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 1/23/2006 22:37'!
faviconFilename
	^'favicon.ico'! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 1/20/2006 12:58'!
faviconMimeType
	^'image/x-icon'! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 2/4/2007 14:44'!
googleAnalyticsAccount
	^self properties
		at: #googleAnalyticsAccount
		ifAbsentPut: [ 'UA-892707-1' ]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 2/4/2007 14:44'!
googleAnalyticsAccount: aString
	self properties
		at: #googleAnalyticsAccount
		put: aString! !

!SSRepository methodsFor: 'accessing-groups' stamp: 'bf 5/24/2005 13:52'!
groups
	groups ifNil: [groups := Dictionary new].
	^groups values! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 23:31'!
hasTagNamed: aString
	^tags includesKey: aString asSymbol! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 10/26/2006 06:50'!
host
	"like host url but without http:// and trailing slash"
	^(self rootUrl allButFirst: 7) "remove http://"
		copyUpTo: $/! !

!SSRepository methodsFor: 'initialization' stamp: 'pmm 1/24/2006 20:25'!
initialize
	super initialize.
	title := String new.
	members := Dictionary new.
	groups := Dictionary new.
	projects := Dictionary new.
	labels := Dictionary new.
	Statistics := SSStatistics model: self! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 19:17'!
introText
	^self properties
		at: #introText
		ifAbsent: [String new]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 19:15'!
introText: aString
	^self properties
		at: #introText
		put: aString! !

!SSRepository methodsFor: 'testing' stamp: 'bf 5/24/2005 14:26'!
isUniqueGroupId: aString
	^self groups 
		allSatisfy: [ :each | each id ~= aString ]! !

!SSRepository methodsFor: 'testing' stamp: 'lr 2/6/2004 17:28'!
isUniqueMemberInitials: aString
	^self members 
		allSatisfy: [ :each | each initials ~= aString ]! !

!SSRepository methodsFor: 'testing' stamp: 'pmm 10/8/2007 06:56'!
isUniqueProjectId: aString
	^((#('files' 'home' 'projects'  'tags' 'members' 'groups' 'help' 'search') includes: aString) not)
		and: [ self projects  allSatisfy: [ :each | each id ~= aString ] ]! !

!SSRepository methodsFor: 'testing' stamp: 'pmm 8/25/2007 17:56'!
isVisible: aProject
	^self allProjectsVisible
		or: [ aProject isMember: self session user allowedTo: SSAccessPolicy read ]! !

!SSRepository methodsFor: 'accessing' stamp: 'pmm 9/13/2007 06:53'!
logo
	^SSFileLibrary logoFileModel! !

!SSRepository methodsFor: 'accessing' stamp: 'pmm 9/13/2007 06:54'!
logo: aMAMemoryFileModel
	^SSFileLibrary logoFileModel: aMAMemoryFileModel! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'bf 5/25/2005 11:35'!
maxActivity
	^self visibleProjects
		inject: 1.0
		into: [ :result :each | result max: each activity ]! !

!SSRepository methodsFor: 'accessing-members' stamp: 'lr 2/1/2004 18:40'!
memberAt: aString
	^self memberAt: aString ifAbsent: [ nil ]! !

!SSRepository methodsFor: 'accessing-members' stamp: 'lr 2/1/2004 18:40'!
memberAt: aString ifAbsent: aBlock
	^members at: aString ifAbsent: aBlock! !

!SSRepository methodsFor: 'accessing-members' stamp: 'lr 2/1/2004 18:40'!
members
	^members values! !

!SSRepository methodsFor: 'accessing-members' stamp: 'al 3/1/2004 21:52'!
membersCount
	^members size! !

!SSRepository methodsFor: 'accessing-members' stamp: 'pmm 10/16/2006 12:44'!
membersDo: aBlock
	members valuesDo: aBlock! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 22:05'!
port
	^self properties
		at: #port
		ifAbsent: [8888]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 22:05'!
port: anInteger
	^self properties
		at: #port
		put: anInteger! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:40'!
projectAt: aString
	^self projectAt: aString ifAbsent: [ nil ]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:40'!
projectAt: aString ifAbsent: aBlock
	^projects at: aString ifAbsent: aBlock! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'lr 2/1/2004 18:40'!
projects
	^projects values! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'al 3/1/2004 21:52'!
projectsCount
	^projects size! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'pmm 1/26/2006 21:38'!
projectsDo: aBlock
	projects valuesDo: aBlock! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'pmm 10/16/2006 11:58'!
projectsSelect: aBlock
	^Array streamContents: [ :stream |
		self projectsDo: [ :each |
			(aBlock value: each) ifTrue: [
				stream nextPut: each ] ] ]! !

!SSRepository methodsFor: 'accessing-properties' stamp: 'bf 7/28/2005 18:33'!
properties
	^ properties ifNil: [properties := Dictionary new]! !

!SSRepository methodsFor: 'actions' stamp: 'pmm 10/23/2006 16:27'!
reinititalizeInfos
	self projectsDo: [ :each |
		each reinititalizeInfos.
		Smalltalk garbageCollectMost ]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'al 2/27/2004 18:58'!
removeProject: aProject
	projects removeKey: aProject id! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:37'!
renameTag: aTag to: aString
	| oldName |
	oldName := aTag name.
	aTag name: aString.
	self projectsDo: [ :each |
		(each hasTagNamed: aString) ifTrue: [
			each reSortTags ] ].
	tags removeKey: oldName.	
	self addTag: aTag! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'al 1/23/2006 21:33'!
rootUrl
	^self properties
		at: #rootUrl
		ifAbsent: [self class defaultRootUrl]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 21:23'!
rootUrl: aString
	^self properties
		at: #rootUrl
		put: aString! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 21:50'!
smtpServer
	^self properties
		at: #smtpServer
		ifAbsent: ['haegar.unibe.ch']! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 21:15'!
smtpServer: aString
	^self properties
		at: #smtpServer
		put: aString! !

!SSRepository methodsFor: 'accessing-members' stamp: 'pmm 7/3/2007 21:36'!
sortedMembers
	^self members asSortedCollection ! !

!SSRepository methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:58'!
statistics
	^Statistics ifNil: [Statistics := SSStatistics model: self]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 9/16/2007 21:42'!
styleColor
	^SSFileLibrary default styleColor! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 9/16/2007 21:42'!
styleColor: aColor
	^SSFileLibrary default styleColor: aColor! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 18:42'!
superUserEmail
	^self properties
		at: #superUserEmail
		ifAbsent: [String streamContents: [:strm |
			self members do: [:ea |
				ea isSuperUser ifTrue: [
					strm nextPutAll: ea email; nextPut: $,]].
			strm skip: -1]]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'bf 12/15/2005 18:43'!
superUserEmail: aStringWithCommas
	^self properties
		at: #superUserEmail
		put: aStringWithCommas! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:49'!
tagActiviy
	| activity |
	activity := Bag new.
	self projectsDo: [ :project |
		project tags do: [ :each |
			activity add: each ] ].
	^activity! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:50'!
tagAt: aString
	^tags at: aString! !

!SSRepository methodsFor: 'accessing-tags' stamp: 'pmm 3/15/2006 21:38'!
tags
	tags isNil ifTrue: [
		tags := Dictionary new.
		SSTag defaultInstances do: [ :each |
			self addTag: each ] ].
	^tags asSortedCollection! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 11/20/2006 12:47'!
timezone
	^self properties
		at: #timezone
		ifAbsent: [ '+0100' ]! !

!SSRepository methodsFor: 'accessing-settings' stamp: 'pmm 11/20/2006 12:34'!
timezone: aString
	self properties
		at: #timezone
		put: aString! !

!SSRepository methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:09'!
title
	^title! !

!SSRepository methodsFor: 'accessing' stamp: 'lr 1/27/2004 11:13'!
title: aString
	title := aString! !

!SSRepository methodsFor: 'actions' stamp: 'pmm 11/15/2006 11:53'!
updateCache
	| maxActivity |
	maxActivity := 0.
	self projectsDo: [ :each |
		each updateCachedDownloads.
		each updateCachedNumberOfNormalVersions.
		each updateCachedNumberOfReleases.
		maxActivity := maxActivity max: each updateCachedAbsoluteActivity.
		Processor yield ].
	self projectsDo: [ :each |
		each updateCachedRelativeActivity: maxActivity.
		Processor yield ].

	self membersDo: [ :each |
		each cachedCommitCount.
		each udateCachedProjectCount.
		Processor yield ].! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'pmm 10/11/2006 01:17'!
visibleProjects
	^Array streamContents: [ :stream |
		self visibleProjectsDo: [ :each |
			stream nextPut: each ] ]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'pmm 10/11/2006 01:06'!
visibleProjectsDo: aBlock
	self allProjectsVisible ifTrue: [
		^self projectsDo: aBlock ].
	self projectsDo: [:each |
		(self isVisible: each) ifTrue: [
			aBlock value: each ] ]! !

!SSRepository methodsFor: 'accessing-projects' stamp: 'pmm 10/16/2006 11:58'!
visibleProjectsSelect: aBlock
	^Array streamContents: [ :stream |
		self visibleProjectsDo: [ :each |
			(aBlock value: each) ifTrue: [
				stream nextPut: each ] ] ]! !

!SSModel class methodsFor: 'accessing-defaults' stamp: 'pmm 9/2/2007 13:03'!
defaultLengthAtLeast: anInteger
	^ SSSizeCondition atLeast: anInteger! !

!SSModel class methodsFor: 'accessing-defaults' stamp: 'pmm 9/2/2007 13:03'!
defaultLengthAtMost: anInteger
	^ SSSizeCondition atMost: anInteger! !

!SSModel methodsFor: 'initialization' stamp: 'pmm 3/1/2006 21:51'!
initialize
	super initialize.
	timestamp := TimeStamp current.! !

!SSModel methodsFor: 'accessing' stamp: 'pmm 9/9/2007 12:19'!
repository
	^SSRepository current! !

!SSModel methodsFor: 'accessing' stamp: 'lr 2/6/2004 17:26'!
timestamp
	^timestamp! !

SSModel subclass: #SSTag
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSTag class methodsFor: 'accessing-defaults' stamp: 'pmm 1/24/2006 20:04'!
defaultInstances
	^self defaultNames collect: [ :each |
		self name: each ]! !

!SSTag class methodsFor: 'accessing-defaults' stamp: 'pmm 1/26/2006 18:48'!
defaultNames
	^#(
		client
		server
		protocol
		fileformat
		
		seaside
		
		algorithm
		
		persistency
		
		education
		children
		teaching
		learning
		exercise
				
		xml
		compiler
		research
		collection
	)! !

!SSTag class methodsFor: 'instance creation' stamp: 'pmm 1/24/2006 20:03'!
name: aString
	^self new
		name: aString;
		yourself! !

!SSTag methodsFor: 'comparing' stamp: 'pmm 2/5/2006 15:48'!
< aLabel
	^(self name compare: aLabel name) = 1! !

!SSTag methodsFor: 'comparing' stamp: 'pmm 1/24/2006 20:05'!
<= aLabel
	^self name caseInsensitiveLessOrEqual: aLabel name! !

!SSTag methodsFor: 'converting' stamp: 'pmm 1/24/2006 21:47'!
asString
	^self name! !

!SSTag methodsFor: 'accessing' stamp: 'pmm 3/15/2006 23:34'!
maxActivity
	^self projects size! !

!SSTag methodsFor: 'accessing' stamp: 'pmm 1/24/2006 20:04'!
name
	^name! !

!SSTag methodsFor: 'accessing' stamp: 'pmm 1/24/2006 20:05'!
name: aString
	name := aString! !

!SSTag methodsFor: 'accessing' stamp: 'pmm 1/24/2006 21:55'!
numberOfProjects
	^self projects size! !

!SSTag methodsFor: 'printing' stamp: 'pmm 1/24/2006 20:07'!
printOn: aStream
	super printOn: aStream.
	self name isNil ifFalse: [
		aStream
			nextPut: $(;
			nextPutAll: self name;
			nextPut: $) ].! !

!SSTag methodsFor: 'accessing' stamp: 'pmm 10/11/2006 01:12'!
projects
	^self repository visibleProjectsSelect: [ :each | each hasTag: self ]! !

SSModel subclass: #SSVersion
	instanceVariableNames: 'author versionInfo dependencies properties downloadStatistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSVersion class methodsFor: 'instance creation' stamp: 'pmm 10/9/2006 11:50'!
array: anArray author: aMember
	^(self stream: anArray readStream author: aMember)
		size: anArray size;
		yourself! !

!SSVersion class methodsFor: 'properties' stamp: 'pmm 10/9/2006 11:45'!
deletedProperty
	^ #deleted! !

!SSVersion class methodsFor: 'properties' stamp: 'pmm 10/9/2006 11:47'!
diffsProperty
	^ #diffs! !

!SSVersion class methodsFor: 'migration' stamp: 'lr 2/20/2004 14:21'!
migrate
	self allInstances do: [ :version |
		version dependencies do: [ :dependency |
			(dependency isKindOf: MCVersionDependency)
				ifTrue: [ dependency become: dependency versionInfo ].
			dependency clearAncestors ].
		version versionInfo ancestors do: [ :each |
			each clearAncestors ] ].! !

!SSVersion class methodsFor: 'properties' stamp: 'avi 9/23/2004 15:46'!
packageProperty
	^ #package! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/8/2004 11:44'!
releaseProperty
	^ #release! !

!SSVersion class methodsFor: 'properties' stamp: 'pmm 10/9/2006 11:44'!
sizeProperty
	^ #size! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/11/2004 11:41'!
smPackageProperty
	^ #smPackage! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/11/2004 11:41'!
smPasswordProperty
	^ #smPassword! !

!SSVersion class methodsFor: 'properties' stamp: 'lr 2/11/2004 11:41'!
smUsernameProperty
	^ #smUsername! !

!SSVersion class methodsFor: 'properties' stamp: 'al 3/3/2004 18:14'!
smVersionCommentProperty
	^ #smVersionComment! !

!SSVersion class methodsFor: 'instance creation' stamp: 'lr 2/4/2004 18:26'!
stream: aStream author: aMember
	^self new
		initializeFromStream: aStream author: aMember;
		yourself! !

!SSVersion methodsFor: 'comparing' stamp: 'bf 12/16/2004 19:30'!
<= aVersion
	^self packageName = aVersion packageName
		ifFalse: [ self packageName < aVersion packageName ]
		ifTrue: [ self packageVersion > aVersion packageVersion ]
! !

!SSVersion methodsFor: 'conveniance' stamp: 'lr 3/22/2004 19:23'!
activity
	"This is non-trivial code with physical background: it calculates an artifical float representing the activity of the receiver. The bigger the number, the more siginification is this publication in the past days. This codes uses the halflife-time known from radioactive elements, in this example the constant lambda has been set to 3 days."
	
	| lambda time |
	lambda := 2 ln / (3 * 24 * 60 * 60).
	time := self timestamp asSeconds - TimeStamp current asSeconds.
	^(time * lambda) exp.! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 2/4/2004 17:37'!
ancestors
	^self versionInfo ancestors! !

!SSVersion methodsFor: 'accessing' stamp: 'al 1/31/2004 17:22'!
author
	^author! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:45'!
author: aMember
	author := aMember! !

!SSVersion methodsFor: 'conveniance' stamp: 'pmm 6/21/2006 09:55'!
authorString
	^self author fullnameOrUnknown! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 3/16/2006 17:25'!
beDeleted
	self deleted: true! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 3/1/2006 21:59'!
beRelease
	self release: true! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'bf 5/30/2005 18:33'!
buildDiff: aFileName in: aProject
	| baseName base |
	baseName := MCDiffyVersion baseNameFrom: aFileName.
	base := aProject versionAt: baseName, '.', self readerClass extension ifAbsent: [^nil].
	^self buildDiffFrom: (base reader: aProject)
		to: (self reader: aProject).! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'pmm 3/1/2006 23:06'!
buildDiffFrom: baseReader to: versionReader

	| diff |
	versionReader info = baseReader info ifTrue: [^nil].
	(versionReader info hasAncestor: baseReader info) ifFalse: [^nil].
	^[
		diff := MCDiffyVersion
			package: versionReader package
			info: versionReader info
			dependencies: versionReader dependencies
			baseInfo: baseReader info
			patch: (versionReader snapshot patchRelativeToBase: baseReader snapshot).
		ByteArray streamContents: [:strm | diff fileOutOn: strm]
	]
		on: ProgressInitiationException
		do: [ :ex |  ex sendNotificationsTo: [ :min :max :curr | "no progress bar please" ] ]! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:45'!
deleted
	^self
		propertyAt: self class deletedProperty
		ifAbsent: [ false ]! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:45'!
deleted: aBoolean
	^self
		propertyAt: self class deletedProperty
		put: aBoolean! !

!SSVersion methodsFor: 'accessing' stamp: 'lr 2/20/2004 14:12'!
dependencies
	^dependencies! !

!SSVersion methodsFor: 'conveniance' stamp: 'bf 5/26/2005 13:28'!
diffName
	^String streamContents: [ :stream |
		stream nextPutAll: self versionInfo name.
		stream nextPut: $..
		stream nextPutAll: MCMcdReader extension ]! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'pmm 10/9/2006 11:49'!
diffNamesDo: aBlock
	^self diffs keysAndValuesDo: [:diffName :valid |
		valid ifTrue: [ aBlock value: diffName ] ]
! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'pmm 10/9/2006 11:47'!
diffs
	^self
		propertyAt: self class diffsProperty
		ifAbsentPut: [ Dictionary new ]
! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'al 2/26/2004 21:52'!
downloadCountForType: aSymbol
	^self downloadStatistics at: aSymbol ifAbsent: [ 0 ]! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'al 2/26/2004 21:50'!
downloadStatistics
	^downloadStatistics ifNil: [ downloadStatistics := Dictionary new ]! !

!SSVersion methodsFor: 'conveniance' stamp: 'bf 3/28/2006 14:59'!
fileName
	^self propertyAt: #fileName ifAbsentPut: [
		String streamContents: [ :stream |
			stream nextPutAll: self versionInfo name.
			stream nextPut: $..
			stream nextPutAll: self readerClass extension ]]! !

!SSVersion methodsFor: 'conveniance' stamp: 'pmm 10/9/2006 00:00'!
fileNameFaked: aBoolean
	| basicFileName |
	basicFileName := self fileName.
	^(aBoolean and: [ basicFileName endsWith: '.mcz' ])
		ifTrue: [ (basicFileName allButLast: 4), '.zip' ]
		ifFalse: [ basicFileName ]! !

!SSVersion methodsFor: 'accessing-diff' stamp: 'bf 7/15/2005 16:23'!
getDiff: aFileName in: aProject
	| diffName data |
	diffName := MCDiffyVersion canonicalNameFor: aFileName.
	self diffs at: diffName ifPresent: [:hasDiff | 
		^hasDiff ifTrue: [SSRepository storage loadDiffNamed: diffName from: aProject]].

	data := [self buildDiff: diffName in: aProject]
		on: Error do: [:ex | ex return: nil].
	data ifNotNil: [SSRepository storage saveDiff: data named: diffName to: aProject].
	self diffs at: diffName put: data notNil.
	^data! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/11/2006 00:56'!
guessedAuthor
	^self repository
		memberAt: (self versionInfo name copyAfterLast: $-)
		ifAbsent: [ nil ]! !

!SSVersion methodsFor: 'testing' stamp: 'avi 9/23/2004 16:04'!
hasAncestor: aVersion project: aProject
	^ (self readVersionInfoFromProject: aProject) hasAncestor: aVersion versionInfo! !

!SSVersion methodsFor: 'testing' stamp: 'pmm 10/23/2006 12:53'!
hasGuid
	^self versionInfo notNil
		and: [ self versionInfo id notNil ]! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 1/31/2004 21:35'!
id
	^self versionInfo id! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'al 2/26/2004 21:53'!
increaseDownloadCounterForType: aSymbol
	self downloadStatistics
		at: aSymbol
		put: (self downloadCountForType: aSymbol) + 1! !

!SSVersion methodsFor: 'initialization' stamp: 'pmm 10/23/2006 16:14'!
initialize
	super initialize.
	properties := Dictionary new.! !

!SSVersion methodsFor: 'initialization' stamp: 'pmm 10/23/2006 16:20'!
initializeFromReader: aReader
	dependencies := aReader dependencies
		collect: [ :each | each versionInfo clearAncestors ].
	(versionInfo := aReader info) ancestors
		do: [ :each | each clearAncestors ].
	self package: (aReader package name)! !

!SSVersion methodsFor: 'initialization' stamp: 'pmm 10/26/2006 21:21'!
initializeFromStream: aStream
	self initializeFromReader: (self readerClass on: aStream)! !

!SSVersion methodsFor: 'initialization' stamp: 'pmm 10/23/2006 16:16'!
initializeFromStream: aStream author: aMember
	author := aMember.
	self initializeFromStream: aStream.	! !

!SSVersion methodsFor: 'testing' stamp: 'pmm 3/16/2006 17:25'!
isDeleted
	^self deleted! !

!SSVersion methodsFor: 'testing' stamp: 'pmm 3/1/2006 21:54'!
isRelease
	^self 
		propertyAt: self class releaseProperty
		ifAbsent: [ false ]! !

!SSVersion methodsFor: 'testing' stamp: 'pmm 10/9/2006 11:53'!
isVersion
	^true! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 1/31/2004 21:32'!
message
	^self versionInfo message! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 3/1/2006 21:59'!
noRelease
	self release: false! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:44'!
package
	^ self
		propertyAt: self class packageProperty
		ifAbsent: [ self packageName ]! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:46'!
package: aString
	self
		propertyAt: self class packageProperty
		put: aString! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'bf 12/14/2004 13:39'!
packageName
	^self versionInfo name copyUpToLast: $-.! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'al 2/2/2006 13:23'!
packageVersion
	^[ (self versionInfo name copyAfterLast: $.) asNumber ]
		ifError: [ :e | 0 ]
	! !

!SSVersion methodsFor: 'accessing-properties' stamp: 'lr 2/8/2004 11:42'!
propertyAt: aSymbol
	^properties at: aSymbol! !

!SSVersion methodsFor: 'accessing-properties' stamp: 'lr 2/8/2004 11:43'!
propertyAt: aSymbol ifAbsent: aBlock
	^properties at: aSymbol ifAbsent: aBlock
	! !

!SSVersion methodsFor: 'accessing-properties' stamp: 'bf 5/30/2005 17:21'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^properties at: aSymbol ifAbsentPut: aBlock
	! !

!SSVersion methodsFor: 'accessing-properties' stamp: 'lr 2/8/2004 11:43'!
propertyAt: aSymbol put: aValue
	^properties at: aSymbol put: aValue! !

!SSVersion methodsFor: 'accessing-properties' stamp: 'lr 2/11/2004 11:47'!
propertyIncludes: aSymbol
	^properties includesKey: aSymbol! !

!SSVersion methodsFor: 'accessing-project' stamp: 'avi 9/23/2004 16:06'!
readVersionInfoFromProject: aProject
	^ (self reader: aProject) info! !

!SSVersion methodsFor: 'accessing-project' stamp: 'pmm 9/9/2007 12:20'!
reader: aProject
	| data |
	data := SSRepository storage loadMonticello: self from: aProject.
	^self readerClass on: data asByteArray readStream.! !

!SSVersion methodsFor: 'conveniance' stamp: 'lr 3/15/2004 16:06'!
readerClass
	^MCMczReader! !

!SSVersion methodsFor: 'conveniance' stamp: 'pmm 9/11/2007 22:12'!
registerSqueakMap: aProject
	"Copyied from MCSMReleaseRepository>>releaseVersion:url: and slightly modified. This message returns an error string in case of any problem, else nil is returned."

	| result |
	result := HTTPSocket
		httpPost: self squeakMapUrl, '/packagebyname/' , (self propertyAt: self class smPackageProperty) , '/newrelease'
		args: (Array
			with: ('version' -> (Array with: ((self versionInfo name copyAfter: $.) extractNumber displayString)))
			with: ('note' -> (Array with: (self propertyAt: self class smVersionCommentProperty )))
			with: ('downloadURL' -> (Array with: (self url: aProject))))
		user: (self propertyAt: self class smUsernameProperty)
		passwd: (self propertyAt: self class smPasswordProperty).
	^result contents size > 4 
		ifTrue: [ result contents ]
		ifFalse: [ nil ]! !

!SSVersion methodsFor: 'conveniance' stamp: 'pmm 9/11/2007 22:14'!
registerSqueakMapCurl: aProject

	| ursername password url arguments postdata curl proxyServer proxyPort |
	ursername := (self propertyAt: self class smUsernameProperty).
	password := (self propertyAt: self class smPasswordProperty).
	url := Url absoluteFromText: (self squeakMapUrl, '/packagebyname/' , (self propertyAt: self class smPackageProperty) , '/newrelease').
	arguments := Array
			with: ('version' -> (Array with: ((self versionInfo name copyAfter: $.) extractNumber displayString)))
			with: ('note' -> (Array with: (self propertyAt: self class smVersionCommentProperty )))
			with: ('downloadURL' -> (Array with: (self url: aProject))).
	postdata := String streamContents: [ :stream |
		arguments do: [ :each |
			stream nextPutAll: each key encodeForHTTP.
			stream nextPut: $=.
			stream nextPutAll: each value encodeForHTTP ] ].

	curl := (self class environment classNamed: 'Curl') new.

	HTTPSocket httpProxyServer isNil ifFalse: [ "use proxy"
		proxyServer := HTTPSocket httpProxyServer.
		proxyPort := HTTPSocket httpProxyPort.
		proxyPort isNil
			ifTrue: [ curl proxy: proxyServer ]
			ifFalse: [ curl proxy: proxyServer, ':' , proxyPort displayString ] ].

	curl onHttpAuthAny.
	curl onPost.
	curl userPwd: ursername, ':' , password.
	^curl putContents: postdata url: url printString. 
	! !

!SSVersion methodsFor: 'initialization' stamp: 'pmm 10/23/2006 16:25'!
reinititalizeInfoFor: aProject
	self initializeFromReader: (self reader: aProject)! !

!SSVersion methodsFor: 'accessing' stamp: 'lr 2/8/2004 11:44'!
release: aBoolean
	self 
		propertyAt: self class releaseProperty
		put: aBoolean! !

!SSVersion methodsFor: 'initialization' stamp: 'pmm 9/9/2007 12:04'!
setTimestampFromVersionInfo
        timestamp := TimeStamp date: versionInfo date time: versionInfo time.! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:44'!
size
	^ self
		propertyAt: self class sizeProperty
		ifAbsent: [ 0 ]! !

!SSVersion methodsFor: 'accessing' stamp: 'pmm 10/9/2006 11:45'!
size: anInteger
	^ self
		propertyAt: self class sizeProperty
		put: anInteger! !

!SSVersion methodsFor: 'conveniance' stamp: 'lr 2/11/2004 12:15'!
squeakMapUrl
	^'http://map1.squeakfoundation.org/sm'! !

!SSVersion methodsFor: 'testing' stamp: 'al 2/3/2006 21:54'!
stringsSatisfy: aBlock
	^(aBlock value: versionInfo name)
		or: [ aBlock value: versionInfo message ]
		or: [ author notNil and: [ author stringsSatisfy: aBlock ] ]! !

!SSVersion methodsFor: 'accessing-shortcut' stamp: 'lr 3/19/2004 09:54'!
title
	^self fileName! !

!SSVersion methodsFor: 'accessing-statistics' stamp: 'pmm 10/16/2006 11:49'!
totalDownloads
	| sum |
	sum := 0.
	self downloadStatistics valuesDo: [ :each |
		sum := sum + each ].
	^sum! !

!SSVersion methodsFor: 'conveniance' stamp: 'lr 2/7/2004 13:43'!
truncatedMessage
	^self message truncateWithElipsisTo: 35! !

!SSVersion methodsFor: 'accessing-project' stamp: 'pmm 9/9/2007 12:47'!
url: aProject
	^aProject fullDirectoryUrl, '/' , self fileName! !

!SSVersion methodsFor: 'accessing' stamp: 'lr 1/31/2004 21:31'!
versionInfo
	^versionInfo! !

Object subclass: #SSSiteMapBuilder
	instanceVariableNames: 'document urlset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Server'!

!SSSiteMapBuilder class methodsFor: 'convenience' stamp: 'pmm 10/8/2006 21:54'!
buildForCurrentRepository
	"self buildForCurrentRepository"
	^self buildForRepository: SSRepository current! !

!SSSiteMapBuilder class methodsFor: 'convenience' stamp: 'pmm 10/8/2006 21:53'!
buildForRepository: aRepository
	^self new buildForRepository: aRepository! !

!SSSiteMapBuilder class methodsFor: 'convenience' stamp: 'pmm 10/26/2006 07:04'!
buildForRepository: aRepository host: aString
	"self buildForRepository: SSRepository current host: 'squeaksource.com'"
	^self new buildForRepository: aRepository host: aString! !

!SSSiteMapBuilder class methodsFor: 'convenience' stamp: 'pmm 10/8/2006 23:25'!
writeCurrentToFile
	"self writeCurrentToFile
	validate with: 
xmllint --schema http://www.google.com/schemas/sitemap/0.84/sitemap.xsd  --noout sitemap.xml"
	| stream |
	stream := FileStream forceNewFileNamed: 'sitemap.xml.gz'.
	stream binary.
	[ stream nextPutAll: self buildForCurrentRepository ]
		ensure: [ stream close ]! !

!SSSiteMapBuilder methodsFor: 'private' stamp: 'pmm 10/8/2006 22:03'!
addLocation: aString
	| url loc |
	url := XMLElement named: 'url'.
	urlset addElement: url.
	loc := XMLElement named: 'loc'.
	loc addContent: (XMLStringNode string: aString).
	url addElement: loc! !

!SSSiteMapBuilder methodsFor: 'private' stamp: 'pmm 9/9/2007 12:47'!
addProject: aProject
	self addLocation: aProject fullDirectoryUrl, '/'! !

!SSSiteMapBuilder methodsFor: 'private' stamp: 'pmm 10/11/2006 01:07'!
addRepository: aRepository
	aRepository visibleProjectsDo: [ :each |
		self addProject: each ]! !

!SSSiteMapBuilder methodsFor: 'public' stamp: 'pmm 10/8/2006 22:35'!
buildForRepository: aRepository
	self addRepository: aRepository.
	^String streamContents: [ :stream |
		| gzip |
		gzip := GZipWriteStream on: stream.
		document printCanonicalOn: gzip.
		gzip finish ]! !

!SSSiteMapBuilder methodsFor: 'public' stamp: 'pmm 10/26/2006 06:57'!
buildForRepository: aRepository host: aString
	host := aString.
	^self buildForRepository: aRepository! !

!SSSiteMapBuilder methodsFor: 'initialize-release' stamp: 'pmm 10/8/2006 21:48'!
initialize
	super initialize.
	document := XMLDocument new.
	urlset := (XMLElement named: 'urlset')
		attributeAt: 'xmlns' put: 'http://www.google.com/schemas/sitemap/0.84';
		attributeAt: 'xmlns:xsi' put: 'http://www.w3.org/2001/XMLSchema-instance';
		attributeAt: 'xsi:schemaLocation' put: 'http://www.google.com/schemas/sitemap/0.84
	http://www.google.com/schemas/sitemap/0.84/sitemap.xsd';
		yourself.
	document addElement: urlset! !

Object subclass: #SSStatistics
	instanceVariableNames: 'model cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSStatistics class methodsFor: 'instance creation' stamp: 'al 7/26/2004 14:38'!
model: aRepository
	^self basicNew
		model: aRepository;
		initialize;
		yourself! !

!SSStatistics methodsFor: 'calculation' stamp: 'pmm 10/26/2006 20:57'!
calculate
	self calculateMembersActive.
	Processor yield.
	self calculateMembersNew.
	Processor yield.
	self calculateProjectsActive.
	Processor yield.
	self calculateProjectsDownloads.
	Processor yield.
	self calculateProjectsNew.
	Processor yield.
	self calculateProjectsRecent! !

!SSStatistics methodsFor: 'calculation' stamp: 'pmm 10/26/2006 20:51'!
calculateMembersActive
	| histogram value |
	histogram := Dictionary new.
	self model visibleProjectsDo: [ :project |
		project versionsDo: [ :version |
			value := histogram at: version author ifAbsent: [ 0.0 ].
			histogram at: version author put: value + version activity ] ].
	cache at: #membersActive put: (self model members asSortedCollection: [ :x :y |
		(histogram at: x ifAbsent: [ 0.0 ]) >= (histogram at: y ifAbsent: [ 0.0 ]) ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:21'!
calculateMembersNew
	cache at: #membersNew put: (self model members asSortedCollection: [ :x :y |
		x timestamp >= y timestamp ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'pmm 10/26/2006 20:53'!
calculateProjectsActive
	cache at: #projectsActive put: (self model projects asSortedCollection: [ :x :y |
		x cachedAbsoluteActivity >= y cachedAbsoluteActivity ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'pmm 10/26/2006 20:53'!
calculateProjectsDownloads
	cache at: #projectsDownloads put: (self model projects asSortedCollection: [ :x :y |
		x cachedDownloads >= y cachedDownloads ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'al 7/26/2004 14:23'!
calculateProjectsNew
	cache at: #projectsNew put: (self model projects asSortedCollection: [ :x :y |
		x timestamp >= y timestamp ])! !

!SSStatistics methodsFor: 'calculation' stamp: 'pmm 10/26/2006 20:53'!
calculateProjectsRecent
	| associations |
	associations := SortedCollection sortBlock: [ :x :y |
		x value timestamp >= y value timestamp ].
	self model visibleProjectsDo: [ :project |
		project versionsDo: [ :version |
			associations add: project -> version ] ].
	cache at: #projectsRecent put: (associations collect: [ :each | 
		each key ])! !

!SSStatistics methodsFor: 'initialize-release' stamp: 'pmm 10/26/2006 20:54'!
initialize
	super initialize.
	cache := Dictionary new.
	self calculate! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:55'!
membersActive
	^cache at: #membersActive! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:55'!
membersNew
	^cache at: #membersNew! !

!SSStatistics methodsFor: 'accessing' stamp: 'al 7/26/2004 14:16'!
model
	^model! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:54'!
model: aRepository
	model := aRepository! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:56'!
projectsActive
	^cache at: #projectsActive! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:56'!
projectsDownloads
	^cache at: #projectsDownloads! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:56'!
projectsNew
	^cache at: #projectsNew! !

!SSStatistics methodsFor: 'accessing' stamp: 'pmm 10/26/2006 20:56'!
projectsRecent
	^cache at: #projectsRecent! !

Object subclass: #SSStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSStorage commentStamp: 'al 1/17/2006 16:31' prior: 0!
AUTOMATIC IMAGE SAVING (as alternative to ref streams)
storage := [ 
	[ Smalltalk garbageCollect.
	  Smalltalk saveSession.
	  (Delay forSeconds: 60 * 60) wait ] repeat ] forkAt: 51.
storage terminate.

====================================

MIGRATION SCRIPTS (old squeaksource instance on kilana to macamis)

"Chronology library changes"
(TimeStamp allInstances
	select: [:each | (each instVarNamed: 'seconds')
			isKindOf: Date])
	do: [:each | each become: (
		TimeStamp
			date: (Date julianDayNumber: (each instVarNamed: 'seconds') start)
			time: ((each instVarNamed: 'offset') instVarNamed: 'nanos' put: 0;
					 yourself))] displayingProgress: 'Converting TimeStamp'

"New instvars in MCVersionInfo. Note, this would normally be doable with SmartRefStream, but it seams to be broken for larger data sets."			
(MCVersionInfo allInstances
	select: [:each | (each stepChildren isKindOf: UUID) and: [ each author isNil ]])
	do: [:each | 
		8 to: 3 by: -1 do: [ :i |
			each instVarAt: i put: (each instVarAt: i - 1) ] ] displayingProgress: 'Converting MCVersionInfo'!

SSStorage subclass: #SSFilesystem
	instanceVariableNames: ''
	classVariableNames: 'CriticalSection'
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!SSFilesystem class methodsFor: 'accessing' stamp: 'lr 2/26/2004 23:24'!
criticalSection
	CriticalSection isNil
		ifTrue: [ CriticalSection := Semaphore forMutualExclusion ].
	^CriticalSection! !

!SSFilesystem class methodsFor: 'utilities' stamp: 'al 2/11/2005 16:03'!
recoverAllLostVersions
	SSRepository current projects do: [ :each |
	Transcript cr; show: 'Importing project: ' , each id; cr.
	self new importVersionsFor: (
		SSRepository current projectAt: each id) ]! !

!SSFilesystem methodsFor: 'utilities' stamp: 'bf 7/28/2005 14:45'!
backupBaseFor: aString
	^aString copyUpToLast: $.! !

!SSFilesystem methodsFor: 'utilities' stamp: 'lr 2/1/2004 18:56'!
backupExtensionFor: aString
	| timestamp |
	timestamp := TimeStamp current.
	^String streamContents: [ :stream |
		timestamp date printOn: stream format: #(3 2 1 $- 1 1 2).
		stream nextPut: $..
		stream nextPutAll: (timestamp time print24 collect: [ :each |
			each isDigit ifTrue: [ each ] ifFalse: [ $- ] ]) ].! !

!SSFilesystem methodsFor: 'utilities' stamp: 'pmm 10/3/2007 07:15'!
backupFileNames
	| base ext |
	base := self backupBaseFor: self streamFile.
	ext := (self backupExtensionFor: self streamFile)
		collect: [:c | c isDigit ifTrue: [ $# ] ifFalse: [ c ] ].
	^self rootDirectory fileNamesMatching: base, FileDirectory dot, ext! !

!SSFilesystem methodsFor: 'utilities' stamp: 'bf 7/28/2005 14:45'!
createBackupIn: aFileDirectory of: aString
	(aFileDirectory fileExists: aString) ifTrue: [
		aFileDirectory
			copyFileWithoutOverwriteConfirmationNamed: aString
			toFileNamed: (FileDirectory 
				fileName: (self backupBaseFor: aString) 
				extension: (self backupExtensionFor: aString)) ]! !

!SSFilesystem methodsFor: 'utilities' stamp: 'pmm 10/3/2007 07:16'!
fileKaput: aFileName
	| d i kaputName |
	d := self rootDirectory.
	(d fileExists: aFileName) ifFalse: [ ^self ].
	i := 0.
	kaputName := aFileName, '.kaputt'.
	[ d fileExists: kaputName ]	
		whileTrue: [kaputName := aFileName, '.kaputt', (i := i + 1) asString].
	[ d
		rename: aFileName
		toBe: kaputName.
		self log: 'BROKEN ', kaputName.
	] on: Error do: [ :ex | "ignore"]
! !

!SSFilesystem methodsFor: 'logging' stamp: 'pmm 10/8/2006 21:22'!
getLogOfSize: anInteger 
	| log |
	log := [ self rootDirectory readOnlyFileNamed: self logFileName]
		on: FileDoesNotExistException
		do: [ :ex| ^nil ].
	^[
		log position: (log size - anInteger max: 0).
		log upTo: Character cr.
		log upToEnd.
	] ensure: [ log close ]
! !

!SSFilesystem methodsFor: 'utilities' stamp: 'pmm 10/16/2006 11:09'!
importVersionsFor: aProject
	| dir contents initials user version |
	dir := self projectDirectoryFor: aProject.
	(dir fileNamesMatching: '*.mcz') do: [ :each |
		(aProject includesVersionAt: each) ifFalse: [
			contents := (dir readOnlyFileNamed: each) contentsOfEntireFile.
			initials := (each copyAfterLast: $-) copyUpTo: $. .
			user := SSRepository current memberAt: initials.
			user ifNil: [ user := SSMember anonymousMember ].
			version := aProject addVersion: contents author: user.
			version setTimestampFromVersionInfo ] ].! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 5/30/2005 17:53'!
loadDiffNamed: aFileName from: aProject
	| stream |
	stream := (self projectDirectoryFor: aProject)
		readOnlyFileNamed: aFileName.
	^[ stream binary; contents ]
		ensure: [ stream close ].! !

!SSFilesystem methodsFor: 'actions' stamp: 'pmm 8/1/2006 11:23'!
loadFile: aFilename from: aProject
	| stream |
	stream := (self projectDirectoryFor: aProject)
		readOnlyFileNamed: aFilename.
	^[ stream binary; contents ]
		ensure: [ stream close ].! !

!SSFilesystem methodsFor: 'actions' stamp: 'pmm 8/1/2006 11:26'!
loadMonticello: aVersion from: aProject
	^self
		loadFile: aVersion fileName
		from: aProject! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 12/20/2005 21:07'!
loadRepository
	[
		Display border: Display boundingBox width: 10 fillColor: Color green.
		[^self loadRepositoryFrom: self streamFile]
			on: Error do: [:ex |
				self fileKaput: self streamFile.
				ex return: nil].
		Display border: Display boundingBox width: 10 fillColor: Color yellow.
		self backupFileNames sort reverseDo: [:f |
			[^self loadRepositoryFrom: f]
				on: Error do: [:ex |
					self fileKaput: f.
					ex return: nil]].
		self error: 'Could not load repository nor any backup'
	] ensure: [World changed]! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 9/29/2005 19:48'!
loadRepositoryFrom: aFileName
	| stream reference |
	self log: 'LOADING repository from ', aFileName.
	stream := self rootDirectory readOnlyFileNamed: aFileName.
	^[ reference := self streamClass on: stream.
		[ reference next ]
			ensure: [ reference close ] ]
		ensure: [ stream close ].! !

!SSFilesystem methodsFor: 'logging' stamp: 'bf 9/29/2005 19:19'!
log: aString
	| log |
	log := self rootDirectory fileNamed: self logFileName.
	[
		log
			setToEnd;
			nextPutAll: DateAndTime now asString; 
			space;
			nextPutAll: aString;
			cr
	] ensure: [log close]! !

!SSFilesystem methodsFor: 'logging' stamp: 'bf 9/29/2005 19:11'!
logFileName
	^'ss.log'! !

!SSFilesystem methodsFor: 'configuration' stamp: 'lr 1/31/2004 21:23'!
projectDirectoryFor: aProject
	^(self rootDirectory directoryNamed: aProject id)
		assureExistence;
		yourself! !

!SSFilesystem methodsFor: 'configuration' stamp: 'lr 1/31/2004 21:23'!
rootDirectory
	^(FileDirectory default directoryNamed: 'ss')
		assureExistence;
		yourself! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 5/30/2005 18:07'!
saveDiff: aByteArray named: aFileName to: aProject
	| directory stream |
	directory := self projectDirectoryFor: aProject.
	self createBackupIn: directory of: aFileName.
	stream := directory forceNewFileNamed: aFileName.
	[ stream nextPutAll: aByteArray ]
		ensure: [ stream close ].! !

!SSFilesystem methodsFor: 'actions' stamp: 'bf 9/29/2005 18:17'!
saveMonticello: aByteArray of: aVersion to: aProject
	| directory stream |
	directory := self projectDirectoryFor: aProject.
	self createBackupIn: directory of: aVersion fileName.
	stream := directory forceNewFileNamed: aVersion fileName.
	[	stream nextPutAll: aByteArray.
		self log: 'STORED ', aProject id, '/', aVersion fileName.
	]
		ensure: [ stream close ].

! !

!SSFilesystem methodsFor: 'actions' stamp: 'pmm 10/3/2007 07:16'!
saveRepository: aRepository
	| where stream reference |
	Display border: Display boundingBox width: 10 fillColor: Color orange.
	where := thisContext sender sender.
	self log: 'MODIFIED by ', where receiver class name, '>>', where method selector.
	aRepository dirty: true.
	[	self class criticalSection critical: [
			aRepository dirty ifTrue: [
				Display border: Display boundingBox width: 10 fillColor: Color red.
				self log: 'BEGIN SAVING'.
				aRepository dirty: false.
				self createBackupIn: self rootDirectory of: self streamFile.
				stream := self rootDirectory forceNewFileNamed: self streamFile.
				[	reference := self streamClass on: stream.
					[	reference nextPut: aRepository.
						self log: 'DONE SAVING'.
					]
						ensure: [ reference close ]
				] ensure: [ stream close ]. 
				aRepository dirty ifFalse: [World changed].
			]
		]
	] forkAt: Processor activePriority - 1 named: 'store'! !

!SSFilesystem methodsFor: 'configuration' stamp: 'lr 1/29/2004 11:20'!
streamClass
	^ReferenceStream! !

!SSFilesystem methodsFor: 'configuration' stamp: 'lr 2/1/2004 13:23'!
streamFile
	^'data.obj'! !

!SSStorage methodsFor: 'actions' stamp: 'lr 2/1/2004 13:37'!
loadMonticello: aVersion from: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'lr 2/1/2004 13:37'!
loadRepository
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'bf 5/26/2005 12:00'!
saveDiff: aString of: aVersion to: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'lr 2/1/2004 13:37'!
saveMonticello: aString of: aVersion to: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'lr 1/31/2004 21:16'!
saveRepository: aRepository
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'bf 3/22/2006 16:56'!
shutdown! !

Object subclass: #SSTodo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Fake'!

!SSTodo commentStamp: '<historical>' prior: 0!
- senders of #render: -> #children
- style stuff for tables, cells, batch
- color icon in table not again table!

!ZipArchiveMember methodsFor: '*squeaksource-override' stamp: 'bf 5/26/2005 17:29'!
refreshLocalFileHeaderTo: aStream
	"Re-writes my local header to the given stream.
	To be called after writing the data stream.
	Assumes that fileName and localExtraField sizes didn't change since last written."

	| here |
	here := aStream position.
	aStream position: writeLocalHeaderRelativeOffset.

	aStream nextPutAll: LocalFileHeaderSignature asByteArray.
	aStream nextLittleEndianNumber: 2 put: versionNeededToExtract.
	aStream nextLittleEndianNumber: 2 put: bitFlag.
	aStream nextLittleEndianNumber: 2 put: desiredCompressionMethod.
	aStream nextLittleEndianNumber: 4 put: lastModFileDateTime.
	aStream nextLittleEndianNumber: 4 put: crc32.
	aStream nextLittleEndianNumber: 4 put: (desiredCompressionMethod = CompressionStored
												ifTrue: [ uncompressedSize ] ifFalse: [ compressedSize ]).
	aStream nextLittleEndianNumber: 4 put: uncompressedSize.
	aStream nextLittleEndianNumber: 2 put: fileName size.
	aStream nextLittleEndianNumber: 2 put: localExtraField size.

	aStream position: here.
! !

!ZipArchiveMember methodsFor: '*squeaksource-override' stamp: 'bf 5/26/2005 17:30'!
writeCentralDirectoryFileHeaderTo: aStream
	"C2 v3 V4 v5 V2"

	aStream nextPutAll: CentralDirectoryFileHeaderSignature asByteArray.
	aStream nextLittleEndianNumber: 1 put: versionMadeBy.
	aStream nextLittleEndianNumber: 1 put: fileAttributeFormat.

	aStream nextLittleEndianNumber: 2 put: versionNeededToExtract.
	aStream nextLittleEndianNumber: 2 put: bitFlag.
	aStream nextLittleEndianNumber: 2 put: desiredCompressionMethod.

	aStream nextLittleEndianNumber: 4 put: lastModFileDateTime.

	"These next 3 should have been updated during the write of the data"
	aStream nextLittleEndianNumber: 4 put: crc32.
	aStream nextLittleEndianNumber: 4 put: (desiredCompressionMethod = CompressionStored
												ifTrue: [ uncompressedSize ] ifFalse: [ compressedSize ]).
	aStream nextLittleEndianNumber: 4 put: uncompressedSize.

	aStream nextLittleEndianNumber: 2 put: fileName size.
	aStream nextLittleEndianNumber: 2 put: cdExtraField size.
	aStream nextLittleEndianNumber: 2 put: fileComment size.
	aStream nextLittleEndianNumber: 2 put: 0.		"diskNumberStart"
	aStream nextLittleEndianNumber: 2 put: internalFileAttributes.

	aStream nextLittleEndianNumber: 4 put: externalFileAttributes.
	aStream nextLittleEndianNumber: 4 put: writeLocalHeaderRelativeOffset.

	aStream nextPutAll: fileName asByteArray.
	aStream nextPutAll: cdExtraField asByteArray.
	aStream nextPutAll: fileComment asByteArray.! !

!ZipArchiveMember methodsFor: '*squeaksource-override' stamp: 'bf 5/26/2005 17:27'!
writeLocalFileHeaderTo: aStream
	"Write my local header to a file handle.
	Stores the offset to the start of the header in my
	writeLocalHeaderRelativeOffset member."

	aStream nextPutAll: LocalFileHeaderSignature asByteArray.
	aStream nextLittleEndianNumber: 2 put: versionNeededToExtract.
	aStream nextLittleEndianNumber: 2 put: bitFlag.
	aStream nextLittleEndianNumber: 2 put: desiredCompressionMethod.

	aStream nextLittleEndianNumber: 4 put: lastModFileDateTime.
	aStream nextLittleEndianNumber: 4 put: crc32.
	aStream nextLittleEndianNumber: 4 put: (desiredCompressionMethod = CompressionStored
												ifTrue: [ uncompressedSize ] ifFalse: [ compressedSize ]).
	aStream nextLittleEndianNumber: 4 put: uncompressedSize.

	aStream nextLittleEndianNumber: 2 put: fileName size.
	aStream nextLittleEndianNumber: 2 put: localExtraField size.

	aStream nextPutAll: fileName asByteArray.
	aStream nextPutAll: localExtraField asByteArray.
! !

!UndefinedObject methodsFor: '*SqueakSource' stamp: 'pmm 6/21/2006 09:53'!
fullnameOrUnknown
	^'unknown'! !

MAListCompositonComponent subclass: #SSListCompositonComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSListCompositonComponent methodsFor: 'rendering' stamp: 'pmm 9/17/2007 06:57'!
renderEditorOn: html
	html table
		id: self labelId;
			with: [
				html tableHead: [
					html tableRow: [
						html tableHeading: 'Available:'.
						html tableHeading: [ html space ].
						html tableHeading: 'Selected:'.
						html tableHeading: [ html space ] ] ].
				html tableRow: [
					html tableData: [
						self renderEditorAvailableOn: html ].
					html tableData
						align: 'center';
						with: [ self renderEditorButtonAddOn: html ].
					html tableData: [
						self renderEditorSelectedOn: html ].
					self isOrdered ifTrue: [
						html tableData
							align: 'center';
							with: [ self renderEditorButtonOrderOn: html ] ] ] ]! !

!WARequest methodsFor: '*SqueakSource' stamp: 'pmm 8/26/2007 14:56'!
accessPath
	^self url findTokens: '/'! !

Error subclass: #SSVersionAlreadyExists
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Model'!

!MCVersionInfo methodsFor: '*SqueakSource' stamp: 'lr 2/20/2004 14:02'!
clearAncestors
	ancestors := #().
	^self! !

!MCDiffyVersion methodsFor: '*SqueakSource-override' stamp: 'bf 6/20/2006 13:54'!
isCacheable
	"Squeaksource does not want to cache hundreds of automatically generated diffies"
	^false! !

WAKom subclass: #SSKom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Server'!

!SSKom class methodsFor: 'accessing' stamp: 'pmm 8/27/2007 11:10'!
default
	| application |
	application := (WAApplication path: String new)
		sessionClass: SSSession;
		preferenceAt: #entryPoint put: SSFrame;
		preferenceAt: #showToolbar put: false;
		preferenceAt: #errorPage put: WAEmailErrorPage;
		yourself.
	^self handler: application! !

!SSKom methodsFor: 'kom 6.1' stamp: 'pmm 1/23/2006 22:47'!
process: komRequest
	"http://www.nextthing.org/archives/2005/08/07/fun-with-http-headers"
	^(super process: komRequest)
		fieldAt: 'X-Code-Repository' put: SSRepository current title;
		yourself! !

!MADescription class methodsFor: '*SqueakSource-Model' stamp: 'SR 8/25/2007 16:05'!
defaultEditable
	^ true! !

MAElementComponent subclass: #SSColorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSColorComponent class methodsFor: 'testing' stamp: 'pmm 9/16/2007 21:45'!
isAbstract
	^ false! !

!SSColorComponent methodsFor: 'actions' stamp: 'pmm 9/16/2007 21:54'!
boxStyle
	^String streamContents: [ :stream |
		stream
			nextPutAll: 'width: ';
			nextPutAll: self width displayString;
			nextPutAll: 'px; ';
			nextPutAll: 'height: ';
			nextPutAll: self height displayString;
			nextPutAll: 'px; ';
			nextPutAll: 'background-color: ';
			nextPutAll: self value asHTMLColor ]! !

!SSColorComponent methodsFor: 'testing' stamp: 'pmm 9/16/2007 21:56'!
hasLabelId
	^ self isReadonly not! !

!SSColorComponent methodsFor: 'accessing' stamp: 'pmm 9/16/2007 21:45'!
height
	^ 15! !

!SSColorComponent methodsFor: 'rendering' stamp: 'pmm 9/16/2007 21:54'!
renderBoxOn: html
	html div
		style: self boxStyle! !

!SSColorComponent methodsFor: 'rendering' stamp: 'pmm 9/16/2007 21:58'!
renderEditorOn: html
	self renderInputOn: html.
	self renderUpdateOn: html.
	self renderBoxOn: html! !

!SSColorComponent methodsFor: 'rendering' stamp: 'pmm 9/16/2007 21:55'!
renderInputOn: html
	html textInput
		attributes: self attributes;
		id: self labelId;
		on: #string of: self! !

!SSColorComponent methodsFor: 'rendering' stamp: 'pmm 9/16/2007 21:57'!
renderUpdateOn: html
	html submitButton
		text: 'Update'! !

!SSColorComponent methodsFor: 'rendering' stamp: 'pmm 9/16/2007 21:48'!
renderViewerOn: html
	self renderBoxOn: html! !

!SSColorComponent methodsFor: 'accessing' stamp: 'pmm 9/16/2007 21:45'!
value
	^ super value ifNil: [ self description kind transparent ]! !

!SSColorComponent methodsFor: 'accessing' stamp: 'pmm 9/16/2007 21:45'!
width
	^ 30! !

TWWiki subclass: #SSWiki
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSWiki methodsFor: 'accessing' stamp: 'lr 3/28/2004 20:15'!
actions
	^Array streamContents: [ :stream |
		(self project isMember: self session user allowedTo: SSAccessPolicy write) ifTrue: [ 
			stream nextPutAll: #( 'View' #view: ).
			stream nextPutAll: #( 'Edit' #edit: ) ].
		stream nextPutAll: #( 'Home' home ) ].! !

!SSWiki methodsFor: 'events' stamp: 'pmm 8/26/2007 11:12'!
onSaved
	self session save! !

!SSWiki methodsFor: 'accessing' stamp: 'lr 3/28/2004 20:12'!
project
	^project! !

!SSWiki methodsFor: 'rendering' stamp: 'pmm 9/8/2007 08:58'!
renderContentOn: html
	html break.
	super renderContentOn: html! !

!SSWiki methodsFor: 'initialization' stamp: 'pmm 8/26/2007 11:12'!
setModel: aModel
	super setModel: (project := aModel) wiki! !

!SSWiki methodsFor: 'rendering' stamp: 'lr 3/29/2004 22:41'!
style
	^
'.wikiheader h1 {
	display: none; 
}
.wikiheader .list {
	margin-top: 5px;
	margin-bottom: 10px;
}
.wikiheader .listItem {
	display: inline;
	margin-right: 10px;
}

.wikicontent p { 
	margin: 0px;
	margin-bottom: 5px;
}

.wikifooter h1 {
	display: none;
}
.wikifooter .list:before {
	content: "References: ";
	font-weight: bold;
}
.wikifooter .list {
	margin-top: 10px;
	border-top: 1px dotted black;
}
.wikifooter .listItem {
	display: inline;
	margin-right: 10px;
}'! !

WAFileLibrary subclass: #SSFileLibrary
	instanceVariableNames: 'logo color style'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 9/14/2007 07:10'!
defaultColor
	^Color r: 0.21484375 g: 0.1171875 b: 0.51953125! !

!SSFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 9/13/2007 06:37'!
defaultLogo
	^#(255 216 255 224 0 16 74 70 73 70 0 1 1 0 0 1 0 1 0 0 255 219 0 67 0 2 1 1 1 1 1 2 1 1 1 2 2 2 2 2 4 3 2 2 2 2 5 4 4 3 4 6 5 6 6 6 5 6 6 6 7 9 8 6 7 9 7 6 6 8 11 8 9 10 10 10 10 10 6 8 11 12 11 10 12 9 10 10 10 255 219 0 67 1 2 2 2 2 2 2 5 3 3 5 10 7 6 7 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 255 192 0 17 8 0 50 3 12 3 1 34 0 2 17 1 3 17 1 255 196 0 31 0 0 1 5 1 1 1 1 1 1 0 0 0 0 0 0 0 0 1 2 3 4 5 6 7 8 9 10 11 255 196 0 181 16 0 2 1 3 3 2 4 3 5 5 4 4 0 0 1 125 1 2 3 0 4 17 5 18 33 49 65 6 19 81 97 7 34 113 20 50 129 145 161 8 35 66 177 193 21 82 209 240 36 51 98 114 130 9 10 22 23 24 25 26 37 38 39 40 41 42 52 53 54 55 56 57 58 67 68 69 70 71 72 73 74 83 84 85 86 87 88 89 90 99 100 101 102 103 104 105 106 115 116 117 118 119 120 121 122 131 132 133 134 135 136 137 138 146 147 148 149 150 151 152 153 154 162 163 164 165 166 167 168 169 170 178 179 180 181 182 183 184 185 186 194 195 196 197 198 199 200 201 202 210 211 212 213 214 215 216 217 218 225 226 227 228 229 230 231 232 233 234 241 242 243 244 245 246 247 248 249 250 255 196 0 31 1 0 3 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 1 2 3 4 5 6 7 8 9 10 11 255 196 0 181 17 0 2 1 2 4 4 3 4 7 5 4 4 0 1 2 119 0 1 2 3 17 4 5 33 49 6 18 65 81 7 97 113 19 34 50 129 8 20 66 145 161 177 193 9 35 51 82 240 21 98 114 209 10 22 36 52 225 37 241 23 24 25 26 38 39 40 41 42 53 54 55 56 57 58 67 68 69 70 71 72 73 74 83 84 85 86 87 88 89 90 99 100 101 102 103 104 105 106 115 116 117 118 119 120 121 122 130 131 132 133 134 135 136 137 138 146 147 148 149 150 151 152 153 154 162 163 164 165 166 167 168 169 170 178 179 180 181 182 183 184 185 186 194 195 196 197 198 199 200 201 202 210 211 212 213 214 215 216 217 218 226 227 228 229 230 231 232 233 234 242 243 244 245 246 247 248 249 250 255 218 0 12 3 1 0 2 17 3 17 0 63 0 252 197 143 189 125 1 251 18 252 114 240 159 195 25 53 125 7 198 218 183 217 173 175 94 23 182 37 73 30 102 118 54 125 56 57 39 253 154 210 253 170 63 100 191 8 248 23 195 247 31 19 124 23 170 139 43 101 117 243 116 235 140 149 37 143 240 48 7 31 67 249 215 234 247 252 19 43 254 8 13 251 37 124 38 248 7 161 252 119 253 181 252 39 107 226 223 23 234 90 60 122 198 161 167 248 130 237 163 210 124 61 11 196 37 242 90 32 193 38 100 67 251 217 38 45 30 115 181 64 27 155 250 63 62 226 60 159 5 149 170 152 139 190 119 101 20 189 230 214 189 116 211 75 187 253 231 100 231 20 181 63 36 255 0 110 47 134 122 150 151 226 235 127 136 154 93 141 179 104 250 132 42 169 53 157 184 64 143 215 231 43 212 183 80 77 120 134 147 169 94 104 250 148 58 166 155 112 241 79 111 32 146 41 17 176 81 129 200 32 251 26 254 141 173 190 50 255 0 193 190 31 31 211 254 20 13 143 141 127 103 219 184 206 219 72 52 200 30 203 79 73 72 225 82 25 148 68 36 63 47 203 229 185 62 157 121 254 118 60 69 103 167 235 31 20 181 205 23 192 58 60 203 96 53 251 184 52 139 53 221 35 36 34 103 17 166 73 37 136 76 12 228 253 107 30 23 226 56 230 212 229 135 157 41 66 80 75 226 210 233 222 223 61 53 20 39 204 117 95 24 63 104 15 24 124 106 135 79 183 241 37 165 172 107 167 194 21 90 24 254 121 31 24 102 102 247 244 174 37 43 218 245 111 217 38 215 192 255 0 6 110 252 113 241 27 197 81 105 186 185 1 236 172 75 12 122 249 103 185 99 237 210 188 86 22 93 234 27 145 187 145 95 75 134 158 26 84 220 104 124 41 219 200 209 91 161 44 93 170 104 251 215 188 220 126 199 54 254 58 248 127 167 252 68 248 75 173 161 23 150 107 44 154 117 228 128 97 241 243 42 191 179 110 24 111 206 188 55 80 211 238 52 125 74 125 46 255 0 96 154 222 70 142 64 146 6 25 7 7 4 100 31 194 149 12 77 28 69 212 30 171 117 213 2 119 55 62 24 219 248 58 227 198 250 114 120 242 233 162 210 62 208 62 218 193 88 146 158 159 47 35 235 95 64 106 31 178 47 194 63 136 214 173 171 124 25 248 149 8 45 146 182 210 200 37 94 157 6 48 227 241 6 190 98 139 181 106 120 111 196 90 167 134 117 72 117 141 42 233 227 154 9 3 174 36 101 7 7 56 59 72 56 252 107 44 77 10 213 36 165 78 163 139 95 52 41 110 122 167 197 239 217 39 198 159 10 252 59 7 137 161 187 93 74 1 16 254 208 22 209 146 109 219 215 167 43 239 94 87 23 106 245 125 67 246 215 248 209 168 219 189 171 77 166 199 19 166 214 69 179 12 8 35 31 196 77 121 117 197 228 154 166 161 37 227 70 130 73 220 177 72 151 3 36 246 3 165 70 19 235 106 13 87 181 251 160 141 193 58 126 53 114 198 230 226 198 116 188 181 153 163 150 54 13 27 163 96 130 57 4 26 245 159 130 255 0 177 215 140 190 33 70 154 215 138 166 125 35 76 101 202 146 160 205 40 255 0 101 79 65 238 127 42 233 172 127 96 221 98 57 203 107 31 16 172 45 162 220 112 171 25 102 219 219 36 144 51 88 213 204 176 80 147 140 167 170 38 234 231 137 107 222 38 241 7 139 53 38 213 188 73 171 77 121 112 227 153 38 144 156 15 65 233 94 179 251 58 254 198 255 0 180 95 198 61 67 67 241 86 141 251 52 252 67 215 60 33 170 78 232 53 253 19 194 23 215 22 146 170 187 68 197 39 142 38 140 237 145 89 88 131 193 86 7 161 174 51 227 119 194 253 39 225 79 138 161 240 246 143 226 68 212 227 123 81 35 76 140 188 54 112 71 202 77 126 249 255 0 193 8 219 119 252 18 171 225 99 15 93 115 255 0 79 183 245 243 252 79 158 203 37 202 161 136 161 21 46 121 40 235 117 100 211 119 211 208 153 201 193 31 145 31 182 197 142 139 225 223 1 233 30 15 109 80 218 79 167 204 99 139 74 104 240 228 160 216 75 131 130 187 126 96 114 58 215 204 177 118 173 191 142 159 18 60 69 241 23 246 130 241 166 165 226 11 198 144 193 226 125 66 11 116 102 226 56 210 230 69 85 21 137 27 47 247 171 213 202 162 214 6 45 189 94 191 121 75 225 69 136 251 255 0 189 86 32 239 95 180 63 240 79 31 248 34 79 236 199 240 207 224 166 143 241 155 246 184 240 197 191 138 60 83 169 105 113 234 119 182 26 221 193 77 51 68 137 227 18 8 140 65 130 74 200 135 247 143 41 101 200 59 64 3 39 190 146 231 254 8 21 241 55 87 139 225 156 81 126 207 209 222 204 222 77 172 54 176 88 105 146 92 54 120 17 206 130 35 41 37 120 218 231 63 143 63 39 138 227 204 186 158 38 84 168 210 157 69 23 103 37 107 124 191 164 102 234 43 232 126 20 67 211 240 171 16 244 252 43 210 254 49 120 211 246 109 212 172 245 111 14 252 35 240 203 90 207 111 173 74 182 147 121 108 74 66 178 176 8 89 216 147 198 223 95 173 121 164 61 63 10 250 252 54 37 98 168 251 69 22 175 220 208 181 7 111 194 172 65 219 240 170 240 191 65 90 118 250 30 177 38 154 250 196 122 117 193 181 139 137 46 4 103 96 36 227 150 233 84 236 158 160 105 120 95 198 158 42 240 116 141 55 134 117 203 155 38 145 129 115 111 38 220 227 166 107 119 94 248 201 241 27 197 250 47 252 35 222 34 241 36 183 86 187 195 236 149 87 57 29 14 236 103 189 113 209 178 127 122 172 197 218 177 157 42 114 151 51 74 224 91 139 250 213 187 31 39 237 17 253 161 73 143 120 222 23 174 51 205 82 133 215 251 223 197 86 97 101 207 222 165 32 61 187 84 253 149 102 213 52 24 60 89 240 239 196 113 220 218 220 91 9 146 27 188 43 0 70 113 188 113 199 225 94 83 37 188 150 119 15 107 54 55 198 251 91 12 8 200 244 34 189 35 224 223 237 45 125 224 93 54 199 194 58 214 158 151 58 108 82 186 203 38 236 184 141 186 1 158 56 59 171 103 227 119 193 221 14 243 73 63 22 62 27 221 67 38 159 56 18 221 64 140 0 25 234 203 248 245 21 229 83 173 90 141 95 103 93 232 246 127 231 230 78 219 158 73 7 122 189 166 249 63 108 139 237 11 186 63 52 111 94 153 25 230 169 216 198 215 119 41 111 27 0 206 193 65 102 192 228 227 147 94 163 226 239 217 179 197 158 29 209 97 241 6 139 50 106 144 52 33 231 22 220 180 103 28 224 2 119 15 113 91 213 173 78 156 146 147 181 198 221 143 87 248 157 164 248 63 195 255 0 0 70 147 107 125 37 181 147 67 27 218 32 195 60 172 78 229 95 196 158 107 231 24 122 126 21 179 226 207 30 120 139 197 90 78 151 163 234 138 241 219 105 182 194 8 83 156 57 28 100 251 227 138 198 135 167 225 92 184 74 50 161 6 164 238 219 108 18 177 114 221 182 176 97 216 215 166 233 58 247 140 190 61 127 102 124 59 184 109 50 214 59 4 221 20 235 27 135 32 46 222 114 228 49 199 160 21 230 48 245 252 107 95 195 58 229 247 134 245 171 109 115 77 153 146 107 121 21 208 143 110 223 141 85 122 124 234 235 117 183 168 53 115 67 197 30 21 212 188 27 226 43 143 14 234 139 137 45 223 27 187 56 236 195 216 138 175 7 111 194 189 231 199 159 15 109 126 52 120 91 78 241 213 135 250 29 218 218 150 153 100 140 229 212 2 118 253 65 233 94 14 171 229 177 86 234 9 21 203 66 186 175 13 119 91 130 119 44 193 222 174 89 198 211 78 144 198 185 103 32 1 245 170 112 119 171 150 114 73 12 171 52 50 50 186 54 85 135 80 71 67 90 189 133 35 233 57 188 77 225 31 133 126 5 182 209 238 181 72 161 191 77 61 99 85 134 48 210 238 35 57 219 245 57 230 188 18 230 234 107 235 201 47 46 38 105 30 71 44 206 252 146 73 206 77 84 251 69 221 245 193 154 226 103 150 71 57 102 118 36 154 238 126 25 124 27 215 188 105 124 141 169 88 220 218 216 21 203 93 121 96 118 227 1 177 159 194 188 232 83 167 131 140 165 39 171 220 147 150 135 167 225 87 237 110 174 161 195 67 112 235 142 152 98 43 188 241 247 193 223 6 252 63 209 205 245 231 138 46 30 119 4 91 91 249 107 151 111 240 174 39 195 247 150 122 126 169 13 214 161 98 46 96 87 253 236 13 198 245 238 51 218 170 53 161 90 28 209 212 9 90 246 234 245 131 93 221 75 41 85 194 153 36 45 180 122 12 212 208 244 252 43 216 215 224 183 195 159 19 248 124 107 158 25 134 69 105 237 247 192 169 113 128 91 29 14 236 227 158 181 229 58 199 135 245 111 14 223 54 159 171 88 201 4 138 78 3 175 81 234 15 122 198 157 122 117 174 163 163 65 123 141 139 181 110 248 55 197 23 222 17 214 87 88 211 213 75 136 153 118 158 156 140 126 157 107 10 46 213 106 14 223 133 21 18 146 179 2 243 92 77 117 112 247 87 18 51 60 142 89 217 186 146 121 53 60 93 71 208 85 88 122 126 21 106 46 163 232 43 57 36 128 235 190 16 234 141 165 248 230 206 69 221 182 82 98 147 232 120 254 117 179 241 131 195 55 154 111 138 39 214 22 215 22 183 44 165 100 237 188 142 71 215 140 215 35 225 93 122 243 195 122 196 58 181 142 221 241 55 42 221 8 238 43 190 248 181 227 13 63 197 30 29 210 230 176 159 43 33 103 145 59 163 0 56 63 157 112 212 82 88 152 184 173 30 130 182 183 56 152 122 254 53 232 127 13 35 248 99 119 229 193 171 91 149 189 244 187 111 145 207 183 65 248 26 243 200 122 254 53 106 14 223 133 85 88 123 69 107 216 103 174 107 222 19 248 103 171 106 146 121 154 228 118 147 174 21 162 73 21 64 192 199 0 140 87 53 227 79 8 232 190 25 142 222 109 39 90 251 88 152 144 71 202 113 129 237 92 156 114 72 205 184 177 39 213 170 212 44 205 247 155 53 205 10 50 131 94 246 130 74 197 187 85 223 34 171 54 1 35 154 244 79 137 151 214 182 254 30 210 244 59 43 132 117 68 4 148 108 140 0 5 121 212 61 63 10 183 15 95 198 149 72 41 73 75 176 53 114 204 61 63 10 235 60 15 224 221 63 196 54 242 95 95 107 11 2 68 248 101 227 61 61 73 174 78 30 159 133 92 133 164 85 42 174 216 45 200 172 234 38 227 100 236 13 92 245 31 15 183 195 223 13 220 253 158 207 82 89 37 144 109 119 118 220 48 57 231 181 99 120 203 197 90 94 169 33 179 209 244 248 86 48 223 52 254 88 12 255 0 78 58 87 33 7 111 194 173 65 222 185 213 5 25 115 54 219 37 43 150 160 237 248 85 184 122 126 21 82 14 223 133 91 135 167 225 85 33 200 244 171 59 173 38 243 192 110 177 198 210 195 4 59 93 122 29 192 114 71 227 205 113 86 241 249 147 8 149 176 9 0 22 254 181 191 224 29 66 205 116 27 253 62 254 226 40 212 140 131 43 1 212 99 191 210 185 248 254 66 127 222 174 58 113 229 148 145 39 160 120 110 79 8 232 122 120 183 147 82 183 146 71 25 149 155 156 159 74 163 171 120 235 82 186 118 181 211 216 67 16 56 6 46 164 125 107 150 131 183 225 93 15 131 52 93 55 90 154 91 123 201 217 100 9 251 164 94 254 255 0 133 100 225 24 55 57 106 5 37 149 164 99 44 140 75 30 73 53 209 248 6 205 110 53 111 181 73 140 66 165 190 111 83 192 172 43 203 27 141 54 241 236 238 23 12 135 31 95 122 146 214 73 33 109 209 200 202 125 85 177 68 215 52 52 3 91 92 190 109 67 86 154 109 255 0 40 109 171 244 21 26 117 252 42 172 29 234 210 117 252 42 82 178 176 22 32 237 248 87 85 121 254 131 225 24 97 219 131 46 51 248 243 92 230 147 36 112 223 67 36 138 172 161 198 224 122 98 186 127 22 93 89 173 156 118 123 115 39 84 219 252 2 185 234 95 153 32 48 226 237 86 97 233 248 85 104 187 85 152 122 126 20 222 160 117 218 90 217 223 104 171 28 140 37 8 156 134 234 8 172 52 233 248 212 122 125 253 197 139 22 133 190 240 195 14 196 83 227 239 88 70 60 183 18 86 44 71 222 183 191 182 22 211 79 138 222 14 100 41 201 244 172 24 251 213 168 250 15 173 103 52 158 226 145 60 123 156 22 235 234 106 104 191 165 93 240 242 172 54 115 92 50 255 0 15 242 170 145 117 252 106 83 185 36 240 118 252 42 196 125 234 109 6 207 206 221 52 139 149 11 129 248 211 38 132 219 204 208 183 99 197 69 245 176 18 167 95 194 173 125 150 69 141 102 11 149 101 234 181 85 58 254 21 171 165 220 70 208 173 187 55 205 207 21 148 155 72 10 241 245 31 238 84 209 245 31 74 100 177 180 51 16 203 143 74 124 125 71 210 165 234 5 139 117 18 72 21 59 154 149 84 163 21 126 162 155 98 202 179 7 106 179 121 183 32 149 228 247 172 222 224 36 93 170 104 93 151 231 74 134 46 213 52 95 114 144 22 226 153 89 70 238 189 232 93 189 186 84 81 118 169 42 26 176 19 39 95 194 165 78 159 141 68 157 127 10 149 58 126 53 18 2 68 251 162 165 94 131 233 81 39 221 21 42 244 31 74 144 63 150 159 217 191 227 186 252 100 210 245 79 130 255 0 24 175 18 241 181 56 92 216 92 77 129 146 71 49 140 99 4 117 90 254 144 52 123 159 134 31 183 63 236 137 115 163 223 221 11 143 13 252 70 240 93 206 147 174 71 165 220 24 164 134 59 171 103 183 187 129 91 147 28 137 190 68 245 86 90 254 73 180 189 74 251 71 212 34 213 52 187 183 130 226 7 15 12 177 54 25 24 28 130 15 177 175 105 248 91 251 88 127 193 69 255 0 224 159 30 62 30 42 248 107 241 43 198 158 7 190 215 146 13 82 227 74 214 108 220 217 107 113 58 6 138 119 181 185 67 20 234 209 191 203 40 92 237 111 145 135 21 251 207 24 112 165 76 213 66 120 105 168 202 55 105 62 187 94 221 182 93 206 170 148 249 182 62 190 253 176 255 0 224 212 223 218 15 224 206 153 127 227 79 217 63 226 69 167 196 189 38 209 90 101 240 237 253 160 176 214 146 33 147 182 49 184 195 116 202 163 179 68 204 120 72 201 226 173 127 193 46 63 97 239 6 248 207 226 151 131 254 2 107 9 109 14 174 207 45 247 136 25 182 173 221 164 49 128 215 1 67 2 202 192 5 136 100 112 204 13 126 165 127 193 26 63 110 127 140 127 240 80 79 216 218 63 140 255 0 29 254 27 219 120 123 196 186 111 137 110 180 59 217 52 248 36 138 215 85 242 34 130 65 123 2 72 75 34 183 157 229 176 220 195 204 134 76 96 124 171 241 199 236 97 169 124 57 248 123 255 0 7 72 252 120 240 62 134 240 203 111 171 248 66 236 105 187 6 4 122 148 208 105 26 133 224 80 6 55 7 91 192 122 127 23 227 241 120 92 243 52 250 190 43 7 137 178 169 70 50 105 164 175 117 101 102 214 142 215 190 221 238 102 167 45 83 232 125 227 251 87 126 210 223 176 135 252 19 3 246 127 183 214 190 56 71 164 248 107 194 215 243 166 155 167 232 86 26 55 218 174 53 105 130 150 242 214 5 82 211 144 160 179 201 33 192 254 38 203 12 224 255 0 193 54 188 27 251 8 120 186 63 22 254 218 255 0 176 21 205 132 94 26 248 179 6 153 22 181 164 233 22 38 210 222 207 80 211 154 240 57 54 197 84 219 76 194 241 68 145 5 85 253 218 200 185 243 55 55 192 127 240 119 111 194 79 136 94 33 176 248 35 241 106 211 78 188 185 240 174 141 54 181 166 234 115 197 27 52 54 55 151 63 99 120 75 144 54 169 149 96 144 41 61 124 156 87 177 255 0 193 171 191 8 190 33 124 61 253 138 60 93 227 15 18 216 92 218 104 94 44 241 193 186 240 212 51 169 85 184 72 173 163 134 107 164 7 170 179 168 143 61 205 185 244 175 9 229 210 143 12 75 48 85 157 231 37 25 70 250 75 222 217 174 173 89 72 155 62 75 220 229 180 223 218 15 196 144 127 193 210 122 143 192 55 182 137 244 233 101 87 89 78 119 167 252 80 209 207 129 255 0 2 83 255 0 125 84 223 240 117 244 122 135 252 51 255 0 194 107 219 40 89 227 135 198 23 223 104 35 248 20 218 168 7 233 154 243 65 113 5 183 252 30 31 117 37 196 170 138 94 53 220 204 0 220 223 15 213 64 250 146 64 21 236 63 240 117 127 195 175 136 94 36 253 144 252 3 227 255 0 10 105 151 87 90 87 135 60 114 233 226 51 105 3 63 217 225 184 181 113 28 210 109 206 216 195 196 16 177 227 116 136 59 215 169 66 126 195 61 203 38 180 110 148 63 30 100 11 226 143 200 207 255 0 131 82 228 243 62 2 252 88 63 245 54 216 127 233 43 215 205 255 0 182 239 236 169 173 254 221 159 240 113 191 141 255 0 102 107 29 81 244 251 27 233 244 75 157 119 83 137 65 107 61 62 31 14 105 210 204 224 19 130 204 6 196 255 0 110 68 207 25 175 177 127 224 216 255 0 128 62 62 248 87 251 25 248 147 226 87 142 252 61 121 166 39 142 60 88 46 116 56 47 97 49 180 214 48 91 164 107 114 21 128 59 94 70 152 41 61 68 121 28 16 79 27 251 61 248 159 195 122 7 252 29 109 241 211 73 215 164 65 117 174 124 51 178 178 209 67 227 45 116 186 54 129 112 219 125 252 139 121 255 0 12 215 77 124 202 174 23 138 115 12 78 25 234 169 202 205 119 92 139 240 107 240 41 187 78 77 30 209 251 88 254 212 127 240 79 47 248 32 95 194 15 8 232 30 25 248 8 178 234 250 247 155 111 161 105 94 28 179 128 106 87 233 2 198 46 46 239 47 37 195 144 60 196 5 152 179 51 56 10 187 67 20 231 188 117 240 75 246 45 255 0 130 244 126 194 179 126 209 127 1 62 31 15 13 120 218 47 181 69 162 106 242 233 208 90 234 86 90 189 186 134 54 55 141 27 108 158 7 204 120 44 236 2 76 174 187 27 34 187 79 248 43 199 237 105 255 0 4 237 253 144 181 63 4 248 171 246 242 253 135 102 248 158 186 236 119 118 158 30 241 12 95 13 244 109 110 61 57 162 49 187 218 188 218 132 209 180 12 226 77 234 139 195 4 115 252 6 188 51 246 117 255 0 131 136 255 0 224 148 158 3 83 240 187 246 112 253 141 62 34 120 66 202 254 238 75 233 244 207 11 252 62 208 116 235 86 155 202 85 123 135 142 219 80 85 45 229 196 128 190 220 237 140 103 133 175 3 13 253 160 232 71 27 134 133 71 89 59 186 156 215 77 95 84 213 200 77 238 183 62 16 255 0 130 86 254 219 191 12 63 103 207 218 37 252 65 251 103 94 220 106 94 12 211 180 11 216 206 153 168 105 109 168 60 87 234 83 201 9 9 82 11 130 174 163 118 21 119 100 145 138 253 8 248 107 255 0 7 50 255 0 193 56 188 93 227 219 47 132 122 143 193 207 28 120 99 195 250 165 228 118 195 90 213 180 45 60 88 192 204 85 85 238 34 130 229 217 35 24 229 149 95 27 70 70 50 71 13 255 0 4 98 255 0 130 108 254 206 191 30 254 39 252 87 253 179 254 46 252 54 181 241 6 145 63 196 107 200 188 1 225 223 17 219 44 176 217 35 176 188 105 46 45 203 50 75 42 165 204 40 161 247 170 149 114 50 112 70 143 199 223 248 56 57 62 23 126 215 58 207 236 23 251 45 254 193 182 158 36 254 199 241 116 158 19 68 187 214 5 138 106 26 130 76 45 93 35 180 134 213 194 66 36 82 170 197 142 245 218 216 81 197 123 185 213 124 30 117 152 53 70 140 165 56 197 115 90 106 17 143 93 19 90 181 125 111 216 185 53 55 162 27 255 0 7 8 127 193 58 126 7 248 47 224 35 254 218 191 6 60 7 101 225 173 99 68 214 45 109 188 93 107 163 89 172 54 151 246 183 82 44 9 59 196 128 34 76 179 188 35 122 129 191 206 109 217 59 77 125 77 255 0 4 28 144 77 255 0 4 163 248 87 34 244 99 174 127 233 247 80 172 223 248 56 73 202 127 193 32 190 45 58 245 15 225 239 253 72 116 218 179 255 0 4 6 98 223 240 73 31 132 206 79 81 174 255 0 233 251 80 175 23 17 142 196 226 248 66 48 173 39 46 74 201 43 246 228 110 223 43 178 27 110 26 158 13 255 0 4 16 255 0 130 126 207 224 175 24 252 67 253 186 254 38 232 173 22 163 226 63 21 235 26 127 128 173 238 97 195 65 96 47 101 91 139 208 24 100 25 93 124 180 63 243 206 55 60 172 162 190 36 255 0 130 215 255 0 193 78 165 253 182 127 105 185 254 14 252 39 214 4 255 0 13 190 29 222 75 105 166 92 91 72 76 122 198 162 62 73 239 184 225 144 16 98 136 243 242 238 112 127 123 138 253 133 248 15 241 63 192 63 240 82 143 216 51 196 126 25 240 46 181 39 131 206 167 99 173 120 35 90 30 27 111 42 95 14 223 194 36 180 127 33 87 27 0 83 28 241 174 127 213 204 128 154 252 0 135 246 8 248 221 240 151 227 191 137 63 103 79 24 248 125 45 117 143 11 106 111 105 168 222 74 197 109 228 65 134 142 226 54 60 178 75 27 36 169 198 74 176 233 94 223 12 201 99 243 202 152 156 84 146 157 53 100 159 68 180 211 250 221 223 169 112 214 87 103 244 107 240 243 197 191 9 191 224 160 159 177 124 122 133 174 163 246 159 11 252 76 240 60 250 118 176 154 93 201 142 75 117 186 182 107 123 187 112 195 38 41 99 47 34 122 171 45 126 70 254 213 31 240 108 159 199 31 132 218 85 231 138 255 0 102 239 137 16 252 72 210 108 145 165 139 65 212 33 251 38 175 28 67 39 100 99 113 134 225 128 29 154 38 99 194 198 79 21 197 124 57 248 91 251 113 254 192 254 39 183 215 63 103 47 143 218 223 131 78 161 12 55 186 142 153 169 89 147 99 170 18 185 87 107 73 148 197 42 148 56 89 8 221 134 249 88 87 236 47 252 19 95 246 152 248 175 251 84 126 205 80 248 251 227 95 135 180 235 31 17 105 250 204 250 93 237 214 145 27 199 105 168 249 73 19 139 152 145 217 138 3 230 108 101 220 71 153 27 227 3 229 30 93 122 120 190 25 174 235 225 39 25 210 147 234 175 232 159 249 167 235 216 151 120 59 163 240 87 246 18 253 143 117 239 218 151 246 153 240 255 0 236 223 164 75 54 148 215 247 178 127 109 221 201 15 207 167 90 192 11 220 57 86 199 206 170 165 85 79 252 180 101 6 191 111 188 107 113 255 0 4 247 255 0 130 61 124 26 211 53 211 240 218 219 76 251 68 235 99 167 190 153 164 199 121 174 107 55 10 155 153 154 103 42 206 64 27 153 157 214 53 200 3 110 85 107 229 207 217 7 91 248 93 224 15 248 56 227 227 143 195 173 30 27 93 186 199 135 238 27 73 146 53 219 141 74 91 125 50 250 241 20 14 51 184 94 22 56 206 85 169 63 224 229 102 241 71 133 207 194 15 136 241 232 207 123 162 219 220 234 186 124 140 232 198 27 123 185 69 180 136 24 142 3 72 145 62 223 95 37 189 43 187 59 199 226 51 188 195 15 132 131 112 167 40 69 242 222 215 114 77 235 222 219 124 159 113 201 185 52 143 172 124 7 117 251 2 255 0 193 89 126 18 93 120 199 254 21 109 134 173 246 123 131 107 121 253 181 162 197 111 172 233 19 149 12 167 204 66 204 153 7 112 40 237 27 96 131 187 12 7 200 63 179 44 218 255 0 236 235 255 0 5 148 240 215 236 105 115 225 251 120 237 116 219 141 74 91 77 77 84 3 121 102 250 37 220 240 74 170 184 10 74 224 48 231 12 174 43 169 255 0 131 117 181 15 29 120 186 195 226 119 143 117 13 10 27 13 1 219 75 177 180 146 8 153 86 234 233 5 195 184 201 36 19 26 72 153 255 0 174 194 160 248 213 227 79 12 234 191 240 115 167 194 109 27 73 158 52 155 71 248 115 53 150 178 124 204 127 165 190 153 173 78 129 179 220 195 113 0 3 233 92 52 227 91 45 197 226 242 249 203 154 10 156 244 189 210 124 183 211 210 246 252 201 213 54 131 254 14 105 215 31 72 248 71 240 153 34 255 0 150 254 45 190 83 248 91 37 107 255 0 193 183 51 121 223 5 254 37 55 253 76 214 95 173 187 85 111 248 57 151 225 143 140 60 85 251 53 252 61 248 141 160 104 247 23 122 119 134 60 109 34 235 79 109 11 63 217 99 184 182 101 73 159 110 118 198 30 37 66 199 141 210 32 254 42 236 255 0 224 223 31 130 190 52 248 113 251 40 107 190 61 241 142 139 117 167 167 140 60 68 179 233 16 221 198 81 167 179 134 5 69 156 6 0 237 103 105 0 61 196 121 28 16 78 145 196 69 112 68 160 229 175 50 73 127 219 215 252 181 26 127 186 60 110 211 196 18 77 255 0 7 67 93 232 36 252 177 21 199 227 224 144 223 214 190 245 253 171 188 11 251 47 233 122 207 135 127 106 255 0 218 179 89 209 108 244 63 133 246 26 137 179 151 196 91 77 156 51 222 61 160 19 148 108 249 147 47 217 182 70 155 88 150 155 42 55 133 175 207 141 55 254 86 169 212 127 223 143 255 0 80 85 174 191 254 14 133 213 117 185 255 0 103 207 133 222 7 182 191 146 61 59 84 241 204 247 23 214 232 196 44 207 5 163 8 247 99 168 95 57 206 15 122 229 197 66 174 43 27 130 167 25 52 221 24 43 173 236 249 147 252 46 133 213 122 7 197 93 79 246 115 255 0 130 215 126 220 223 15 252 49 251 61 252 85 125 99 225 247 130 60 33 119 121 227 125 66 211 69 186 176 154 28 220 198 177 218 160 186 130 39 221 41 40 1 0 170 170 202 71 32 131 245 23 237 3 251 81 254 192 31 240 73 47 135 218 30 147 226 157 34 207 195 81 106 123 227 208 188 61 225 157 28 92 106 23 161 0 18 74 121 12 193 119 40 105 101 126 75 99 36 215 198 159 240 109 13 191 133 124 43 226 207 138 158 22 81 26 234 186 134 145 164 93 90 131 212 219 193 37 210 77 143 109 243 193 154 243 255 0 248 56 211 224 127 196 11 175 219 83 193 255 0 24 245 205 62 230 127 9 106 94 8 131 74 211 111 150 54 48 219 221 193 117 115 36 182 236 113 181 88 172 232 227 39 230 12 216 251 134 182 196 96 170 212 205 161 148 78 163 84 224 180 87 222 235 155 239 215 126 195 179 230 229 45 126 220 159 180 207 236 237 255 0 5 62 248 237 240 83 193 223 177 142 159 12 26 190 187 168 223 105 222 34 154 251 195 255 0 98 188 129 230 146 204 68 215 36 12 76 145 162 204 234 85 220 127 172 3 158 43 238 239 137 254 46 253 144 63 224 140 159 178 190 157 226 175 16 248 126 230 253 133 244 90 117 132 145 66 146 234 122 206 160 232 204 78 247 32 68 129 81 216 242 18 53 92 40 44 66 183 230 31 252 18 94 207 193 254 3 255 0 130 129 252 47 214 181 136 163 72 36 213 110 173 34 102 81 143 180 79 99 113 4 0 123 249 178 199 138 253 90 255 0 130 155 252 113 253 147 127 103 79 131 122 63 197 63 219 11 246 93 184 248 153 225 184 188 64 182 86 203 15 131 180 237 100 105 55 18 198 229 102 117 190 145 22 20 111 47 103 152 167 239 50 47 241 10 211 61 165 91 3 87 15 150 167 41 83 74 246 190 174 242 122 95 203 160 75 75 35 142 248 113 227 143 216 207 254 11 79 240 11 93 75 31 8 203 167 234 122 84 235 13 197 204 214 177 13 71 71 185 145 25 160 184 138 100 39 122 54 27 134 32 63 150 225 151 161 175 201 127 22 248 99 91 248 109 241 31 196 95 10 60 86 170 186 175 134 117 155 173 50 252 39 33 165 130 86 141 153 113 156 131 183 35 218 190 243 248 87 255 0 5 222 255 0 130 86 252 27 107 168 254 7 126 198 158 54 240 187 234 230 21 190 143 194 159 14 244 43 22 188 41 184 68 28 65 124 190 110 223 49 246 231 56 243 14 58 154 248 59 227 239 199 111 7 254 210 223 181 207 142 190 59 252 56 208 245 93 55 64 241 70 172 151 150 22 122 220 49 199 117 30 97 141 95 204 72 228 145 1 50 43 159 149 207 13 248 87 165 194 239 27 134 197 206 148 163 37 73 234 148 186 63 235 242 42 23 76 142 30 191 141 89 131 170 253 106 180 61 127 26 179 7 85 250 215 221 189 205 143 82 248 77 241 251 88 240 156 105 225 239 18 111 189 211 74 108 27 185 120 23 253 159 81 236 107 152 210 124 63 121 227 15 21 29 19 195 113 249 175 113 59 249 27 184 27 114 72 36 246 24 172 11 117 102 101 85 60 150 0 87 190 252 35 240 27 124 33 240 246 165 241 3 198 17 34 207 28 36 91 168 96 112 164 100 96 250 177 32 87 155 95 217 225 111 56 47 122 90 122 178 26 177 228 154 239 135 117 143 10 234 210 104 186 229 175 147 113 19 124 203 184 30 59 16 71 173 71 7 111 194 164 241 6 189 125 226 125 114 231 93 212 36 221 45 204 197 219 219 61 0 250 10 142 14 223 133 110 185 185 61 237 199 35 173 248 87 226 237 31 193 190 32 254 212 214 180 84 189 139 202 33 81 148 18 141 216 174 238 149 212 248 143 246 136 241 150 180 222 78 139 179 78 128 55 11 15 44 71 187 31 233 92 79 131 252 19 226 15 25 95 29 55 67 181 15 40 77 216 118 218 48 61 207 21 171 171 124 46 241 231 135 97 107 173 83 195 179 71 18 12 180 171 134 80 62 160 154 226 169 12 52 171 94 86 191 159 249 19 100 200 188 65 226 173 107 197 218 147 106 218 229 211 75 41 80 0 232 0 29 128 237 80 193 222 170 67 211 240 171 112 119 173 57 84 82 72 13 255 0 15 248 223 197 30 31 88 99 210 117 137 162 72 36 47 26 6 224 19 140 241 232 113 210 187 251 239 140 94 31 241 127 131 231 211 252 89 225 244 147 80 72 177 111 34 116 45 235 158 171 94 87 7 111 194 173 194 187 153 87 214 185 42 208 167 54 155 90 174 187 1 110 14 245 106 14 223 133 116 90 247 194 61 115 195 254 27 181 241 36 51 37 220 82 70 26 227 236 252 249 89 233 245 30 245 206 193 219 240 169 231 133 69 120 176 61 143 193 190 3 240 71 196 143 8 193 168 253 139 236 215 145 175 151 59 219 54 62 97 220 142 156 245 174 11 196 90 28 158 29 215 39 210 89 101 196 79 132 105 35 218 72 236 113 85 188 55 226 239 16 120 101 191 226 79 169 60 42 101 87 100 94 132 143 81 94 147 125 226 15 4 252 78 240 155 222 235 147 37 150 165 103 22 119 119 39 253 159 80 125 59 87 19 246 148 42 93 235 23 248 1 231 48 118 252 42 220 108 220 46 238 7 65 85 33 251 223 47 35 177 171 80 119 173 218 2 228 61 127 26 179 15 79 194 186 191 129 118 186 93 230 185 115 107 168 88 195 51 27 124 194 210 198 24 161 7 4 140 244 224 214 6 181 103 246 29 114 238 205 87 2 43 151 80 62 132 138 230 246 137 213 112 236 2 65 222 173 65 219 240 170 176 119 171 80 118 252 41 61 128 213 177 209 53 107 187 23 212 173 244 249 30 8 254 252 161 120 24 235 154 88 122 254 53 219 120 79 253 31 225 13 244 221 55 239 31 200 87 19 15 95 198 185 99 81 201 201 118 98 78 229 152 122 126 21 216 120 31 92 240 125 157 131 233 190 34 211 55 153 28 159 59 110 113 199 24 238 43 143 135 167 225 86 225 235 248 212 212 138 154 179 6 174 122 102 155 224 63 4 235 146 27 205 38 248 188 123 72 104 150 76 227 35 143 126 43 158 241 39 132 111 188 51 117 178 79 158 22 111 221 204 189 62 135 222 178 52 157 107 84 210 213 151 79 190 120 67 253 237 141 140 226 172 205 172 234 151 203 229 222 106 19 74 188 124 175 33 34 185 163 78 172 101 241 93 121 146 149 197 131 183 225 86 225 233 248 86 215 195 29 47 75 213 174 174 96 212 44 210 93 176 130 129 215 56 57 172 171 136 126 207 121 45 190 220 108 114 49 244 52 115 167 55 30 192 217 191 224 251 95 11 221 67 42 248 130 235 203 124 143 40 238 35 142 245 210 105 126 11 240 141 213 194 181 150 169 231 47 83 23 152 14 71 225 131 92 4 29 191 10 191 167 222 93 88 205 231 218 220 24 223 24 220 141 131 205 97 82 18 110 234 66 58 111 18 120 45 116 117 55 86 55 136 98 255 0 158 110 223 50 253 61 107 55 75 186 154 194 242 59 171 121 54 186 48 32 213 63 62 107 134 243 38 153 220 158 164 182 106 120 59 212 168 181 27 73 220 15 66 214 116 187 29 107 73 109 81 144 52 235 111 149 100 108 140 227 61 171 143 131 183 225 79 209 245 205 71 75 66 182 243 102 54 24 104 207 32 211 99 249 155 112 238 107 26 113 148 46 155 2 204 29 234 210 117 252 42 172 29 234 221 188 109 35 8 227 92 150 56 2 135 160 26 182 186 29 196 154 73 214 86 100 8 167 149 110 188 122 82 73 113 53 220 222 116 205 150 61 254 149 179 121 111 53 143 132 99 181 242 72 99 141 227 211 156 214 28 125 7 214 185 212 185 149 192 189 167 217 220 95 73 229 219 174 230 3 59 119 85 151 211 239 45 71 250 69 171 168 245 101 170 154 125 212 150 119 9 113 19 97 148 131 93 92 122 166 147 174 71 246 25 36 101 46 1 29 185 172 231 41 69 249 9 187 24 48 244 252 42 204 29 191 10 126 161 163 220 105 109 185 190 104 207 221 117 254 180 200 59 126 21 55 77 12 177 31 122 181 31 65 245 170 177 247 171 75 25 93 165 213 134 87 34 179 145 50 58 24 100 181 143 71 18 50 225 89 57 11 220 214 100 125 234 53 184 150 72 86 221 155 229 76 224 83 226 254 149 17 143 41 38 207 135 153 131 58 134 224 14 149 12 140 205 59 59 54 78 106 45 62 238 107 60 180 106 167 112 231 117 61 95 115 51 158 237 89 219 80 39 141 91 105 249 122 117 169 225 102 86 12 131 4 116 171 58 93 170 181 155 179 127 203 74 175 183 203 144 171 14 156 86 123 129 122 226 234 59 136 211 229 249 192 228 211 99 234 62 149 12 125 71 251 149 61 186 180 172 21 123 212 181 96 38 139 181 93 153 150 72 85 183 115 233 81 205 110 176 219 170 168 232 121 52 200 251 214 109 220 9 162 237 86 45 228 242 198 71 67 214 171 197 218 166 139 167 225 72 11 140 171 39 221 110 69 34 171 41 203 212 81 141 173 214 166 243 88 253 234 134 172 4 137 215 240 169 163 86 197 66 157 127 10 148 16 122 84 72 9 106 69 232 62 149 18 125 209 82 175 65 244 169 3 248 215 210 124 47 226 45 114 206 231 80 209 116 91 155 168 172 208 27 151 183 132 191 150 9 192 39 21 251 211 240 43 254 14 4 255 0 130 57 107 127 4 124 39 240 155 227 126 183 170 104 241 248 127 195 214 54 15 101 227 15 134 243 94 66 30 222 221 99 220 169 100 151 72 1 49 252 184 254 242 254 31 150 126 1 181 143 246 115 253 146 111 188 89 125 10 197 172 120 129 63 112 178 46 24 51 141 168 48 127 186 185 98 43 229 11 205 54 219 80 145 166 154 53 37 155 38 191 163 179 172 150 135 20 194 211 110 42 155 124 173 59 107 165 247 76 236 148 125 161 253 16 252 124 255 0 131 134 255 0 98 239 134 31 8 238 38 253 145 124 57 169 120 230 254 61 45 142 131 21 190 131 54 153 165 91 225 78 198 144 76 145 204 16 112 124 184 226 201 28 110 78 163 240 143 225 47 237 119 251 66 120 19 246 196 135 246 239 95 21 155 207 136 41 226 249 124 67 119 127 114 191 187 188 154 87 99 60 46 131 24 134 72 221 225 40 184 196 109 181 113 129 91 159 177 255 0 142 52 159 11 252 67 139 195 62 44 145 101 211 53 80 182 195 206 229 98 126 138 121 236 122 26 173 251 79 124 37 177 248 79 241 74 231 78 210 90 38 176 190 205 205 154 163 2 99 86 234 135 232 107 201 200 184 79 9 148 226 170 81 171 239 115 173 222 183 93 81 49 166 162 207 219 239 135 191 240 114 183 252 18 179 226 239 194 67 47 237 9 169 106 190 18 212 165 180 3 85 240 86 191 224 251 173 86 57 228 28 180 113 203 109 12 176 202 155 128 42 210 249 95 195 149 83 192 247 95 248 38 15 252 20 143 193 159 240 81 235 111 136 62 39 248 61 240 226 231 195 254 3 240 102 175 101 163 248 77 245 8 86 43 139 248 252 134 105 38 104 144 148 129 50 21 99 136 18 66 174 78 11 108 95 230 2 227 71 178 186 249 228 141 73 175 210 95 248 33 175 252 21 163 246 108 255 0 130 111 252 45 241 207 195 127 142 62 21 241 141 244 218 254 181 22 169 166 201 225 173 62 210 104 149 34 183 42 232 230 123 168 72 115 142 0 4 123 215 206 113 7 1 211 192 96 42 86 193 169 73 221 89 94 246 87 87 183 249 187 232 68 233 40 173 14 23 254 10 235 241 183 198 223 179 71 252 28 21 227 191 143 255 0 15 26 63 237 143 9 107 158 22 212 236 99 155 152 231 242 244 13 48 180 47 142 124 185 23 40 216 231 12 113 95 167 159 12 63 224 229 207 248 38 15 140 124 11 6 189 227 223 29 120 147 193 222 32 104 135 159 225 43 255 0 9 95 94 220 121 221 25 34 154 206 25 97 144 103 238 150 116 36 17 149 83 192 252 71 255 0 130 144 254 213 127 15 191 110 127 248 40 39 196 31 218 179 225 78 129 174 105 190 30 241 83 105 95 217 246 94 36 181 134 27 216 254 205 165 89 217 191 152 144 75 42 12 201 110 229 113 33 249 88 103 7 32 121 19 105 54 207 56 184 95 149 213 178 172 188 16 107 214 167 194 56 124 239 36 195 123 116 225 82 16 75 77 30 203 71 163 26 166 165 4 126 232 120 7 254 14 91 248 111 171 124 101 241 157 207 139 191 102 47 137 255 0 240 175 227 180 211 160 240 27 105 58 62 159 37 237 196 168 110 154 250 234 236 79 121 8 132 62 251 69 142 36 105 112 33 118 98 165 246 215 229 239 237 133 255 0 5 2 191 248 175 255 0 5 91 241 23 252 20 71 246 84 143 94 240 196 163 85 210 47 60 56 190 34 179 133 46 224 150 207 75 180 179 149 39 138 25 101 140 163 180 18 2 162 70 13 20 152 108 100 129 149 240 99 246 167 176 240 127 133 230 208 124 119 225 243 169 77 12 63 232 55 67 0 185 31 192 231 25 252 107 173 210 126 54 126 202 63 16 33 16 124 64 248 110 52 233 220 124 247 2 220 56 67 236 233 134 253 40 203 184 82 25 86 46 85 93 38 211 143 43 179 186 105 218 250 62 246 215 230 53 14 86 126 146 252 42 255 0 131 139 127 224 155 31 180 231 194 196 248 113 255 0 5 0 248 84 222 30 185 154 56 198 185 166 107 190 17 62 32 208 110 165 28 121 145 44 113 203 38 51 185 130 201 14 87 160 103 235 92 95 198 191 248 43 63 252 16 163 224 167 193 15 29 120 27 246 36 248 69 166 205 226 143 21 248 75 81 209 244 253 83 193 191 11 127 179 113 45 213 164 144 163 77 113 119 29 188 162 21 105 62 96 3 28 103 106 156 243 249 51 241 75 69 240 29 199 142 53 24 124 15 3 29 37 102 197 155 59 22 37 113 215 45 207 53 207 217 248 95 77 134 101 153 33 92 142 126 237 11 128 240 113 171 207 74 115 140 30 188 188 218 124 214 255 0 136 149 37 125 15 214 15 216 83 254 10 181 225 15 248 39 166 177 255 0 8 239 199 15 13 234 87 31 15 60 107 26 93 127 105 232 240 249 211 233 23 232 161 119 249 89 30 108 50 70 80 54 211 185 124 181 32 54 72 175 69 253 167 63 224 185 223 240 72 47 133 122 142 173 251 72 126 201 127 8 116 127 28 124 111 212 116 199 135 77 241 12 127 14 223 78 146 27 135 140 160 146 242 238 230 24 165 96 160 144 222 86 247 144 47 151 185 84 238 95 203 111 138 31 27 172 126 36 124 53 208 254 30 183 133 124 182 210 33 143 126 161 37 198 76 142 19 99 97 66 244 35 29 235 204 163 240 190 151 230 121 194 21 205 58 156 19 135 196 214 85 230 220 100 244 146 79 73 36 250 250 173 208 253 154 110 231 233 215 252 20 43 254 11 243 251 42 126 219 223 240 79 79 19 254 202 246 95 12 190 38 89 248 207 196 186 86 147 230 234 55 122 30 157 14 154 47 173 175 109 46 228 59 150 250 73 4 37 237 220 12 70 78 24 116 234 59 143 248 37 111 252 22 155 246 111 253 145 63 96 31 7 252 11 248 139 240 131 226 110 161 168 248 66 29 81 245 45 83 66 209 116 249 44 100 243 245 43 187 181 17 60 215 209 59 17 28 232 27 40 48 217 237 201 252 168 240 191 132 87 90 215 236 244 189 55 77 19 207 61 194 36 80 237 251 228 144 0 175 174 254 56 106 223 15 126 28 252 35 63 15 245 69 182 182 212 238 244 70 75 123 107 56 112 155 194 133 56 3 166 73 226 176 197 240 150 10 134 17 96 162 155 82 151 54 251 52 173 247 91 160 157 53 107 17 127 193 38 127 224 172 122 31 236 17 251 65 252 75 241 135 196 15 13 248 159 86 248 109 241 14 250 235 80 151 70 209 173 224 146 246 210 244 92 59 219 206 177 203 50 71 147 28 143 20 128 72 51 242 28 183 150 5 117 159 240 84 127 248 42 223 236 143 251 110 106 222 29 248 165 251 49 120 83 226 143 132 190 33 232 237 246 29 74 235 94 210 108 96 178 213 52 195 185 149 100 107 123 217 155 205 138 67 242 29 156 172 142 24 240 184 248 142 29 62 213 99 242 214 49 143 74 146 29 15 79 142 67 34 194 160 215 170 184 87 9 79 31 28 92 27 83 86 79 179 210 218 175 53 185 92 170 247 63 111 190 20 127 193 122 255 0 224 149 26 247 194 175 15 120 15 227 103 137 117 125 33 244 221 30 214 214 230 15 21 124 63 154 238 35 44 80 170 179 5 179 75 149 0 148 227 31 222 21 129 251 71 255 0 193 203 191 176 175 194 15 1 201 225 207 217 3 194 218 167 143 181 152 237 26 45 18 222 29 6 93 35 72 182 108 16 166 83 112 177 203 176 30 118 71 23 205 211 114 125 234 252 105 255 0 132 62 29 106 65 28 122 121 149 152 225 85 35 201 38 189 19 225 95 236 95 226 239 29 71 113 116 186 111 246 95 146 161 161 58 133 171 162 203 158 202 113 253 43 193 175 192 249 109 42 174 115 168 212 111 123 55 167 229 114 125 148 78 111 225 167 237 9 251 64 105 95 180 99 254 217 35 198 147 127 194 194 147 196 242 120 129 245 135 140 16 215 111 33 119 82 159 119 203 96 204 134 47 187 229 182 207 187 95 175 191 11 63 224 225 15 248 39 231 199 175 134 203 224 47 219 143 225 228 254 25 186 184 133 99 215 116 221 87 194 239 174 104 119 142 49 150 65 28 114 200 84 145 184 44 145 124 189 55 55 83 249 95 227 239 217 239 198 95 9 108 69 215 136 154 192 66 205 136 252 155 197 44 255 0 68 56 63 165 113 23 90 14 159 168 127 199 196 42 107 215 199 240 214 93 154 225 233 242 187 56 104 165 29 62 95 33 184 70 71 235 239 198 191 248 56 171 254 9 243 251 59 124 49 147 193 31 176 255 0 195 251 143 21 223 65 110 241 104 26 86 151 225 119 208 244 75 55 57 195 72 37 142 41 2 3 243 20 142 44 183 77 203 212 126 86 252 47 253 166 62 63 71 251 91 71 251 117 120 151 90 254 210 241 231 252 37 75 175 220 207 52 123 98 184 144 48 38 223 106 253 216 12 99 201 10 191 118 62 6 48 43 146 177 240 78 143 4 130 85 183 25 207 247 107 211 62 5 248 235 195 191 11 252 65 38 173 173 120 101 53 24 90 216 162 68 209 169 40 217 200 35 119 74 195 1 194 248 108 182 51 154 78 110 74 206 239 87 126 128 169 168 163 246 83 225 143 252 23 183 246 9 241 183 131 160 215 60 103 173 120 163 194 122 195 68 60 255 0 15 95 248 70 250 233 214 79 226 84 184 181 138 72 25 115 209 217 211 35 168 7 129 230 250 87 252 28 25 240 211 78 248 157 227 29 107 199 31 4 60 110 222 2 130 214 194 47 6 54 141 101 99 37 228 178 41 185 55 151 55 98 123 168 86 16 251 173 86 56 213 164 192 141 203 21 47 138 252 221 241 135 237 25 113 226 75 133 125 51 193 186 117 164 65 249 222 187 216 143 208 10 230 124 127 227 171 207 31 31 178 181 154 89 216 39 250 187 59 126 159 86 61 205 120 16 224 104 58 206 234 209 125 221 218 244 219 245 234 79 178 61 207 64 255 0 130 144 124 20 191 255 0 130 210 94 255 0 193 72 98 240 95 140 19 192 242 50 237 210 100 211 237 127 181 184 240 216 210 207 238 197 201 135 253 120 221 254 187 253 95 63 123 229 173 175 248 43 207 252 21 59 224 39 252 20 83 195 158 4 240 103 193 111 0 248 223 74 185 240 182 189 117 121 127 47 138 180 219 56 35 146 57 33 84 2 51 5 212 196 144 71 57 2 190 83 180 209 108 109 148 172 112 128 9 231 229 174 167 225 31 194 109 47 199 158 56 180 208 89 102 137 38 99 230 77 4 59 202 1 220 242 48 61 235 219 124 55 131 163 82 150 33 183 122 81 73 107 209 127 195 148 224 150 167 65 251 50 254 209 223 20 63 100 175 138 218 55 199 79 132 243 68 117 45 44 52 119 86 55 74 76 26 133 171 128 37 182 148 14 118 176 29 71 42 202 172 57 2 191 80 188 25 255 0 5 240 255 0 130 110 124 95 240 95 246 39 237 29 99 169 248 74 89 163 31 218 90 31 137 188 39 54 175 102 206 57 194 61 172 83 9 84 17 193 120 227 63 236 138 248 47 227 55 195 159 135 63 6 126 25 155 29 11 75 89 117 29 70 81 10 221 92 252 242 109 28 177 29 135 28 113 95 62 95 120 83 73 213 27 117 197 186 18 127 217 172 243 44 147 5 159 90 186 188 100 180 77 104 221 129 198 51 212 250 223 254 10 157 255 0 5 14 253 145 255 0 104 151 248 113 225 223 216 109 110 44 229 240 102 171 125 122 117 43 15 12 157 42 8 30 65 108 99 104 3 42 62 224 240 41 39 96 198 209 95 69 254 207 223 240 95 15 217 211 199 31 13 162 248 101 251 123 248 2 230 199 80 146 204 91 107 26 164 26 8 212 180 125 89 49 130 242 91 160 103 140 183 86 140 68 233 158 65 3 10 63 48 180 159 4 232 250 92 130 75 123 117 7 253 218 212 186 240 254 155 168 199 229 220 91 169 255 0 128 214 53 56 91 11 87 3 10 21 27 110 23 105 223 85 119 119 168 157 52 213 143 211 104 191 224 168 31 240 66 79 217 239 81 111 27 124 9 248 97 163 234 26 212 127 188 182 147 193 223 10 154 210 230 55 201 33 99 146 242 27 113 23 32 31 149 128 251 190 149 240 255 0 192 191 6 254 206 186 167 133 173 111 181 239 19 11 107 167 183 6 120 254 209 140 54 57 227 109 121 5 191 195 127 14 172 194 95 178 166 119 127 118 186 77 47 77 135 79 183 11 111 30 16 113 149 94 42 178 252 133 224 28 156 106 74 238 215 109 221 233 183 230 53 11 31 79 248 119 225 223 236 251 55 133 110 126 203 125 107 117 102 178 230 75 201 166 1 162 108 118 126 49 94 59 241 11 75 240 14 151 172 24 124 7 173 77 123 14 126 115 36 120 81 254 235 113 159 202 185 104 110 174 60 159 179 253 161 252 189 217 217 184 227 62 184 169 97 233 248 87 171 75 13 58 85 28 156 219 41 43 26 122 26 199 38 169 109 28 146 42 169 153 3 49 232 6 69 123 31 197 239 143 86 119 186 123 248 47 194 17 164 176 24 196 119 23 110 160 130 49 200 80 71 235 94 41 7 69 250 86 214 165 225 157 99 65 179 179 190 213 45 26 40 239 162 50 91 135 234 84 28 103 20 86 163 78 165 72 202 91 173 191 175 144 164 69 7 122 239 254 16 248 139 225 191 135 227 187 155 199 90 47 218 229 224 218 134 143 120 233 200 193 227 243 174 2 14 245 114 206 22 184 153 33 143 239 59 0 51 234 105 85 166 170 67 149 142 71 181 218 254 211 26 30 159 121 13 174 141 224 213 183 178 12 60 194 184 12 23 253 144 188 126 181 201 252 66 248 181 175 124 66 186 242 228 99 111 100 167 247 86 168 220 125 88 247 53 203 106 222 29 214 188 55 121 246 29 106 194 88 36 234 55 175 4 122 131 208 143 165 54 14 139 244 174 72 97 176 240 151 60 86 164 43 34 204 61 63 10 183 7 122 143 69 190 254 205 212 33 190 107 104 166 17 184 99 20 203 149 113 232 69 123 239 135 124 23 240 167 199 222 25 143 90 211 244 27 104 164 153 10 149 18 21 217 38 58 16 166 163 17 136 84 44 228 180 3 196 32 237 248 85 184 122 126 21 171 226 239 135 94 38 240 77 211 46 165 167 183 144 73 242 238 35 249 144 142 220 246 252 107 42 30 159 133 62 104 206 60 201 129 233 127 4 190 33 106 22 122 132 126 15 212 163 251 77 149 209 42 168 237 254 175 35 156 103 183 181 108 252 96 248 95 162 232 58 42 107 222 29 181 216 171 57 251 64 13 145 181 186 99 216 26 242 107 118 101 96 202 216 35 161 21 210 105 255 0 16 60 81 22 151 46 135 54 164 103 181 154 50 173 13 199 204 6 123 140 242 43 134 165 9 42 220 240 118 238 187 138 197 8 122 126 21 114 213 90 70 17 196 24 150 192 0 119 170 112 244 252 43 160 240 21 213 141 159 138 172 110 47 172 204 232 183 11 136 131 99 44 120 92 253 15 53 172 219 81 108 102 135 139 60 23 121 224 247 179 91 198 36 220 219 9 15 179 119 95 194 179 160 239 94 145 241 243 83 211 222 222 203 75 146 213 190 209 183 205 142 85 232 6 112 84 253 107 205 224 239 92 180 39 42 148 148 164 11 83 191 248 18 218 122 248 169 154 226 224 164 230 22 16 167 103 207 81 245 167 124 92 178 210 244 255 0 22 52 122 122 183 153 34 249 151 5 155 63 49 255 0 235 87 31 163 234 23 90 93 244 90 141 148 155 101 133 195 35 47 168 174 226 203 193 126 34 248 157 52 190 46 142 226 218 37 154 66 187 30 67 145 129 143 74 231 156 85 58 222 210 78 202 214 21 181 185 203 65 222 173 91 87 123 161 124 12 85 103 254 220 212 131 2 159 187 251 62 65 13 235 200 172 111 23 124 63 95 9 183 153 30 179 111 50 159 187 23 73 63 42 149 136 165 57 114 166 9 220 238 116 239 16 104 177 252 47 251 116 214 113 109 242 182 52 10 184 15 47 78 158 231 154 243 136 219 115 22 233 147 210 163 143 82 188 109 60 105 126 115 121 2 95 48 39 251 88 198 106 72 122 254 53 148 41 123 59 190 236 18 177 106 221 90 70 10 171 146 120 2 182 117 47 12 235 90 26 199 38 161 102 200 178 140 163 117 28 142 153 172 107 118 104 216 73 27 96 142 65 90 239 252 35 241 9 117 8 215 195 254 40 181 251 68 114 124 139 38 220 159 196 84 85 148 227 178 186 234 13 216 229 32 237 248 85 168 59 215 99 227 15 135 58 125 158 142 111 180 24 91 116 76 90 69 221 156 169 255 0 10 227 160 239 89 198 164 106 171 161 68 238 126 16 219 194 215 243 220 11 172 72 169 143 43 212 30 255 0 133 82 241 149 141 174 159 226 9 161 183 153 159 113 46 249 236 73 206 7 210 178 188 55 172 77 160 234 81 234 16 238 59 126 250 250 131 212 84 183 215 207 170 106 19 106 50 112 101 114 216 244 207 106 197 194 74 171 151 66 71 65 219 240 173 37 210 245 24 237 82 241 173 95 202 127 187 34 242 43 54 14 223 133 118 255 0 14 117 235 27 123 25 180 221 74 100 84 12 10 111 60 115 193 21 53 100 224 174 129 232 115 144 118 252 42 212 29 235 87 198 218 12 150 55 223 218 22 246 232 45 164 232 99 92 0 125 235 42 14 245 156 100 165 27 160 45 39 95 194 183 237 252 55 24 240 233 215 38 184 100 109 223 42 109 224 140 224 86 78 135 166 182 173 122 150 43 32 66 253 24 251 87 85 227 40 228 177 210 109 116 248 87 17 47 12 222 224 112 43 25 201 169 40 160 57 232 59 213 187 118 104 220 72 189 71 34 170 65 222 173 39 95 194 135 168 29 79 136 60 66 179 88 195 101 110 220 200 138 210 159 175 106 200 135 230 198 218 171 7 111 194 181 124 54 170 218 181 186 178 100 23 228 87 59 74 17 1 145 118 171 49 125 229 171 254 34 208 226 177 97 121 104 202 21 219 148 247 246 170 16 244 252 42 83 82 90 1 125 181 43 203 171 116 183 154 102 101 78 155 169 208 118 252 42 180 61 63 10 179 7 111 194 179 105 36 6 174 143 164 205 121 58 52 139 136 186 150 245 171 154 197 244 115 72 182 182 234 187 35 227 62 245 34 106 150 186 109 138 90 175 206 225 0 42 59 31 115 89 106 219 155 119 173 97 171 119 102 101 187 21 86 184 69 97 144 88 3 90 23 218 92 150 109 230 70 55 70 123 250 86 109 171 249 114 172 158 156 214 242 220 54 173 166 190 223 149 215 178 212 205 181 107 1 159 31 122 177 31 122 175 31 122 177 31 122 64 107 105 46 62 203 41 252 191 42 175 23 106 142 222 226 104 85 150 57 48 27 173 91 91 13 182 98 225 164 193 254 237 100 244 122 128 71 212 127 185 86 172 99 243 38 85 31 222 170 177 245 31 238 85 139 121 12 44 26 62 181 47 112 46 93 76 205 39 150 173 192 237 73 31 122 137 93 153 139 55 82 106 88 251 214 109 88 9 225 82 204 21 106 204 118 178 127 23 3 214 160 182 152 71 247 87 159 90 155 237 13 34 250 84 187 244 2 102 141 99 198 214 201 239 75 81 197 218 166 78 191 133 38 172 128 145 58 254 21 42 125 209 73 26 149 93 204 105 202 251 179 89 200 7 167 221 21 42 244 31 74 137 62 232 169 87 160 250 84 129 252 195 255 0 193 66 21 83 192 58 60 104 160 42 206 229 84 14 1 3 0 254 85 242 44 125 232 162 191 169 242 111 247 5 234 206 232 236 79 104 204 146 198 232 196 48 96 65 7 156 230 180 53 221 71 80 213 53 171 139 173 74 250 107 137 119 176 243 39 148 187 96 19 129 147 69 21 232 75 248 139 209 149 212 174 157 127 10 101 226 171 39 204 160 253 69 20 84 214 248 25 50 19 71 68 80 118 160 28 246 21 171 31 122 40 172 40 127 9 14 59 19 69 218 166 139 238 81 69 108 50 196 125 234 104 187 81 69 102 4 201 211 241 171 17 247 162 138 153 25 158 179 251 28 65 4 223 27 116 239 58 20 125 145 74 203 185 65 193 8 112 71 189 88 253 175 238 39 151 227 109 234 75 51 176 75 104 130 6 98 66 140 30 7 165 20 87 143 63 249 26 175 240 130 220 243 72 187 85 136 187 81 69 122 18 3 235 223 216 175 76 211 91 225 103 219 91 79 128 204 215 146 134 148 196 55 16 8 192 206 51 94 200 25 128 92 49 233 235 237 69 21 241 25 151 251 228 253 72 123 159 28 254 210 215 247 247 159 22 175 226 187 189 154 84 141 246 198 178 72 88 32 244 0 244 21 194 67 211 240 162 138 250 108 31 251 164 61 11 91 22 160 237 248 85 136 59 126 20 81 90 61 192 181 23 106 178 157 127 10 40 168 144 22 162 254 181 244 127 236 87 107 107 253 147 169 221 253 154 63 55 204 85 243 118 13 216 244 207 92 81 69 121 185 167 251 156 132 246 56 31 142 26 158 165 127 168 194 151 218 132 243 5 190 185 10 37 148 176 3 43 192 201 174 50 208 3 60 96 142 11 12 143 90 40 165 133 255 0 119 95 63 205 141 108 122 47 197 205 47 76 211 239 173 86 195 78 130 0 214 49 179 8 97 85 201 32 100 240 58 215 26 160 2 48 40 162 170 159 192 128 177 23 106 238 180 107 123 118 248 31 168 92 180 8 100 26 220 32 72 84 110 198 195 198 127 19 249 209 69 101 95 117 234 191 48 57 136 122 254 53 102 14 171 245 162 138 111 112 54 252 31 28 115 120 150 198 25 144 58 53 204 97 145 134 65 4 242 49 94 185 251 85 162 37 206 134 136 128 1 3 0 0 224 15 151 138 40 175 58 191 251 221 63 159 232 76 183 60 162 14 245 110 212 144 80 131 206 225 205 20 86 239 96 145 244 191 196 59 43 59 207 133 209 205 119 105 20 174 150 113 148 105 35 12 84 237 29 9 233 95 62 195 215 241 162 138 242 240 63 194 126 164 150 97 233 248 86 214 139 127 125 109 106 171 109 121 44 96 92 238 1 36 35 4 14 15 29 232 162 183 173 240 129 244 166 144 6 163 224 44 234 3 207 45 101 146 102 249 178 118 245 230 190 116 156 5 185 148 40 192 19 16 0 236 40 162 188 204 6 211 245 2 196 93 170 212 29 191 10 40 174 201 238 5 184 122 126 21 181 225 16 15 136 236 114 63 229 238 63 253 8 81 69 101 63 133 250 1 221 252 126 255 0 145 130 203 254 188 207 254 133 92 76 29 232 162 185 48 255 0 238 241 18 216 185 15 95 198 183 52 189 75 81 181 210 214 43 91 249 227 92 177 219 28 164 12 253 1 162 138 138 251 12 232 254 31 106 186 164 154 133 201 147 82 184 98 44 216 130 102 99 131 235 214 177 175 102 154 123 199 146 121 89 216 183 44 237 146 104 162 185 169 255 0 21 250 19 17 240 244 252 42 220 61 127 26 40 173 30 197 22 97 233 248 85 184 25 145 131 163 16 70 8 32 243 159 90 40 172 222 192 118 222 12 212 181 25 92 69 45 252 204 132 224 171 74 72 35 30 153 172 25 120 187 147 28 124 230 138 43 138 151 196 201 137 52 29 191 10 183 15 79 194 138 43 73 4 139 48 118 252 42 229 191 223 31 133 20 86 82 36 244 93 23 253 35 193 67 237 31 63 200 227 231 231 129 211 173 113 145 118 162 138 228 163 179 245 3 107 193 132 141 126 223 4 143 152 255 0 35 91 30 61 119 58 156 113 151 59 68 121 11 158 51 69 21 148 191 140 189 0 201 131 189 90 78 191 133 20 85 129 98 14 223 133 104 105 108 201 119 27 163 16 65 224 131 69 21 140 182 3 165 241 23 205 162 64 237 201 200 228 245 233 88 176 244 252 40 162 177 165 240 147 18 196 61 63 10 179 7 111 194 138 41 61 138 44 167 221 21 102 62 131 235 69 21 148 137 145 52 29 191 10 215 240 217 62 123 140 241 179 165 20 86 115 248 73 18 228 1 116 224 14 50 120 167 71 222 138 42 86 192 88 78 191 133 106 106 124 64 138 58 122 81 69 98 247 64 65 31 81 254 229 77 31 81 244 162 138 79 112 39 139 181 77 31 122 40 168 144 19 69 218 166 139 167 225 69 21 32 77 23 106 154 219 168 250 81 69 41 108 5 135 235 248 82 167 79 198 138 43 41 1 34 125 209 82 175 65 244 162 138 144 63 255 217) asByteArray! !

!SSFileLibrary class methodsFor: 'accessing' stamp: 'pmm 9/13/2007 06:43'!
logoFileModel
	^MAMemoryFileModel new
		filename: 'logo.jpg';
		mimetype: (self mimetypeFor: 'jpg');
		contents: self default logoJpg! !

!SSFileLibrary class methodsFor: 'accessing' stamp: 'pmm 9/13/2007 06:46'!
logoFileModel: aMAMemoryFileModel
	self default setLogoContents: aMAMemoryFileModel contents! !

!SSFileLibrary methodsFor: 'images' stamp: ''!
bgJpg
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(255 216 255 224 0 16 74 70 73 70 0 1 1 0 0 1 0 1 0 0 255 219 0 67 0 2 1 1 1 1 1 2 1 1 1 2 2 2 2 2 4 3 2 2 2 2 5 4 4 3 4 6 5 6 6 6 5 6 6 6 7 9 8 6 7 9 7 6 6 8 11 8 9 10 10 10 10 10 6 8 11 12 11 10 12 9 10 10 10 255 219 0 67 1 2 2 2 2 2 2 5 3 3 5 10 7 6 7 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 255 192 0 17 8 0 2 3 12 3 1 34 0 2 17 1 3 17 1 255 196 0 31 0 0 1 5 1 1 1 1 1 1 0 0 0 0 0 0 0 0 1 2 3 4 5 6 7 8 9 10 11 255 196 0 181 16 0 2 1 3 3 2 4 3 5 5 4 4 0 0 1 125 1 2 3 0 4 17 5 18 33 49 65 6 19 81 97 7 34 113 20 50 129 145 161 8 35 66 177 193 21 82 209 240 36 51 98 114 130 9 10 22 23 24 25 26 37 38 39 40 41 42 52 53 54 55 56 57 58 67 68 69 70 71 72 73 74 83 84 85 86 87 88 89 90 99 100 101 102 103 104 105 106 115 116 117 118 119 120 121 122 131 132 133 134 135 136 137 138 146 147 148 149 150 151 152 153 154 162 163 164 165 166 167 168 169 170 178 179 180 181 182 183 184 185 186 194 195 196 197 198 199 200 201 202 210 211 212 213 214 215 216 217 218 225 226 227 228 229 230 231 232 233 234 241 242 243 244 245 246 247 248 249 250 255 196 0 31 1 0 3 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 1 2 3 4 5 6 7 8 9 10 11 255 196 0 181 17 0 2 1 2 4 4 3 4 7 5 4 4 0 1 2 119 0 1 2 3 17 4 5 33 49 6 18 65 81 7 97 113 19 34 50 129 8 20 66 145 161 177 193 9 35 51 82 240 21 98 114 209 10 22 36 52 225 37 241 23 24 25 26 38 39 40 41 42 53 54 55 56 57 58 67 68 69 70 71 72 73 74 83 84 85 86 87 88 89 90 99 100 101 102 103 104 105 106 115 116 117 118 119 120 121 122 130 131 132 133 134 135 136 137 138 146 147 148 149 150 151 152 153 154 162 163 164 165 166 167 168 169 170 178 179 180 181 182 183 184 185 186 194 195 196 197 198 199 200 201 202 210 211 212 213 214 215 216 217 218 226 227 228 229 230 231 232 233 234 242 243 244 245 246 247 248 249 250 255 218 0 12 3 1 0 2 17 3 17 0 63 0 253 252 162 138 40 0 162 138 40 0 162 138 40 0 162 138 40 0 162 138 40 0 162 138 40 0 162 138 40 0 162 138 40 0 162 138 40 3 63 196 222 19 240 175 141 52 232 244 127 24 248 103 79 213 173 33 212 45 47 225 181 212 236 146 120 210 234 214 226 59 171 91 128 174 8 18 195 113 12 83 70 227 230 73 34 71 82 25 65 26 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 5 20 81 64 31 255 217) asByteArray ].
	^ cache at: 1! !

!SSFileLibrary methodsFor: 'images' stamp: 'pmm 9/13/2007 06:45'!
logoJpg
	logo isNil ifTrue: [
		logo := self class defaultLogo ].
	^logo! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/18/2007 19:32'!
renderStyleBatchOn: aStream
	aStream nextPutAll: '.batch {'.
	aStream nextPutAll: 		'text-align: center;'.
	aStream nextPutAll: 		'margin-top: 8px;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/14/2007 07:06'!
renderStyleBottomOn: aStream
	aStream nextPutAll: '#bottom {'.
	aStream nextPutAll: 		'padding-left: 5px;'.
	aStream nextPutAll: 		'padding-right: 5px;'.
	aStream nextPutAll: 		'margin: 0px;'.
	aStream nextPutAll: 		'clear: both;'.
	aStream nextPutAll: 		'border-top: 1px solid black;'.
	aStream nextPutAll: 		'background: white;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/14/2007 07:03'!
renderStyleContainerOn: aStream
	aStream nextPutAll: '#container {'.
	aStream nextPutAll: 		'margin: auto;'.
	aStream nextPutAll: 		'width: 780px;'.
	aStream nextPutAll: 		'background: white url('; nextPutAll: (self urlOf: #bgJpg) displayString; nextPutAll: ') repeat-y;'.
	aStream nextPutAll: 		'border: 1px solid black;'.
	aStream nextPutAll: 		'border-top: 5px solid black;'.
	aStream nextPutAll: 		'border-bottom: 5px solid black;'.
	aStream nextPutAll: 		'text-align: left;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/14/2007 07:06'!
renderStyleContentsOn: aStream
	aStream nextPutAll: '#contents {'.
	aStream nextPutAll: 		'width: 610px; height: auto;'.
	aStream nextPutAll: 		'padding: 5px 10px 10px 10px;'.
	aStream nextPutAll: 		'margin: 0px 0px 0px 150px;'.
	aStream nextPutAll: 		'text-align: justify;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: '#contents h1 {'.
	aStream nextPutAll: 		'margin-top: 0px;'.
	aStream nextPutAll: 		'font-size: 20px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '#contents h2 {'.
	aStream nextPutAll: 		'margin-bottom: 5px;'.
	aStream nextPutAll: 		'font-size: 15px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '#contents h3 {'.
	aStream nextPutAll: 		'margin-bottom: 5px;'.
	aStream nextPutAll: 		'font-size: 13px;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: '#contents hr {'.
	aStream nextPutAll: 		'border: none;'.
	aStream nextPutAll: 		'border-bottom: 1px dotted black;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/18/2007 19:50'!
renderStyleHtmlOn: aStream
	aStream nextPutAll: 'body {'.
	aStream nextPutAll:	 	'margin: 0px;'.
	aStream nextPutAll:	 	'padding: 10px;'.
	aStream nextPutAll: 		'border: 0px;'.
	aStream nextPutAll: 		'background: gray;'.
	aStream nextPutAll: 		'text-align: center;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: 'body, div, table, tr, td, th, form input, form submit {'.
	aStream nextPutAll: 		'font-family: Geneva, Arial, Helvetica, sans-serif;'.
	aStream nextPutAll:	 	'font-size: 11px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: 'table, tr, td, th, form {'.
	aStream nextPutAll: 		'margin: 0px;'.
	aStream nextPutAll: 		'padding: 0px;'.
	aStream nextPutAll: 		'border: 0px;'.
	aStream nextPutAll: 		'border-spacing: 0px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: 'th {'.
	aStream nextPutAll: 		'text-align: left;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: 'thead tr td {'.
	aStream nextPutAll: 		'font-weight: bold;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: 'a, a:visited {'.
	aStream nextPutAll: 		'color: '; nextPutAll: self styleColor asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: 		'text-decoration: none;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/14/2007 07:06'!
renderStyleNavigationOn: aStream
	aStream nextPutAll: '#navigation {'.
	aStream nextPutAll: 		'float: left;'.
	aStream nextPutAll: 		'width: 130px;'.
	aStream nextPutAll: 		'padding: 10px;'.
	aStream nextPutAll: 		'padding-top: 0px;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: '#navigation .title {'.
	aStream nextPutAll: 		'margin-top: 11px;'.
	aStream nextPutAll: 		'font-weight: bold;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/14/2007 07:01'!
renderStyleOn: aStream
	self renderStyleHtmlOn: aStream.	
	self renderStyleContainerOn: aStream.
	self renderStyleTopOn: aStream.
	self renderStyleToolbarOn: aStream.
	self renderStylePageOn: aStream.
	self renderStyleNavigationOn: aStream.
	self renderStyleContentsOn: aStream.
	self renderStyleBottomOn: aStream.
	self renderStyleTabPanelOn: aStream.
	self renderStyleBatchOn: aStream.
	self renderStyleTableRowOn: aStream.
	self renderWindowOn: aStream! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/14/2007 07:06'!
renderStylePageOn: aStream
	aStream nextPutAll: '#page {'.
	aStream nextPutAll: 		'padding: 0px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '#page td, #page th {'.
	aStream nextPutAll: 		'padding-right: 5px;'.
	aStream nextPutAll: 		'vertical-align: top;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/16/2007 21:41'!
renderStyleTabPanelOn: aStream
	aStream nextPutAll: '.TabSelected {'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: 		'color: white;'.
	aStream nextPutAll: 		'width: 95px;'.
	aStream nextPutAll: 		'text-align: center;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '.TabUnselected {'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor muchLighter asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: 		'width: 95px;'.
	aStream nextPutAll: 		'text-align: center}'.
			
	aStream nextPutAll: 	'.TabSpacer {'.
	aStream nextPutAll: 		'width: 5px;'.
	aStream nextPutAll: 	'}'.
		
	aStream nextPutAll: 	'.TabLine {'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: '}'! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/16/2007 21:41'!
renderStyleTableRowOn: aStream
	aStream nextPutAll: 'tr.even {'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor veryMuchLighter asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: 'tr.odd {'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '.largeLabel {'.
	aStream nextPutAll:		'width: 120px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '.mediumLabel {'.
	aStream nextPutAll:		'width: 100px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '.smallLabel {'.
	aStream nextPutAll:		'width: 80px;'.
	aStream nextPutAll: '}'.
	
	aStream nextPutAll: '.activityTable {'.
	aStream nextPutAll:		'margin-left: auto;'.
	aStream nextPutAll:		'margin-right: auto;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/16/2007 21:41'!
renderStyleToolbarOn: aStream
	aStream nextPutAll: '#sstoolbar {'.
	aStream nextPutAll: 		'height: 18px;'.
	aStream nextPutAll: 		'border-bottom: 1px solid black;'.
	aStream nextPutAll: 		'background: white;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: '#sstoolbar a {'.
	aStream nextPutAll: 		'padding-left: 10px;'.
	aStream nextPutAll: 		'padding-right: 10px;'.
	aStream nextPutAll: 		'padding-top: 2px;'.
	aStream nextPutAll: 		'padding-bottom: 2px;'.
	aStream nextPutAll: 		'margin-left: -1px;'.
	aStream nextPutAll: 		'border-left: 1px solid black;'.
	aStream nextPutAll: 		'border-right: 1px solid black;'.
  	aStream nextPutAll: 		'line-height: 18px;'.
 	aStream nextPutAll: 		'letter-spacing: 1px;'.
 	aStream nextPutAll: 		'text-decoration: none;'.
	aStream nextPutAll: '}'.

	aStream nextPutAll: '#sstoolbar a:hover {'.
	aStream nextPutAll: 		'color: white;'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/14/2007 07:05'!
renderStyleTopOn: aStream
	aStream nextPutAll: '#top {'.
	aStream nextPutAll: 		'width: 780px; height: 50px;'.
	aStream nextPutAll: 		'background: url(', (self urlOf: #logoJpg) displayString, ') no-repeat;'.
	aStream nextPutAll: 		'border-bottom: 1px solid black;'.
	aStream nextPutAll: 		'font-size: 9px;'.
	aStream nextPutAll: 		'text-align: right;'.
	aStream nextPutAll: '}'.! !

!SSFileLibrary methodsFor: 'css-rendering' stamp: 'pmm 9/16/2007 21:41'!
renderWindowOn: aStream
	
	aStream nextPutAll: '#window-titlebar {'.
	aStream nextPutAll: 		'background-color: '; nextPutAll: self styleColor muchLighter asHTMLColor; nextPutAll: ';'.
	aStream nextPutAll: 		'margin-bottom: 10px;'.
	aStream nextPutAll: 		'width: 100%;'.
	aStream nextPutAll: '}'.
			
	aStream nextPutAll: 	'#window-title {'.
	aStream nextPutAll: 		'text-align: right;'.
	aStream nextPutAll: 		'width: 66%;'.
	aStream nextPutAll: 	'}'.
		
	aStream nextPutAll: 	'#window-close {'.
	aStream nextPutAll: 		'text-align: right;'.
	aStream nextPutAll: '}'! !

!SSFileLibrary methodsFor: 'accessing' stamp: 'pmm 9/14/2007 07:11'!
selectorsToInclude
	^#(stylesheetCss)! !

!SSFileLibrary methodsFor: 'accessing' stamp: 'pmm 9/13/2007 06:46'!
setLogoContents: aByteArray
	logo := aByteArray! !

!SSFileLibrary methodsFor: 'accessing' stamp: 'pmm 9/16/2007 21:41'!
styleColor
	color isNil ifTrue: [ 
		color := self class defaultColor ].
	^color! !

!SSFileLibrary methodsFor: 'accessing' stamp: 'pmm 9/16/2007 21:40'!
styleColor: aColor
	color := aColor! !

!SSFileLibrary methodsFor: 'css' stamp: 'pmm 9/16/2007 21:41'!
stylesheetCss
	style isNil ifTrue: [
		style := String streamContents: [ :stream |
			self renderStyleOn: stream ] ].
	^style! !

WABatchedList subclass: #SSBatchedList
	instanceVariableNames: 'displayedPages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-View-Components'!

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 11:57'!
basicPageRangeEnd
	^ self maxPages
		min: self currentPage + (self displayedPages / 2)! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 11:57'!
basicPageRangeStart
	^ 1 max: self currentPage - (self displayedPages)! !

!SSBatchedList methodsFor: 'accessing' stamp: 'pmm 7/10/2005 11:37'!
displayedPages
	^displayedPages! !

!SSBatchedList methodsFor: 'accessing' stamp: 'pmm 7/10/2005 11:37'!
displayedPages: anInteger
	displayedPages := anInteger! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 7/10/2005 14:55'!
firstPage
	self currentPage: 1! !

!SSBatchedList methodsFor: 'initialize-release' stamp: 'pmm 7/10/2005 14:57'!
initialize
	super initialize.
	self displayedPages: 10! !

!SSBatchedList methodsFor: 'accessing' stamp: 'pmm 7/10/2005 15:04'!
items: aCollection
	super items: aCollection.
	self currentPage: (self maxPages min: self currentPage)! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 7/10/2005 14:56'!
lastPage
	self currentPage: self maxPages! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 15:06'!
maxPages
	^ 1 max: (items size / batchSize) ceiling! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 6/8/2006 07:23'!
nextPage
	self isOnLastPage ifFalse: [
		self currentPage:
			(self maxPages min: self currentPage + 1) ]! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 12:04'!
pageRangeEnd
	| basicStart increment |
	basicStart := self basicPageRangeStart.
	increment := (self displayedPages / 2) + (self currentPage - basicStart).
	^ self maxPages
		min: self currentPage + increment! !

!SSBatchedList methodsFor: 'accessing-calculated' stamp: 'pmm 7/10/2005 12:03'!
pageRangeStart
	| increment basicEnd |
	basicEnd := self basicPageRangeEnd.
	increment := (self displayedPages / 2) + (basicEnd - self currentPage).
	^ 1 max: self currentPage - increment! !

!SSBatchedList methodsFor: 'actions' stamp: 'pmm 6/8/2006 07:23'!
previousPage
	self isOnFirstPage ifFalse: [
		self currentPage: (1 max: currentPage - 1) ]! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:09'!
renderFirstOn: html
	self pageRangeStart = 1 ifFalse: [
		html anchor
			callback: [self currentPage: 1 ];
			with: '1'.
		html space.
		self pageRangeStart = 2 ifFalse: [
			html text: '...'.
			html space ] ]! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:09'!
renderLastOn: html
	self pageRangeEnd = self maxPages ifFalse: [
		html space.
		self pageRangeEnd = (self maxPages - 1) ifFalse: [
			html text: '...'.
			html space ].
		html anchor
			callback: [self currentPage: self maxPages ];
			with: self maxPages.
		html space ].
	! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:10'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [
			html anchor
				title: 'next';
				callback: [ self nextPage ];
				with: [ html text: '>>' ] ]
		ifTrue: [ html text: '>>' ]		! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 7/10/2005 14:34'!
renderPagesOn: html
	self renderFirstOn: html.
	super renderPagesOn: html.
	self renderLastOn: html.! !

!SSBatchedList methodsFor: 'rendering' stamp: 'pmm 8/26/2007 17:11'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ 
			html anchor
				title: 'previous';
				callback: [ self previousPage ];
				with: [ html text: '<<' ] ]
		ifTrue: [ html text: '<<' ].
	html space.! !

WARenderLoopMain subclass: #SSMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Server'!

!SSMain methodsFor: 'request handling' stamp: 'pmm 8/30/2007 09:44'!
start: aRequest

	| accessPath |
	accessPath := (self session relativePathFor: aRequest).
	accessPath size = 1
		ifTrue: [
			| fileName project root |
			fileName := accessPath first.
			(fileName endsWith: '.html')
				ifTrue: [
					"route directly to project home page for <projectName>.html"
					project := self session projectNamed: (fileName copyUpToLast: $.).
					project notNil
						ifTrue: [
							root := self rootClass new.
							root setComponent: project view.
							"copied from WARenderLoopMain>>start:"
							root visiblePresentersDo: [:ea | ea initialRequest: aRequest].
							^(WARenderLoop new root: root) run ] ] ].
	super start: aRequest! !

WASession subclass: #SSSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Server'!

!SSSession methodsFor: 'private' stamp: 'pmm 8/28/2007 12:54'!
authResponseFor: aProject
	^ WAResponse basicAuthWithRealm: aProject title! !

!SSSession methodsFor: 'private' stamp: 'pmm 3/14/2006 23:33'!
authentificateProject: aProject
	self returnResponse: (self authResponseFor: aProject)! !

!SSSession methodsFor: 'actions' stamp: 'pmm 8/26/2007 12:33'!
blessingDeniedFor: aProject
	^ WAResponse new
		status: 500;
		nextPutAll: 'You cannot bless that version.';
		yourself
		
	! !

!SSSession methodsFor: 'accessing' stamp: 'pmm 9/2/2007 14:32'!
charSet
	^ 'iso-8859-1'! !

!SSSession methodsFor: 'testing' stamp: 'pmm 3/16/2006 17:53'!
comesFromRepository: aRequest
	| referer |
	referer := aRequest headerAt: 'referer' ifAbsent: [ ^false ].
	^referer beginsWith: self repository rootUrl
	! !

!SSSession methodsFor: 'request handling' stamp: 'pmm 8/29/2007 10:58'!
createRootFromRequest: aRequest
	"Make a project home page for projectname.html"
	| accessPath frame |
	frame := super createRootFromRequest: aRequest.
	accessPath := self relativePathFor: aRequest.
	accessPath isEmpty ifFalse: [
		(self projectNamed: (accessPath first copyUpToLast: $.))
			ifNotNilDo: [:project | frame setComponent: project view]].
	^ frame! !

!SSSession methodsFor: 'private' stamp: 'pmm 8/27/2007 09:36'!
downloadTypeOfCurrentRequest
	| agent |
	agent := self currentRequest
		headerAt: 'user-agent'
		ifAbsent: [ 'unknown' ].
	^(agent beginsWith: 'Squeak')
		ifTrue: [ #Squeak ]
		ifFalse: [ #Web ]! !

!SSSession methodsFor: 'errors' stamp: 'pmm 8/26/2007 12:51'!
errorNotFound: aString
	self returnResponse: (WAResponse notFound: aString).! !

!SSSession methodsFor: 'errors' stamp: 'bf 12/15/2004 12:31'!
errorPageClass
	(user notNil and: [user isSuperUser])
		ifTrue: [^WAWalkbackPage].
	
	^ super errorPageClass! !

!SSSession methodsFor: 'actions' stamp: 'pmm 8/30/2007 11:01'!
getBlessed: aProject
	| component |
	component := SSBlessedVersionListing session: self project: aProject.
	self returnResponse: component render.! !

!SSSession methodsFor: 'actions' stamp: 'pmm 8/26/2007 12:33'!
getConfig: aConfig
	^ self returnResponse: (WAResponse
		document: (String streamContents: [:strm | aConfig fileOutOn: strm])
		mimeType: 'text/plain')
! !

!SSSession methodsFor: 'actions' stamp: 'pmm 8/26/2007 12:33'!
getDiff: fileName from: aProject
	| verName version diffData |
	verName := MCDiffyVersion verNameFrom: fileName.
	version := aProject versionAt: verName, '.mcz'.
	version ifNil: [ self errorNotFound: fileName ].
	self returnResponse: ((self isAllowed: SSAccessPolicy read for: version in: aProject)
		ifFalse: [ self authResponseFor: aProject ]
		ifTrue: [
			diffData := version getDiff: fileName in: aProject.
			diffData ifNil: [ self errorNotFound: fileName ].
			version increaseDownloadCounterForType: self downloadTypeOfCurrentRequest.
			WAResponse
				document: diffData
				mimeType: MIMEDocument contentTypeMonticello ])! !

!SSSession methodsFor: 'actions' stamp: 'pmm 8/26/2007 12:33'!
getFavicon
	self returnResponse: (WAResponse
		document: self repository favicon
		mimeType: self repository faviconMimeType).! !

!SSSession methodsFor: 'private' stamp: 'pmm 10/7/2007 18:13'!
getFile: aProject
	| fileName |
	fileName := self currentRequest accessPath last.

	"rss feed"
	fileName = 'feed.rss'
		ifTrue: [ ^self getRss: aProject ].

	"robots.txt"
	fileName = 'robots.txt'
		ifTrue: [ ^self getRobotsTxt ].

	aProject configs at: fileName
		ifPresent: [:aConfig | ^ self getConfig: aConfig ].

	fileName = 'blessed' ifTrue: [
		self currentRequest accessPath size > 2
			ifTrue: [ fileName := self currentRequest accessPath third ]
			ifFalse: [^ self getBlessed: aProject ] ].

	"mc diff"
	(fileName endsWith: MCMcdReader extension)
		ifTrue: [^self getDiff: fileName from: aProject].
	
	"mcz"
	self getVersion: fileName from: aProject! !

!SSSession methodsFor: 'actions' stamp: 'pmm 10/8/2006 23:55'!
getListing: aProject
	| component |
	component := SSDirectoryListing
		session: self
		project: aProject
		fakeZips: self isGooglebot.
	self returnResponse: component render.! !

!SSSession methodsFor: 'actions' stamp: 'pmm 8/29/2007 10:59'!
getRequest: aProject
	self expire.
	(self relativePathFor: self currentRequest) size > 1
		ifTrue: [ self getFile: aProject ]
		ifFalse: [ self getListing: aProject ] ! !

!SSSession methodsFor: 'actions' stamp: 'pmm 8/26/2007 12:33'!
getRobotsTxt
	"allow
	http://squeaksource.com/
	http://squeaksource.com/ss
	http://squeaksource.com/ss/
	http://squeaksource.com/ss.html
	http://squeaksource.com/ss/SqueakSource-al.1000.zip

	disallow
	http://squeaksource.com/@EaqkHwcIAYprHJzP/HcYJkifl?10

	attention google is picky about subdomains"
	self returnResponse: (WAResponse
		document:
			'User-agent: *', String crlf ,
			'Disallow: /@*'
		mimeType: MIMEDocument contentTypeTextPlain)! !

!SSSession methodsFor: 'actions' stamp: 'pmm 10/8/2006 23:46'!
getRss
	| component |
	component := SSRssListing session: self projects: self repository visibleProjects.
	self returnResponse: component render.! !

!SSSession methodsFor: 'actions' stamp: 'pmm 3/14/2006 23:10'!
getRss: aProject
	| component |
	component := SSRssListing session: self project: aProject.
	self returnResponse: component render.! !

!SSSession methodsFor: 'actions' stamp: 'pmm 8/26/2007 12:33'!
getSitemapZipped
	self returnResponse: (WAResponse
		document: (SSSiteMapBuilder buildForRepository: self repository)
		mimeType: MIMEDocument contentTypeGZip)! !

!SSSession methodsFor: 'actions' stamp: 'pmm 8/26/2007 12:43'!
getVersion: fileName from: aProject
	| version |
	version := aProject 
		versionAt: fileName
		ifAbsent: [ self errorNotFound: fileName ].
	self returnResponse: ((self isAllowed: SSAccessPolicy read for: version in: aProject)
		ifFalse: [ self authResponseFor: aProject ]
		ifTrue: [ 
			version increaseDownloadCounterForType: self downloadTypeOfCurrentRequest.
			[ WAResponse
				document: (self storage loadMonticello: version from: aProject)
				mimeType: (self mimeTypeFor: fileName) ]
				on: FileDoesNotExistException
				do: [ self errorNotFound: fileName ] ])! !

!SSSession methodsFor: 'request handling' stamp: 'pmm 9/1/2007 14:59'!
handleProject: aSymbol 
	" This method looks-up the project if outside a seaside-session and if successfull initializes a stateless environment with error-handler and escape continuation that can be used similarly while while inside a session. "

	| actionDictionary accessPath project |
	accessPath := (self relativePathFor: self currentRequest).
	project := self
		projectNamed: accessPath first
		ifNotAllowed: [ :pjct | self authentificateProject: pjct ].
	project isNil 
		ifTrue: [ 
			actionDictionary := Dictionary new
				at: 'feed.rss' put: [ self getRss ];
				at: 'sitemap.xml.gz' put: [ self getSitemapZipped ];
				at: 'robots.txt' put: [ self getRobotsTxt ];
				at: self repository faviconFilename put: [ self getFavicon ];
				yourself.
			(actionDictionary
				at: accessPath first
				ifAbsent: [ self errorNotFound: accessPath first ]) value ]
		ifFalse: [ self perform: aSymbol with: project ]! !

!SSSession methodsFor: 'testing' stamp: 'lr 2/2/2004 12:55'!
isAllowed: aSymbol for: aVersion in: aProject
	^aProject isMember: self user allowedTo: aSymbol for: aVersion! !

!SSSession methodsFor: 'testing' stamp: 'pmm 8/1/2006 11:22'!
isAllowed: aSymbol in: aProject
	^aProject isMember: self user allowedTo: aSymbol! !

!SSSession methodsFor: 'testing' stamp: 'pmm 8/27/2007 09:35'!
isGooglebot
	^(self currentRequest headerAt: 'user-agent' ifAbsent: [ '' ])
		includesSubString: 'Googlebot'
	! !

!SSSession methodsFor: 'testing' stamp: 'lr 2/6/2004 18:42'!
isSuperUser
	^self isValidUser
		and: [ self user isSuperUser ]! !

!SSSession methodsFor: 'testing' stamp: 'lr 1/31/2004 18:27'!
isValidUser
	^self user notNil! !

!SSSession methodsFor: 'actions' stamp: 'lr 3/15/2004 17:49'!
login: aMember
	user := aMember! !

!SSSession methodsFor: 'actions' stamp: 'lr 3/15/2004 17:02'!
logout
	isActive := false.
	user := nil.! !

!SSSession methodsFor: 'accessing' stamp: 'dkh 06/06/2007 10:57'!
mainClass
	^ SSMain! !

!SSSession methodsFor: 'private' stamp: 'pmm 10/11/2006 01:32'!
mimeTypeFor: aFilename
	^(aFilename endsWith: '.zip')
		ifTrue: [ "google fake"
			MIMEDocument contentTypeZip ]
		ifFalse: [ MIMEDocument contentTypeMonticello ]! !

!SSSession methodsFor: 'request handling' stamp: 'pmm 9/1/2007 15:03'!
performRequest: aRequest
	" This method is overridden to hock-in requests coming from monticello, it isn't used while being in a seaside session. "

	^aRequest isGet
		ifTrue: [
			(self wantsSessionForRequest: aRequest)
				ifTrue: [ super performRequest: aRequest ]
				ifFalse: [ self handleProject: #getRequest: ] ]
		ifFalse: [
			(self wantsSessionForPutRequest: aRequest)
				ifTrue: [ super performRequest: aRequest ]
				ifFalse: [ self handleProject: #putRequest: ] ]! !

!SSSession methodsFor: 'accessing' stamp: 'pmm 9/5/2007 22:34'!
projectNamed: aString

	^self projectNamed: aString ifNotAllowed: [ nil ]! !

!SSSession methodsFor: 'accessing' stamp: 'pmm 9/5/2007 22:34'!
projectNamed: aString ifNotAllowed: aBlock
	| project |
	project := self repository projectAt: aString ifAbsent: [ ^nil ].
	^(self repository isVisible: project)
			ifTrue: [ project ]
			ifFalse: [ aBlock value: project ]! !

!SSSession methodsFor: 'actions' stamp: 'pmm 10/9/2007 22:55'!
putRequest: aProject
	| author data version response blessed |
	self expire.
	(self isAllowed: SSAccessPolicy write in: aProject)
		ifFalse: [ self authentificateProject: aProject ].
	author := self user ifNil: [ SSMember anonymousMember ].
	self storage log: 'PUT ', self currentRequest url, ' (', author initials, ')'.
	data := self currentRequest at: 'PUTData'.

	(self currentRequest url endsWith: '.mcm')
		ifTrue: [ aProject addConfig: data author: author url: self currentRequest url ]
		ifFalse: [ version := [ aProject addVersion: data author: author ]
			on: SSVersionAlreadyExists
			do: [ :exception |
				self returnResponse: (WAResponse new
					status: 409;
					nextPutAll: 'Version already exists';
					contentType: 'text/plain';
					yourself) ] ].

	(version notNil and: [ (self relativePathFor: self currentRequest ) last = 'blessed'])
		ifTrue: [blessed := true.
				aProject
					blessVersion: version
					ifForbidden: [ blessed := false] ].
	self save.
	response := WAResponse new.
	response status: 201.
	blessed ifNotNil: [
		blessed
			ifTrue: [ response nextPutAll: 'Version blessed' ]
			ifFalse: [ response nextPutAll: 'Version NOT blessed' ] ].
	self returnResponse: response! !

!SSSession methodsFor: 'private' stamp: 'pmm 8/29/2007 10:56'!
relativePathFor: aRequest
	| accessPath |
	accessPath := aRequest accessPath.
	^accessPath
		copyFrom: self baseUrl path size + 1
		to: accessPath size! !

!SSSession methodsFor: 'accessing' stamp: 'lr 1/31/2004 17:24'!
repository
	^SSRepository current
	! !

!SSSession methodsFor: 'responding' stamp: 'pmm 10/4/2007 07:04'!
returnResponse: aResponse
	super returnResponse: aResponse
	"http://www.nextthing.org/archives/2005/08/07/fun-with-http-headers"
	"super returnResponse: (aResponse
		headerAt: 'X-Code-Repository' put: SSRepository current title;
		headerAt: 'X-Smalltalk-Version' put: Smalltalk version;
		yourself)"
		! !

!SSSession methodsFor: 'actions' stamp: 'al 1/17/2006 16:27'!
save
	"self storage saveRepository: self repository."! !

!SSSession methodsFor: 'accessing' stamp: 'lr 1/31/2004 20:18'!
storage
	^SSRepository storage
	! !

!SSSession methodsFor: 'accessing' stamp: 'pmm 8/27/2007 10:41'!
user
	user isNil ifTrue: [ 
		user := self repository 
			authenticateUser: self currentRequest user
			password: self currentRequest password ].
	^user! !

!SSSession methodsFor: 'actions' stamp: 'avi 9/23/2004 23:44'!
verifyBlessingOf: dataString project: aProject
	^ false! !

!SSSession methodsFor: 'request handling' stamp: 'pmm 9/1/2007 15:03'!
wantsSessionForPutRequest: aRequest
	^aRequest fields includesKey: self actionField! !

!SSSession methodsFor: 'request handling' stamp: 'pmm 8/29/2007 10:56'!
wantsSessionForRequest: aRequest
	"We want to start a regular session if the path is empty or a project home page (projectname.html)"
	| accessPath fileName baseName |
	accessPath := self relativePathFor: aRequest.
	
	"first visit, a url without a path"
	accessPath isEmpty ifTrue: [^true].
	
	"project listing"
	accessPath size > 1 ifTrue: [^false].
	
	fileName := accessPath first.
	(fileName endsWith: '.html') ifFalse: [^false].
	baseName := fileName copyUpToLast: $. .
	^ (self projectNamed: baseName) notNil! !

MAObjectTest subclass: #SSConditionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

SSConditionTest subclass: #SSSizeConditionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Magritte'!

!SSSizeConditionTest methodsFor: 'private' stamp: 'pmm 9/2/2007 13:06'!
actualClass
	^ SSSizeCondition! !

!SSSizeConditionTest methodsFor: 'testing' stamp: 'pmm 9/2/2007 13:09'!
testAtLeast
	| collection sizeCondition |
	collection := #(1 2 3) asOrderedCollection.
	sizeCondition := SSSizeCondition atLeast: 4.
	self deny: (sizeCondition value: collection).
	collection add: 4.
	self assert: (sizeCondition value: collection).
	collection add: 5.
	self assert: (sizeCondition value: collection)! !

!SSSizeConditionTest methodsFor: 'testing' stamp: 'pmm 9/2/2007 13:08'!
testAtMost
	| collection sizeCondition |
	collection := #(1 2 3) asOrderedCollection.
	sizeCondition := SSSizeCondition atMost: 4.
	self assert: (sizeCondition value: collection).
	collection add: 4.
	self assert: (sizeCondition value: collection).
	collection add: 5.
	self deny: (sizeCondition value: collection).
	collection add: 6.
	self deny: (sizeCondition value: collection)! !
SSRepository initialize!
